C. 	spline.f
      subroutine spline(y)
************************************************************************
*                                                                      *
*  Precompute the spline coefficients given tabulated functions.       *
*  Revised on Jul 3, 1996:                                             *
*     1) Mnemonic dlt introduced.                                      *
*                                                                      *
************************************************************************
$include grids.h
$include gss32.h
$include apeno.h
$include speed.h
      dimension y(*), u(meqn*mxgrd)
      common /splval/ w(meqn*mxgrd), y2(meqn*mxgrd)
************************************************************************
*     Spline x * parton densities.                                     *
************************************************************************
      do 10 j=0,meqn-1
         do 10 i=1,nxgrd
 10         w(i+j*nxgrd)=x0(i)*y(i+j*nxgrd)
************************************************************************
*     Natural boundary conditions at small x.                          *
************************************************************************
      do 11 j=0,meqn-1
         y2(1+j*nxgrd)=0.
 11      u(1+j*nxgrd)=0.
************************************************************************
*     intermediate vector for spline coefficient calculation.          *
************************************************************************
      do 12 i=2,nxgrd-1
         dlt=hx(i)+hx(i-1)
         sig=hx(i-1)/dlt
         do 12 j=0,meqn-1
            p=sig*y2(i-1+j*nxgrd)+2.
            y2(i+j*nxgrd)=(sig-1.)/p
 12         u(i+j*nxgrd)=(6.*((w(i+1+j*nxgrd)-w(i+j*nxgrd))/hx(i)
     1         -(w(i+j*nxgrd)-w(i-1+j*nxgrd))
     2         /hx(i-1))/dlt-sig*u(i-1+j*nxgrd))/p
************************************************************************
*     First derivative at x=1 is zero.                                 *
************************************************************************
      do 13 j=1,meqn
         un=(3./hx(nxgrd-1))*(w(j*nxgrd-1)-w(j*nxgrd))/hx(nxgrd-1)
 13      y2(j*nxgrd)=(un-0.5*u(j*nxgrd-1))/(0.5*y2(j*nxgrd-1)+1.)
************************************************************************
*     Spline coefficient calculation.                                  *
************************************************************************
      do 14 j=0,meqn-1
         do 14 k=nxgrd-1,1,-1
 14         y2(k+j*nxgrd)=y2(k+j*nxgrd)*y2(k+1+j*nxgrd)+u(k+j*nxgrd)
*
      return
      end
      subroutine splevl(x,kklo,f)
************************************************************************
*                                                                      *
*  Evaluate spline with precomputed coefficients and pointer.          *
*  Revised on Jul 3, 1996:                                             *
*     1) Factors of hh included with definition of a3 and b3.          *
*                                                                      *
************************************************************************
$include grids.h
$include gss32.h
$include apeno.h
$include speed.h
      dimension f(meqn)
      common /splval/ w(meqn*mxgrd), y2(meqn*mxgrd)
*
      khi=kklo+1
*
      h=hx(kklo)
      hh=h*h/6.0
      a=(x0(khi)-x)/h
      a3=hh*a*(a+1)*(a-1)
      b=(x-x0(kklo))/h
      b3=hh*b*(b+1)*(b-1)
*
      do 10 j=0,meqn-1
 10      f(j+1)=(a*w(kklo+j*nxgrd)+b*w(khi+j*nxgrd)
     1      +a3*y2(kklo+j*nxgrd)+b3*y2(khi+j*nxgrd))/x
*
      return
      end
      subroutine splint(x,f)
************************************************************************
*                                                                      *
*  Evaluate spline with precomputed coefficients.                      *
*  Revised on Jul 3, 1996:                                             *
*     1) Factors of hh included with definition of a3 and b3.          *
*     2) klo computed (as in mkindx) on-line, not passed
*                                                                      *
************************************************************************
$include apeno.h
$include grids.h
      dimension f(meqn)
      common /splval/ w(meqn*mxgrd), y2(meqn*mxgrd)
*
      klo=1
      khi=nxgrd
1     if (khi-klo.gt.1) then
         k=(khi+klo)/2
         if (x0(k).gt.x) then
            khi=k
         else
            klo=k
         end if
         go to 1
      end if
*
      h=x0(khi)-x0(klo)
      hh=h*h/6.0
      a=(x0(khi)-x)/h
      a3=hh*a*(a+1)*(a-1)
      b=(x-x0(klo))/h
      b3=hh*b*(b+1)*(b-1)
*
      do 10 j=0,meqn-1
 10      f(j+1)=(a*w(klo+j*nxgrd)+b*w(khi+j*nxgrd)
     1      +a3*y2(klo+j*nxgrd)+b3*y2(khi+j*nxgrd))/x
*
      return
      end
