C. 	minuit.f
      SUBROUTINE MINUIT(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C   
C  CPNAM   Parameter name (10 characters)   
C  U       External (visible to user in FCN) value of parameter 
C  WERR    External parameter error (standard deviation, defined by UP) 
C  ALIM, BLIM Lower and upper parameter limits. If both zero, no limits.    
C  ERP,ERN Positive and negative MINOS errors, if calculated.   
C  NVARL   =-1 if parameter undefined,      =0 if constant, 
C          = 1 if variable without limits,  =4 if variable with limits  
C   (Note that if parameter has been fixed, NVARL=1 or =4, and NIOFEX=0)    
C  NIOFEX  Internal parameter number, or zero if not currently variable 
C  NEXOFI  External parameter number for currently variable parameters  
C  X, XT   Internal parameter values (X are sometimes saved in XT)  
C  DIRIN   (Internal) step sizes for current step   
C  variables with names ending in ..S are saved values for fixed params 
C   
      EXTERNAL FCN,FUTIL    
      CHARACTER*40 CWHYXT   
      DATA CWHYXT/'FOR UNKNOWN REASONS                     '/   
      DATA JSYSRD,JSYSWR,JSYSSA/5,6,7/  
C                                 . . . . . . . . . . initialize minuit 
      WRITE (JSYSWR,'(1X,75(1H*))') 
      CALL MNINIT (JSYSRD,JSYSWR,JSYSSA)    
C                                      . . . . initialize new data block    
  100 CONTINUE  
      WRITE (ISYSWR,'(1X,75(1H*))') 
      NBLOCK = NBLOCK + 1   
      WRITE (ISYSWR,'(26X,A,I4)')  'MINUIT DATA BLOCK NO.',NBLOCK   
      WRITE (ISYSWR,'(1X,75(1H*))') 
C               . . . . . . . . . . .   set parameter lists to undefined    
      CALL MNCLER   
C                                             . . . . . . . . read title    
      CALL MNREAD(FCN,1,IFLGUT,FUTIL)   
      IF (IFLGUT .EQ. 2)  GO TO 500 
      IF (IFLGUT .EQ. 3)  GO TO 600 
C                                        . . . . . . . . read parameters    
      CALL MNREAD(FCN,2,IFLGUT,FUTIL)   
      IF (IFLGUT .EQ. 2)  GO TO 500 
      IF (IFLGUT .EQ. 3)  GO TO 600 
      IF (IFLGUT .EQ. 4)  GO TO 700 
C                              . . . . . . verify FCN not time-dependent    
      WRITE (ISYSWR,'(A,A)') '0MINUIT: FIRST CALL TO USER FUNCTION,',   
     +    ' WITH IFLAG=1'   
      NPARX = NPAR  
      CALL MNINEX(X)    
      FZERO = UNDEFI    
      CALL FCN(NPARX,GIN,FZERO,U,1,FUTIL)   
      FIRST = UNDEFI    
      CALL FCN(NPARX,GIN,FIRST,U,4,FUTIL)   
      NFCN = 2  
      IF (FZERO.EQ.UNDEFI .AND. FIRST.EQ.UNDEFI)  THEN  
          CWHYXT = 'BY ERROR IN USER FUNCTION.  '   
          WRITE (ISYSWR,'(/A,A/)') ' USER HAS NOT CALCULATED FUNCTION', 
     +    ' VALUE WHEN IFLAG=1 OR 4'    
          GO TO 800 
      ENDIF 
      AMIN = FIRST  
      IF (FIRST .EQ. UNDEFI) AMIN=FZERO 
      CALL MNPRIN(1,AMIN)   
      NFCN = 2  
      IF (FIRST .EQ. FZERO)  GO TO 300  
      FNEW = 0.0    
      CALL FCN(NPARX,GIN,FNEW,U,4,FUTIL)    
      IF  (FNEW .NE. AMIN) WRITE (ISYSWR,280) AMIN, FNEW    
  280 FORMAT (/' MINUIT WARNING: PROBABLE ERROR IN USER FUNCTION.'/ 
     +         ' FOR FIXED VALUES OF PARAMETERS, FCN IS TIME-DEPENDENT'/    
     +         ' F =',E22.14,' FOR FIRST CALL'/ 
     +         ' F =',E22.14,' FOR SECOND CALL.'/)  
      NFCN = 3  
  300 FVAL3 = 2.0*AMIN+1.0  
C                                   . . . . . . . . . . . read commands 
      CALL MNREAD(FCN,3,IFLGUT,FUTIL)   
      IF (IFLGUT .EQ. 2)  GO TO 500 
      IF (IFLGUT .EQ. 3)  GO TO 600 
      IF (IFLGUT .EQ. 4)  GO TO 700 
      CWHYXT = 'BY MINUIT COMMAND: '//CWORD 
      IF (INDEX(CWORD,'STOP').GT. 0)  GO TO 800 
      IF (INDEX(CWORD,'EXI') .GT. 0)  GO TO 800 
      IF (INDEX(CWORD,'RET') .EQ. 0)  GO TO 100 
      CWHYXT = 'AND RETURNS TO USER PROGRAM.    '   
      WRITE (ISYSWR,'(A,A)')  ' ..........MINUIT TERMINATED ',CWHYXT    
      RETURN    
C                                           . . . . . . stop conditions 
  500 CONTINUE  
      CWHYXT = 'BY END-OF-DATA ON PRIMARY INPUT FILE.   '   
      GO TO 800 
  600 CONTINUE  
      CWHYXT = 'BY UNRECOVERABLE READ ERROR ON INPUT.   '   
      GO TO 800 
  700 CONTINUE  
      CWHYXT = ': FATAL ERROR IN PARAMETER DEFINITIONS. '   
  800 WRITE (ISYSWR,'(A,A)')  ' ..........MINUIT TERMINATED ',CWHYXT    
      STOP  
C   
C  ......................entry to set unit numbers  - - - - - - - - - - 
      ENTRY MINTIO(I1,I2,I3)    
      JSYSRD = I1   
      JSYSWR = I2   
      JSYSSA = I3   
      RETURN    
      END   
      SUBROUTINE MNAMIN(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called  from many places.  Initializes the value of AMIN by   
CC        calling the user function. Prints out the function value and  
CC        parameter values if Print Flag value is high enough.  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      NPARX = NPAR  
      IF (ISW(5) .GE. 0) WRITE (ISYSWR,'(A,A)') '0FIRST CALL TO USER ', 
     + 'FUNCTION AT NEW START POINT, WITH IFLAG=4.' 
      CALL FCN(NPARX,GIN,FNEW,U,4,FUTIL)    
      NFCN = NFCN + 1   
      AMIN = FNEW   
      IF (ISW(2) .GT. 1)  ISW(2) = ISW(2) - 1   
      RETURN    
      END   
      SUBROUTINE MNBINS(A1,A2,NAA,BL,BH,NB,BWID)    
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
C         SUBROUTINE TO DETERMINE REASONABLE HISTOGRAM INTERVALS    
C         GIVEN ABSOLUTE UPPER AND LOWER BOUNDS  A1 AND A2  
C         AND DESIRED MAXIMUM NUMBER OF BINS NAA    
C         PROGRAM MAKES REASONABLE BINNING FROM BL TO BH OF WIDTH BWID  
C         F. JAMES,   AUGUST, 1974 , stolen for Minuit, 1988    
      AL = MIN(A1,A2)   
      AH = MAX(A1,A2)   
      IF (AL.EQ.AH)  AH = AL + 1.   
C         IF NAA .EQ. -1 , PROGRAM USES BWID INPUT FROM CALLING ROUTINE 
      IF (NAA .EQ. -1)  GO TO 150   
   10 NA = NAA - 1  
      IF (NA .LT. 1)  NA = 1    
C          GET NOMINAL BIN WIDTH IN EXPON FORM  
   20 AWID = (AH-AL)/FLOAT(NA)  
      LOG = INT(LOG10(AWID))    
      IF (AWID .LE. 1.0)  LOG=LOG-1 
      SIGFIG = AWID * (10.00 **(-LOG))  
C         ROUND MANTISSA UP TO 2, 2.5, 5, OR 10 
      IF(SIGFIG .GT. 2.0)  GO TO 40 
      SIGRND = 2.0  
      GO TO 100 
   40 IF (SIGFIG .GT. 2.5)  GO TO 50    
      SIGRND = 2.5  
      GO TO 100 
   50 IF(SIGFIG .GT. 5.0)  GO TO 60 
      SIGRND =5.0   
      GO TO 100 
   60 SIGRND = 1.0  
      LOG = LOG + 1 
  100 CONTINUE  
      BWID = SIGRND*10.0**LOG   
      GO TO 200 
C         GET NEW BOUNDS FROM NEW WIDTH BWID    
  150 IF (BWID .LE. 0.)  GO TO 10   
  200 CONTINUE  
      ALB = AL/BWID 
      LWID=ALB  
      IF (ALB .LT. 0.0)  LWID=LWID-1    
      BL = BWID*FLOAT(LWID) 
      ALB = AH/BWID + 1.0   
      KWID = ALB    
      IF (ALB .LT. 0.0)  KWID=KWID-1    
      BH = BWID*FLOAT(KWID) 
      NB = KWID-LWID    
      IF (NAA .GT. 5)  GO TO 240    
      IF (NAA .EQ. -1)  RETURN  
C          REQUEST FOR ONE BIN IS DIFFICULT CASE    
      IF (NAA .GT. 1 .OR. NB .EQ. 1)  RETURN    
      BWID =  BWID*2.0  
       NB  = 1  
       RETURN   
  240 IF (2*NB .NE. NAA)  RETURN    
      NA = NA + 1   
      GO TO 20  
      END   
      SUBROUTINE MNCALF(FCN,PVEC,YCALF,FUTIL)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called only from MNIMPR.  Transforms the function FCN 
CC        by dividing out the quadratic part in order to find further   
CC        minima.    Calculates  ycalf = (f-fmin)/(x-xmin)*v*(x-xmin)   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION PVEC(15)    
      NPARX = NPAR  
      CALL MNINEX(PVEC) 
      CALL FCN(NPARX,GIN,F,U,4,FUTIL)   
      NFCN = NFCN + 1   
      DO 200 I= 1, NPAR 
      GRD(I) = 0.   
      DO 200 J= 1, NPAR 
  200 GRD(I) = GRD(I) + VT(I,J) * (XT(J)-PVEC(J))   
      DENOM = 0.    
      DO 210 I= 1, NPAR 
  210 DENOM = DENOM + GRD(I) * (XT(I)-PVEC(I))  
      IF (DENOM .LE. 0.)  ISW(2) = 0    
      IF (DENOM .LE. 0.)  DENOM = 1.0   
      YCALF = (F-APSI) / DENOM  
      RETURN    
      END   
      SUBROUTINE MNCLER 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called from MINUIT and by option from MNEXCM  
CC        Resets the parameter list to UNDEFINED    
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      NPFIX = 0 
      NU = 0    
      NPAR = 0  
      DO 10 I= 1, MAXEXT    
      U(I) = 0.0    
      CPNAM(I) = CUNDEF 
      WERR(I) = 0.0 
      NVARL(I) = -1 
   10 NIOFEX(I) = 0 
      CALL MNRSET(1)    
      CFROM = 'CLEAR   '    
      CSTATU = 'UNDEFINED ' 
      RETURN    
      END   
      SUBROUTINE MNCNTR(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       to print function contours in two variables, on line printer   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      PARAMETER (NUMBCS=20,NXMAX=115)   
      DIMENSION CONTUR(NUMBCS), FCNA(NXMAX),FCNB(NXMAX) 
      CHARACTER CLABEL*(NUMBCS) 
      CHARACTER CHLN*(NXMAX),CHMID*(NXMAX),CHZERO*(NXMAX)   
      DATA CLABEL/'0123456789ABCDEFGHIJ'/   
C                 input arguments: parx, pary, devs, ngrid  
      NPARX = NPAR  
      I1 = WORD7(1) 
      I2 = WORD7(2) 
      XSAV = U(I1)  
      YSAV = U(I2)  
      DEVS = WORD7(3)   
      IF (DEVS .LE. 0.)  DEVS=2.    
      XLO = U(I1) - DEVS*WERR(I1)   
      XUP = U(I1) + DEVS*WERR(I1)   
      YLO = U(I2) - DEVS*WERR(I2)   
      YUP = U(I2) + DEVS*WERR(I2)   
      NGRID = WORD7(4)  
      IF (NGRID .LE. 0)  THEN   
          NGRID=25  
          NX = MIN(NPAGWD-15,NGRID) 
          NY = MIN(NPAGLN-7, NGRID) 
      ELSE  
          NX = NGRID    
          NY = NGRID    
      ENDIF 
      IF (NX .LT. 11) NX=11 
      IF (NY .LT. 11) NY=11 
      IF (NX .GE. NXMAX)  NX=NXMAX-1    
C         ask if parameter outside limits   
      IF (NVARL(I1) .GT. 1)  THEN   
         IF (XLO .LT. ALIM(I1))  XLO = ALIM(I1) 
         IF (XUP .GT. BLIM(I1))  XUP = BLIM(I1) 
      ENDIF 
      IF (NVARL(I2) .GT. 1)   THEN  
         IF (YLO .LT. ALIM(I2))  YLO = ALIM(I2) 
         IF (YUP .GT. BLIM(I2))  YUP = BLIM(I2) 
      ENDIF 
      BWIDX = (XUP-XLO)/REAL(NX)    
      BWIDY = (YUP-YLO)/REAL(NY)    
      IXMID = INT((XSAV-XLO)*REAL(NX)/(XUP-XLO)) + 1    
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      DO 185 I= 1, NUMBCS   
      CONTUR(I) = AMIN + UP*FLOAT(I-1)**2   
  185 CONTINUE  
      CONTUR(1) = CONTUR(1) + 0.01*UP   
C                fill FCNB to prepare first row, and find column zero   
      U(I2) = YUP   
      IXZERO = 0    
      XB4 = 1.  
      DO 200 IX= 1, NX+1    
      U(I1) = XLO + REAL(IX-1)*BWIDX    
      CALL FCN(NPARX,GIN,FF,U,4,FUTIL)  
      FCNB(IX) = FF 
      IF (XB4.LT.0. .AND. U(I1).GT.0.)  IXZERO = IX-1   
      XB4 = U(I1)   
      CHMID(IX:IX) = '*'    
      CHZERO(IX:IX)= '-'    
  200 CONTINUE  
      WRITE (ISYSWR,'(A,I3,A,A)') ' Y-AXIS: PARAMETER ',    
     +      I2,': ',CPNAM(I2)   
      IF (IXZERO .GT. 0)  THEN  
         CHZERO(IXZERO:IXZERO) = '+'    
         CHLN = ' ' 
         WRITE (ISYSWR,'(12X,A,A)') CHLN(1:IXZERO),'X=0'    
      ENDIF 
C                 loop over rows    
      DO 280 IY= 1, NY  
      UNEXT = U(I2) - BWIDY 
C                 prepare this line's background pattern for contour    
      CHLN = ' '    
      CHLN(IXMID:IXMID) = '*'   
      IF (IXZERO .NE. 0) CHLN(IXZERO:IXZERO) = ':'  
      IF (U(I2).GT.YSAV .AND. UNEXT.LT.YSAV) CHLN=CHMID 
      IF (U(I2).GT.0. .AND. UNEXT.LT.0.) CHLN=CHZERO    
      U(I2) = UNEXT 
      YLABEL = U(I2) + 0.5*BWIDY    
C                 move FCNB to FCNA and fill FCNB with next row 
      DO 220 IX= 1, NX+1    
      FCNA(IX) = FCNB(IX)   
      U(I1) = XLO + REAL(IX-1)*BWIDX    
      CALL FCN(NPARX,GIN,FF,U,4,FUTIL)  
      FCNB(IX) = FF 
  220 CONTINUE  
C                 look for contours crossing the FCNxy squares  
      DO 250 IX= 1, NX  
      FMX = MAX(FCNA(IX),FCNB(IX),FCNA(IX+1),FCNB(IX+1))    
      FMN = MIN(FCNA(IX),FCNB(IX),FCNA(IX+1),FCNB(IX+1))    
      DO 230 ICS= 1, NUMBCS 
      IF (CONTUR(ICS) .GT. FMN)  GO TO 240  
  230 CONTINUE  
      GO TO 250 
  240 IF (CONTUR(ICS) .LT. FMX) CHLN(IX:IX)=CLABEL(ICS:ICS) 
  250 CONTINUE  
C                 print a row of the contour plot   
      WRITE (ISYSWR,'(1X,G12.4,1X,A)') YLABEL,CHLN(1:NX)    
  280 CONTINUE  
C                 contours printed, label x-axis    
      CHLN = ' '    
      CHLN( 1: 1) = 'I' 
      CHLN(IXMID:IXMID) = 'I'   
      CHLN(NX:NX) = 'I' 
      WRITE (ISYSWR,'(14X,A)') CHLN(1:NX)   
C                the hardest of all: print x-axis scale!    
      CHLN = ' '    
      IF (NX .LE. 26) THEN  
          NL = MAX(NX-12,2) 
          NL2 = NL/2    
          WRITE (ISYSWR,'(8X,G12.4,A,G12.4)') XLO,CHLN(1:NL),XUP    
          WRITE (ISYSWR,'(14X,A,G12.4)')   CHLN(1:NL2),XSAV 
      ELSE  
          NL = MAX(NX-24,2)/2   
          NL2 = NL  
          IF (NL .GT. 10) NL2=NL-6  
          WRITE (ISYSWR,'(8X,G12.4,A,G12.4,A,G12.4)')  XLO, 
     +      CHLN(1:NL),XSAV,CHLN(1:NL2),XUP 
      ENDIF 
      WRITE (ISYSWR,'(6X,A,I3,A,A,A,G12.4)') ' X-AXIS: PARAMETER',  
     +    I1,': ',CPNAM(I1),'  ONE COLUMN=',BWIDX   
      WRITE (ISYSWR,'(A,G12.4,A,G12.4,A)') ' FUNCTION VALUES: F(I)=',   
     +    AMIN,' +',UP,' *I**2' 
C                 finished.  reset input values 
      U(I1) = XSAV  
      U(I2) = YSAV  
      RETURN    
      END   
      SUBROUTINE MNCRCK(CRDBUF,MAXP,COMAND,PLIST,LLIST,IERR,ISYSWR) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC  
CC       Called from MNREAD.    
CC       Cracks the free-format input, expecting zero or more   
CC         alphanumeric fields (which it joins into COMAND) 
CC         followed by one or more numeric fields separated by  
CC         blanks and/or one comma.  The numeric fields are put into    
CC         the LLIST (but at most MAXP) elements of PLIST.  
CC      IERR = 0 if no errors,  
CC           = 1 if error(s).   
CC      Diagnostic messages are written to ISYSWR   
CC  
      PARAMETER (MAXELM=15) 
      CHARACTER*(*) COMAND, CRDBUF  
      CHARACTER CNUMER*13, CELMNT(MAXELM)*15, CNULL*15  
      DIMENSION LELMNT(MAXELM),PLIST(MAXP)  
      DATA CNULL /')NULL STRING   '/    
      DATA CNUMER/'123456789-.0+'/  
      IELMNT = 0    
      LEND = LEN(CRDBUF)    
      NEXTB = 1 
      IERR = 0  
C                                   . . . .  loop over words CELMNT 
   10 CONTINUE  
      DO 100 IPOS= NEXTB,LEND   
         IBEGIN = IPOS  
         IF (CRDBUF(IPOS:IPOS).EQ.' ')  GO TO 100   
         IF (CRDBUF(IPOS:IPOS).EQ.',')  GO TO 250   
         GO TO 150  
  100 CONTINUE  
         GO TO 300  
  150 CONTINUE  
C               found beginning of word, look for end   
         DO 180 IPOS = IBEGIN+1,LEND    
         IF (CRDBUF(IPOS:IPOS).EQ.' ')  GO TO 250   
         IF (CRDBUF(IPOS:IPOS).EQ.',')  GO TO 250   
  180    CONTINUE   
      IPOS = LEND+1 
  250 IEND = IPOS-1 
      IELMNT = IELMNT + 1   
      IF (IEND .GE. IBEGIN) THEN    
         CELMNT(IELMNT) = CRDBUF(IBEGIN:IEND)   
      ELSE  
         CELMNT(IELMNT) = CNULL 
      ENDIF 
      LELMNT(IELMNT) = IEND-IBEGIN+1    
      IF (LELMNT(IELMNT) .GT. 15)  THEN 
         WRITE (ISYSWR, 253) CRDBUF(IBEGIN:IEND),CELMNT(IELMNT) 
  253    FORMAT (' MINUIT WARNING: INPUT ELEMENT EXCEEDS 15 CHARACTERS' 
     +   /'     ORIGINAL:',A    
     +   /' TRUNCATED TO:',A)   
         LELMNT(IELMNT) = 15    
         ENDIF  
      IF (IPOS .GE. LEND) GO TO 300 
      IF (IELMNT .GE. MAXELM)  GO TO 300    
C                     look for comma or beginning of next word  
         DO 280 IPOS= IEND+1,LEND   
         IF (CRDBUF(IPOS:IPOS) .EQ. ' ') GO TO 280  
         NEXTB = IPOS   
         IF (CRDBUF(IPOS:IPOS) .EQ. ',') NEXTB = IPOS+1 
         GO TO 10   
  280    CONTINUE   
C                 All elements found, join the alphabetic ones to   
C                                form a command 
  300 CONTINUE  
      NELMNT = IELMNT   
      COMAND = ' '  
      PLIST(1) = 0. 
      LLIST = 0 
      IF (IELMNT .EQ. 0)  GO TO 900 
      KCMND = 0 
         DO 400 IELMNT = 1, NELMNT  
         IF (CELMNT(IELMNT) .EQ. CNULL)  GO TO 450  
            DO 350 IC= 1, 13    
            IF (CELMNT(IELMNT)(1:1) .EQ. CNUMER(IC:IC)) GO TO 450   
  350       CONTINUE    
         IF (KCMND .GE. 10) GO TO 400   
         LEFT = 10-KCMND    
         LTOADD = LELMNT(IELMNT)    
         IF (LTOADD .GT. LEFT) LTOADD=LEFT  
         COMAND(KCMND+1:KCMND+LTOADD) = CELMNT(IELMNT)(1:LTOADD)    
         KCMND = KCMND + LTOADD 
         IF (KCMND .EQ. 10)  GO TO 400  
         KCMND = KCMND + 1  
         COMAND(KCMND:KCMND) = ' '  
  400    CONTINUE   
      GO TO 900 
  450 CONTINUE  
C                      . . . .  we have come to a numeric field 
      LLIST = 0 
      DO 600 IFLD= IELMNT,NELMNT    
      LLIST = LLIST + 1 
      IF (LLIST .GT. MAXP) THEN 
         NREQ = NELMNT-IELMNT+1 
         WRITE (ISYSWR,511) NREQ,MAXP   
  511 FORMAT (/' MINUIT WARNING IN MNCRCK: '/ ' COMMAND HAS INPUT',I5,  
     + ' NUMERIC FIELDS, BUT MINUIT CAN ACCEPT ONLY',I3)    
         GO TO 900  
      ENDIF 
      IF (CELMNT(IFLD) .EQ. CNULL)  THEN    
          PLIST(LLIST) = 0. 
        ELSE    
          READ (CELMNT(IFLD), '(BN,F15.0)',ERR=575) PLIST(LLIST)    
      ENDIF 
      GO TO 600 
  575 WRITE (ISYSWR,'(A,A,A)') ' FORMAT ERROR IN NUMERIC FIELD: "', 
     + CELMNT(IFLD)(1:LELMNT(IFLD)),'"' 
      IERR = 1  
      PLIST(LLIST) = 0. 
  600 CONTINUE  
C                                  end loop over numeric fields 
  900 RETURN    
      END   
      SUBROUTINE MNDERI(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Calculates the first derivatives of FCN (GRD),    
CC        either by finite differences or by transforming the user- 
CC        supplied derivatives to internal coordinates, 
CC        according to whether ISW(3) is zero or one.   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      LOGICAL LDEBUG    
C          BETA is the factor between EPSMAC and precision in FCN   
      DATA BETA/20./    
      NPARX = NPAR  
      LDEBUG = (IDBG(2) .GE. 1) 
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      IF (ISW(3) .EQ. 1)  GO TO 100 
      IF (LDEBUG) WRITE 
     +   (ISYSWR,'(/''  FIRST DERIVATIVE DEBUG PRINTOUT.  MNDERI''/ 
     +   '' PAR    DERIV     STEP      MINSTEP   OPTSTEP '',    
     +   '' D1-D2    2ND DRV'')')   
      DFMIN = EPSMAC*(ABS(AMIN)+UP) 
C                                loop over variable parameters  
      DO 60  I=1,NPAR   
      EPSPRI = EPSMAC + ABS(GRD(I)*EPSMAC)  
C         two-point derivatives always assumed necessary    
C         maximum number of cycles over step size depends on strategy   
      NCYC = 1 + ISTRAT**2  
      STPMAX = 10.*ABS(GSTEP(I))    
      XTF = X(I)    
      STEPB4 = 0.   
C                               loop as little as possible here!    
      DO 45 ICYC= 1, NCYC   
C                 ........ theoretically best step  
      OPTSTP = SQRT(BETA*DFMIN/(ABS(G2(I))+EPSPRI)) 
C                 ........ averaged with previous step so that step 
C                      cannot decrease by more than a factor of two 
      STEP = 0.5*(OPTSTP+ABS(GSTEP(I))) 
C                 but if parameter has limits, max step size = 0.5  
      IF (GSTEP(I).LT.0.0 .AND. STEP.GT.0.5)  STEP=0.5  
C                 and not more than ten times the previous step 
      IF (STEP .GT. STPMAX)  STEP = STPMAX  
C                 minimum step size allowed by machine precision    
      STPMIN = ABS(BETA*EPSMAC*X(I))    
      IF (STEP .LT. STPMIN)  STEP = STPMIN  
C                 end of iterations if step change less than factor 2   
      IF (ABS((STEP-STEPB4)/STEP) .LT. 0.25)  GO TO 50  
C         take step positive    
      GSTEP(I) = SIGN(STEP, GSTEP(I))   
      STPMAX = 10.0*STEP    
      STEPB4 = STEP 
      X(I) = XTF + STEP 
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FS1,U,4,FUTIL) 
      NFCN=NFCN+1   
C         take step negative    
      X(I) = XTF - STEP 
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FS2,U,4,FUTIL) 
      NFCN=NFCN+1   
      GRBFOR = GRD(I)   
      GRD(I) = (FS1-FS2)/(2.0*STEP) 
      G2(I) = (FS1+FS2-2.0*AMIN)/(STEP**2)  
      X(I) = XTF    
      IF (LDEBUG) THEN  
         D1D2 = (FS1+FS2-2.0*AMIN)/STEP 
         WRITE (ISYSWR,41) I,GRD(I),STEP,STPMIN,OPTSTP,D1D2,G2(I)   
   41    FORMAT (I4,2G11.3,5G10.2)  
      ENDIF 
C         see if another iteration is necessary 
      IF (ABS(GRBFOR-GRD(I))/(ABS(GRD(I))+DFMIN/STEP) .LT. 0.05)    
     +        GO TO 50  
   45 CONTINUE  
C                           end of ICYC loop. too many iterations   
      IF (LREPOR) WRITE (ISYSWR,46)  I, NCYC, STEP, GRD(I), GRBFOR  
   46 FORMAT (' MINUIT EXCEPTIONAL CONDITION IN MNDERI: '/  
     +' FIRST DERIVATIVE OF PARAM',I3,' AFTER',I2,' ITERATIONS, STEP=', 
     +E11.3/' LAST TWO VALUES OF DERIVATIVE WERE ',2E11.3)  
   50 CONTINUE  
C   
   60 CONTINUE  
      CALL MNINEX(X)    
      RETURN    
C                                        .  derivatives calc by fcn 
  100 DO 150 IINT= 1, NPAR  
      IEXT = NEXOFI(IINT)   
      IF (NVARL(IEXT) .GT. 1)  GO TO 120    
      GRD(IINT) = GIN(IEXT) 
      GO TO 150 
  120 DD = (BLIM(IEXT)-ALIM(IEXT))*0.5 *COS(X(IINT))    
      GRD(IINT) = GIN(IEXT)*DD  
  150 CONTINUE  
  200 RETURN    
      END   
      SUBROUTINE MNDXDI(PINT,IPAR,DXDI) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        calculates the transformation factor between external and 
CC        internal parameter values.     this factor is one for 
CC        parameters which are not limited.     called from MNEMAT. 
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      I = NEXOFI(IPAR)  
      DXDI = 1.0    
      IF (NVARL(I) .GT. 1)  
     +      DXDI = 0.5 *ABS((BLIM(I)-ALIM(I)) * COS(PINT))  
      RETURN    
      END   
      SUBROUTINE MNEIG(A,NDIMA,N,MITS,WORK,PRECIS,IFAULT)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
C   
      DIMENSION A(NDIMA,*),WORK(*)  
      DATA ZERO,ONE,TWO/0.0,1.0,2.0/    
      DATA TOL/1.0E-35/ 
C          PRECIS is the machine precision EPSMAC   
      IFAULT = 1    
C   
      I = N 
      DO 70 I1 = 2,N    
      L = I-2   
      F = A(I,I-1)  
      GL = ZERO 
C   
      IF(L .LT. 1) GO TO 25 
C   
      DO 20 K = 1,L 
   20 GL = GL+A(I,K)**2 
   25 H = GL + F**2 
C   
      IF(GL .GT. TOL) GO TO 30  
C   
      WORK(I) = ZERO    
      WORK(N+I) = F 
      GO TO 65  
   30 L = L+1   
C   
      GL = SQRT(H)  
C   
      IF(F .GE. ZERO) GL = -GL  
C   
      WORK(N+I) = GL    
      H = H-F*GL    
      A(I,I-1) = F-GL   
      F = ZERO  
      DO 50 J = 1,L 
      A(J,I) = A(I,J)/H 
      GL = ZERO 
      DO 40 K = 1,J 
   40 GL = GL+A(J,K)*A(I,K) 
C   
      IF(J .GE. L) GO TO 47 
C   
      J1 = J+1  
      DO 45 K = J1,L    
   45 GL = GL+A(K,J)*A(I,K) 
   47 WORK(N+J) = GL/H  
      F = F+GL*A(J,I)   
   50 CONTINUE  
      HH = F/(H+H)  
      DO 60 J = 1,L 
      F = A(I,J)    
      GL = WORK(N+J)-HH*F   
      WORK(N+J) = GL    
      DO 60 K = 1,J 
      A(J,K) = A(J,K)-F*WORK(N+K)-GL*A(I,K) 
   60 CONTINUE  
      WORK(I) = H   
   65 I = I-1   
   70 CONTINUE  
      WORK(1) = ZERO    
      WORK(N+1) = ZERO  
      DO 110 I = 1,N    
      L = I-1   
C   
      IF(WORK(I) .EQ. ZERO .OR. L .EQ. 0) GO TO 100 
C   
      DO 90 J = 1,L 
      GL = ZERO 
      DO 80 K = 1,L 
   80 GL = GL+A(I,K)*A(K,J) 
      DO 90 K = 1,L 
      A(K,J) = A(K,J)-GL*A(K,I) 
   90 CONTINUE  
  100 WORK(I) = A(I,I)  
      A(I,I) = ONE  
C   
      IF(L .EQ. 0) GO TO 110    
C   
      DO 105 J = 1,L    
      A(I,J) = ZERO 
      A(J,I) = ZERO 
  105 CONTINUE  
  110 CONTINUE  
C   
C   
      N1 = N-1  
      DO 130 I = 2,N    
      I0 = N+I-1    
  130 WORK(I0) = WORK(I0+1) 
      WORK(N+N) = ZERO  
      B = ZERO  
      F = ZERO  
      DO 210 L = 1,N    
      J = 0 
      H = PRECIS*(ABS(WORK(L))+ABS(WORK(N+L)))  
C   
      IF(B .LT. H) B = H    
C   
      DO 140 M1 = L,N   
      M = M1    
C   
      IF(ABS(WORK(N+M)) .LE. B) GO TO 150   
C   
  140 CONTINUE  
C   
  150 IF(M .EQ. L) GO TO 205    
C   
  160 IF(J .EQ. MITS) RETURN    
C   
      J = J+1   
      PT = (WORK(L+1)-WORK(L))/(TWO*WORK(N+L))  
      R = SQRT(PT*PT+ONE)   
      PR = PT+R 
C   
      IF(PT .LT. ZERO) PR=PT-R  
C   
      H = WORK(L)-WORK(N+L)/PR  
      DO 170 I=L,N  
  170 WORK(I) = WORK(I)-H   
      F = F+H   
      PT = WORK(M)  
      C = ONE   
      S = ZERO  
      M1 = M-1  
      I = M 
      DO 200 I1 = L,M1  
      J = I 
      I = I-1   
      GL = C*WORK(N+I)  
      H = C*PT  
C   
      IF(ABS(PT) .GE. ABS(WORK(N+I))) GO TO 180 
C   
      C = PT/WORK(N+I)  
      R = SQRT(C*C+ONE) 
      WORK(N+J) = S*WORK(N+I)*R 
      S = ONE/R 
      C = C/R   
      GO TO 190 
  180 C = WORK(N+I)/PT  
      R = SQRT(C*C+ONE) 
      WORK(N+J) = S*PT*R    
      S = C/R   
      C = ONE/R 
  190 PT = C*WORK(I)-S*GL   
      WORK(J) = H+S*(C*GL+S*WORK(I))    
      DO 200 K = 1,N    
      H = A(K,J)    
      A(K,J) = S*A(K,I)+C*H 
      A(K,I) = C*A(K,I)-S*H 
  200 CONTINUE  
      WORK(N+L) = S*PT  
      WORK(L) = C*PT    
C   
      IF(ABS(WORK(N+L)) .GT. B) GO TO 160   
C   
  205 WORK(L) = WORK(L)+F   
  210 CONTINUE  
      DO 240 I=1,N1 
      K = I 
      PT = WORK(I)  
      I1 = I+1  
      DO 220 J = I1,N   
C   
      IF(WORK(J) .GE. PT) GO TO 220 
C   
      K = J 
      PT = WORK(J)  
  220 CONTINUE  
C   
      IF(K .EQ. I) GO TO 240    
C   
      WORK(K) = WORK(I) 
      WORK(I) = PT  
      DO 230 J=1,N  
      PT = A(J,I)   
      A(J,I) = A(J,K)   
      A(J,K) = PT   
  230 CONTINUE  
  240 CONTINUE  
      IFAULT = 0    
C   
      RETURN    
      END   
      SUBROUTINE MNEMAT(EMAT,NDIM)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION EMAT(NDIM,NDIM) 
CC        Calculates the external error matrix from the internal    
CC        to be called by user, who must dimension EMAT at (NDIM,NDIM)  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      IF (ISW(2) .LT. 1)  RETURN    
      IF (ISW(5) .GE. 1)  WRITE (ISYSWR,16)    NDIM,NPAR    
   16 FORMAT (' EXTERNAL ERROR MATRIX CALCULATED BY MNEMAT.    NDIM=',  
     +  I4,'    NPAR=', I3) 
C                    size of matrix to be printed   
      NPARD = NPAR  
      IF (NDIM .LT. NPAR)  THEN 
        NPARD = NDIM    
        IF (ISW(5) .GE. 0) WRITE (ISYSWR,'(A,A)') ' USER-DIMENSIONED ', 
     +      ' ARRAY EMAT NOT BIG ENOUGH. REDUCED MATRIX CALCULATED.'    
      ENDIF 
C                 NPERLN is the number of elements that fit on one line 
      NPERLN = (NPAGWD-5)/10    
      IF (ISW(5).GE. 1 .AND. NPARD.GT.NPERLN)  WRITE (ISYSWR,'(A)') 
     +     ' ELEMENTS ABOVE DIAGONAL ARE NOT PRINTED.'  
C                 I counts the rows of the matrix   
      DO 110 I= 1, NPARD    
         CALL MNDXDI(X(I),I,DXDI)   
         DO 100 J= 1, NPARD 
            CALL MNDXDI(X(J),J,DXDJ)    
            EMAT(I,J) = DXDI * V(I,J) * DXDJ * UP   
  100    CONTINUE   
C                    IZ is number of columns to be printed in row I 
         IF (ISW(5) .GE. 1)  THEN   
            IZ = NPARD  
            IF (NPARD .GE. NPERLN)  IZ = I  
            DO 105 K= 1, IZ, NPERLN 
              K2 = K + NPERLN - 1   
              IF (K2 .GT. IZ)  K2=IZ    
              WRITE (ISYSWR,'(1X,13E10.3)')  (EMAT(I,KK),KK=K,K2)   
  105       CONTINUE    
         ENDIF  
  110 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNERRS(NUMBER,EPLUS,EMINUS,EPARAB,GLOBCC)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC    Called by user, utility routine to get MINOS errors   
CC    If NUMBER is positive, then it is external parameter number,  
CC                  if negative, it is -internal number.    
CC    values returned by MNERRS:    
CC       EPLUS, EMINUS are MINOS errors of parameter NUMBER,    
CC       EPARAB is 'parabolic' error (from error matrix).   
CC                 (Errors not calculated are set = 0.) 
CC       GLOBCC is global correlation coefficient from error matrix 
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C   
      IEX = NUMBER  
      IF (NUMBER .LT. 0)  THEN  
         IIN = -NUMBER  
         IF (IIN .GT. NPAR)  GO TO 900  
         IEX = NEXOFI(IIN)  
      ENDIF 
      IF (IEX .GT. NU .OR. IEX .LE. 0)  GO TO 900   
      IIN = NIOFEX(IEX) 
      IF (IIN .LE. 0)  GO TO 900    
C             IEX is external number of a currently variable parameter  
      EPLUS = ERP(IEX)  
      EMINUS= ERN(IEX)  
      CALL MNDXDI(X(IIN),IIN,DXDI)  
      EPARAB = ABS(DXDI*SQRT(ABS(UP*V(IIN,IIN))))   
C              global correlation coefficient   
      GLOBCC = 0.   
      IF (ISW(2) .LT. 2)  GO TO 990 
      GLOBCC = -1.  
      DO 130 I= 1, NPAR 
      DO 130 J= 1, NPAR 
  130 P(I,J) = V(I,J)   
      CALL MNVERT(P,MAXINT,MAXINT,NPAR,IERR)    
      IF (IERR .GT. 0)     GO TO 990    
      DENOM = P(IIN,IIN)*V(IIN,IIN) 
      IF (DENOM .LT. 1.0)  GO TO 990    
      GLOBCC = 0.   
      IF (DENOM .EQ. 1.0)  GO TO 990    
      GLOBCC = SQRT(1.0-1.0/DENOM)  
      GO TO 990 
C                  ERROR.  parameter number not valid   
  900 EPLUS = 0.    
      EMINUS = 0.   
      EPARAB = 0.   
      GLOBCC = 0.   
  990 RETURN    
      END   
      SUBROUTINE MNEXCM(FCN,COMAND,PLIST,LLIST,IERFLG,FUTIL)    
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Interprets a command and takes appropriate action,    
CC        either directly by skipping to the corresponding code in  
CC        MNEXCM, or by setting up a call to a subroutine   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      CHARACTER*(*) COMAND  
C Unfortunately, cannot say DIMENSION PLIST(LLIST) since LLIST can be =0.   
      DIMENSION PLIST(*)    
      CHARACTER*10 CNAME(40), CNEWAY    
C  recognized MINUIT commands:  
      DATA CNAME( 1) / 'MINImize  ' /   
      DATA CNAME( 2) / 'SEEk      ' /   
      DATA CNAME( 3) / 'SIMplex   ' /   
      DATA CNAME( 4) / 'MIGrad    ' /   
      DATA CNAME( 5) / 'MINOs     ' /   
      DATA CNAME( 6) / 'SET xxx   ' /   
      DATA CNAME( 7) / 'SHOw xxx  ' /   
      DATA CNAME( 8) / 'TOP of pag' /   
      DATA CNAME( 9) / 'FIX       ' /   
      DATA CNAME(10) / 'REStore   ' /   
      DATA CNAME(11) / 'RELease   ' /   
      DATA CNAME(12) / 'SCAn      ' /   
      DATA CNAME(13) / 'CONtour   ' /   
      DATA CNAME(14) / 'HESse     ' /   
      DATA CNAME(15) / 'SAVe      ' /   
      DATA CNAME(16) / 'IMProve   ' /   
      DATA CNAME(17) / 'CALl fcn  ' /   
      DATA CNAME(18) / 'STAndard  ' /   
      DATA CNAME(19) / 'END       ' /   
      DATA CNAME(20) / 'EXIt      ' /   
      DATA CNAME(21) / 'RETurn    ' /   
      DATA CNAME(22) / 'CLEar     ' /   
      DATA CNAME(23) / 'HELP      ' /   
      DATA CNAME(24) / '          ' /   
      DATA CNAME(25) / 'STOp      ' /   
       DATA NNAME/25/   
      DATA CNAME(26) / '          ' /   
      DATA CNAME(27) / '          ' /   
      DATA CNAME(28) / '          ' /   
      DATA CNAME(29) / '          ' /   
      DATA CNAME(30) / '          ' /   
      DATA CNAME(31) / '          ' /   
      DATA CNAME(32) / '          ' /   
      DATA CNAME(33) / '          ' /   
C  obsolete commands:   
      DATA CNAME(34) / 'COVARIANCE' /   
      DATA CNAME(35) / 'PRINTOUT  ' /   
      DATA CNAME(36) / 'GRADIENT  ' /   
      DATA CNAME(37) / 'MATOUT    ' /   
      DATA CNAME(38) / 'ERROR DEF ' /   
      DATA CNAME(39) / 'LIMITS    ' /   
      DATA CNAME(40) / 'PUNCH     ' /   
      DATA NNTOT/40/    
C   
      CWORD = COMAND    
      DO 20 IW= 1, 7    
      WORD7(IW) = 0.    
      IF (IW .LE. LLIST) WORD7(IW) = PLIST(IW)  
   20 CONTINUE  
      ICOMND = ICOMND + 1   
      IF (CWORD(1:7).NE.'SET PRI' .OR. WORD7(1).GE.0.)  THEN    
        IF (ISW(5) .GE. 0) THEN 
         WRITE (ISYSWR,25) ICOMND,CWORD,(PLIST(I),I=1,LLIST)    
   25    FORMAT (1H ,10(1H*)/' ***',I3,' ***',A,7G13.5/21X,7G13.5)  
         WRITE (ISYSWR, '(1H ,10(1H*))' )   
        ENDIF   
      ENDIF 
      NFCNMX = WORD7(1) 
      IF (NFCNMX .LE. 0)  NFCNMX = 200 + 100*NPAR + 10*NPAR**2  
      EPSI = WORD7(2)   
      IF (EPSI .LE. 0.)  EPSI = 0.1 * UP    
      LNEWMN = .FALSE.  
      ISW(1) = 0    
      IERFLG = 0    
C                look for command in list CNAME . . . . . . . . . . 
      DO 80 I= 1, NNTOT 
      IF (CWORD(1:3) .EQ. CNAME(I)(1:3))  GO TO 90  
   80 CONTINUE  
      WRITE (ISYSWR,'(10X,''UNKNOWN COMMAND IGNORED:'',A)') COMAND  
      IERFLG = 2    
      GO TO 5000    
C                normal case: recognized MINUIT command . . . . . . .   
   90 CONTINUE  
      IF (CWORD(1:4) .EQ. 'MINO') GO TO 500 
C              1    2    3    4    5    6    7    8    9   10   
      GO TO ( 400, 200, 300, 400, 500, 700, 700, 800, 900,1000, 
     1       1100,1200,1300,1400,1500,1600,1700,1800,1900,1900, 
     2       1900,2200,2300,2400,1900,2400,2400,2400,2400,2400, 
     3       2400,2400,2400,3400,3500,3600,3700,3800,3900,4000) , I 
C                                        . . . . . . . . . . seek   
  200 CALL MNSEEK(FCN,FUTIL)    
      GO TO 5000    
C                                        . . . . . . . . . . simplex    
  300 CALL MNSIMP(FCN,FUTIL)    
      GO TO 5000    
C                                        . . . . . . migrad, minimize   
  400 NF = NFCN 
      APSI = EPSI   
      CALL MNMIGR(FCN,FUTIL)    
      IF (ISW(2) .GE. 2)  GO TO 5000    
      IF (ISW(1) .EQ. 1)  GO TO 5000    
      NFCNMX = NFCNMX + NF - NFCN   
      NF = NFCN 
      CALL MNSIMP(FCN,FUTIL)    
      IF (ISW(1) .EQ. 1)  GO TO 5000    
      NFCNMX = NFCNMX + NF - NFCN   
      CALL MNMIGR(FCN,FUTIL)    
      GO TO 5000    
C                                        . . . . . . . . . . minos  
  500 CONTINUE  
      NSUPER = NFCN + 2*(NPAR+1)*NFCNMX 
C          possible loop over new minima    
  510 CONTINUE  
      IF (ISW(2) .LT. 3)  CALL MNHESS(FCN,FUTIL)    
      IF (ISW(2) .LT. 2)  THEN  
        WRITE (ISYSWR,'(/A/A/)')    
     +    '      THE MINOS COMMAND CANNOT BE EXECUTED BECAUSE', 
     +    '      CALCULATION OF COVARIANCE MATRIX WAS UNSUCCESSFUL.'    
        IERFLG = 1  
        CALL MNRSET(0)  
        GO TO 5000  
        ENDIF   
      EPSI = 0.1 * UP   
      CALL MNMNOS(FCN,FUTIL)    
      IF (.NOT. LNEWMN)  GO TO 5000 
      CALL MNMIGR(FCN,FUTIL)    
      IF (NFCN .LT. NSUPER)  GO TO 510  
      WRITE (ISYSWR,'(/'' TOO MANY FUNCTION CALLS. MINOS GIVES UP''/)') 
      IERFLG = 1    
      CALL MNRSET(0)    
      GO TO 5000    
C                                        . . . . . . . . . .set, show   
  700 CALL MNSET(FCN,FUTIL) 
      GO TO 5000    
C                                        . . . . . . . . . . top of page    
  800 CONTINUE  
      WRITE (ISYSWR,'(1H1)')    
      GO TO 5000    
C                                        . . . . . . . . . . fix    
  900 IEXT = WORD7(1)   
      IF (IEXT .GT. NU)  GO TO 1350 
      IINT = NIOFEX(IEXT)   
      IF (IINT .EQ. 0)  GO TO 1350  
      CALL MNFIXP(IINT) 
      CALL MNRSET(0)    
      IF (ISW(5) .GT. 0)  CALL MNPRIN(5,AMIN)   
      GO TO 5000    
C                                        . . . . . . . . . . restore    
 1000 IT = WORD7(1) 
      CALL MNFREE(IT)   
      CALL MNRSET(0)    
      GO TO 5000    
C                                        . . . . . . . . . . release    
 1100 CONTINUE  
      IF (WORD7(1) .EQ. 0)  THEN    
         WRITE (ISYSWR,'(A)') ' NO PARAMETERS REQUESTED FOR RELEASE'    
         GO TO 5000 
      ENDIF 
      DO 1120 IRL=1,7   
      KRL = WORD7(IRL)  
      IF (KRL .EQ. 0)  GO TO 1130   
      KRL = -IABS(KRL)  
      CALL MNFREE(KRL)  
 1120 CONTINUE  
 1130 CALL MNRSET(0)    
      GO TO 5000    
C                                       . . . . . . . . . . scan . . .  
 1200 CONTINUE  
      IT = WORD7(1) 
      IF (IT .LE. 0)  GO TO 1210    
      IT2 = 0   
      IF (IT .LE. NU)  IT2 = NIOFEX(IT) 
      IF (IT2 .LE. 0)  GO TO 1350   
 1210 CALL MNSCAN(FCN,FUTIL)    
      GO TO 5000    
C                                        . . . . . . . . . . contour    
 1300 CONTINUE  
      IF (ISW(2) .LT. 1)  CALL MNHESS(FCN,FUTIL)    
      KE1 = WORD7(1)    
      KE2 = WORD7(2)    
      IF (KE1.LE.0 .OR. KE2.LE.0)  GO TO 1350   
      IF (KE1.GT.NU .OR. KE2.GT.NU)  GO TO 1350 
      IF (NIOFEX(KE1).LE.0 .OR. NIOFEX(KE2).LE.0)  GO TO 1350   
      NFCNMX = 1000 
      CALL MNCNTR(FCN,FUTIL)    
      GO TO 5000    
C   
 1350 WRITE (ISYSWR,1351)   
 1351 FORMAT (50H ILLEGAL PARAMETER NUMBER REQUESTED.  IGNORED.    /)   
      IERFLG = 1    
      GO TO 5000    
C                                        . . . . . . . . . . hesse  
 1400 CONTINUE  
      CALL MNHESS(FCN,FUTIL)    
      IF (ISW(5) .GE. 0)  THEN  
        CALL MNPRIN(2, AMIN)    
        CALL MNMATU(1)  
      ENDIF 
      GO TO 5000    
C                                        . . . . . . . . . . save   
 1500 CONTINUE  
      CALL MNSAVE   
      GO TO 5000    
C                                        . . . . . . . . . . improve    
 1600 CONTINUE  
      IF (ISW(2) .LT. 2)  CALL MNMIGR(FCN,FUTIL)    
      CALL MNIMPR(FCN,FUTIL)    
      IF (LNEWMN)  GO TO 400    
      GO TO 5000    
C                                        . . . . . . . . . . call fcn   
 1700 IFLAG = WORD7(1)  
      NPARX = NPAR  
      F = UNDEFI    
      CALL FCN(NPARX,GIN,F,U,IFLAG,FUTIL)   
      NFCN = NFCN + 1   
      NOWPRT = 0    
      IF (F .NE. UNDEFI)  THEN  
         IF (AMIN .EQ. UNDEFI)  THEN    
             AMIN = F   
             NOWPRT = 1 
         ELSE IF (F .LT. AMIN)  THEN    
             AMIN = F   
             NOWPRT = 1 
         ENDIF  
         IF (ISW(5).GE.0 .AND. IFLAG.LE.5 .AND. NOWPRT.EQ.1)    
     +          CALL MNPRIN(5,AMIN) 
         IF (IFLAG .EQ. 3)  FVAL3=F 
      ENDIF 
      IF (IFLAG .GT. 5)  CALL MNRSET(1) 
      GO TO 5000    
C                                        . . . . . . . . . . standard   
 1800 CALL STAND    
      GO TO 5000    
C                                        . . . . . . . stop, end, exit  
 1900 IT = PLIST(1) 
      IF (FVAL3 .EQ. AMIN .OR. IT .GT. 0)  GO TO 5000   
      IFLAG = 3 
      WRITE (ISYSWR,'(A/)') '0CALL TO USER FUNCTION WITH IFLAG = 3' 
      NPARX = NPAR  
      CALL FCN(NPARX,GIN,F,U,IFLAG,FUTIL)   
      NFCN = NFCN + 1   
      GO TO 5000    
C                                        . . . . . . . . . . clear  
 2200 CONTINUE  
      CALL MNCLER   
      IF (ISW(5) .GE. 1)  WRITE (ISYSWR,'(A)')  
     +         ' NO PARAMETERS CURRENTLY DEFINED'   
      GO TO 5000    
C                                        . . . . . . . . . . help   
 2300 CONTINUE  
      IF (INDEX(CWORD,'SHO') .GT. 0)  GO TO 700 
      IF (INDEX(CWORD,'SET') .GT. 0)  GO TO 700 
      WRITE (ISYSWR,2301)  (CNAME(I),I=1,NNAME) 
 2301 FORMAT (' THE COMMANDS RECOGNIZED BY MINUIT ARE:'/6(2X,A10))  
      GO TO 5000    
C                                        . . . . . . . . . . blank line 
 2400 CONTINUE  
      GO TO 5000    
C  . . . . . . . . obsolete commands     . . . . . . . . . . . . . . . .    
C                                        . . . . . . . . . . covariance 
 3400 CONTINUE  
      WRITE (ISYSWR, '(A)') ' THE "COVARIANCE" COMMAND IS OSBSOLETE.',  
     + ' THE COVARIANCE MATRIX IS NOW SAVED IN A DIFFERENT FORMAT', 
     + ' WITH THE "SAVE" COMMAND AND READ IN WITH:"SET COVARIANCE"' 
      GO TO 5000    
C                                        . . . . . . . . . . printout   
 3500 CONTINUE  
      CNEWAY = 'SET PRInt ' 
      GO TO 3100    
C                                        . . . . . . . . . . gradient   
 3600 CONTINUE  
      CNEWAY = 'SET GRAd  ' 
      GO TO 3100    
C                                        . . . . . . . . . . matout 
 3700 CONTINUE  
      CNEWAY = 'SHOW COVar' 
      GO TO 3100    
C                                        . . . . . . . . . . error def  
 3800 CONTINUE  
      CNEWAY = 'SET ERRdef' 
      GO TO 3100    
C                                        . . . . . . . . . . limits 
 3900 CONTINUE  
      CNEWAY = 'SET LIMits' 
      GO TO 3100    
C                                        . . . . . . . . . . punch  
 4000 CONTINUE  
      CNEWAY = 'SAVE      ' 
C                                ....... come from obsolete commands <--    
 3100 WRITE (ISYSWR, 3101) CWORD,CNEWAY 
 3101 FORMAT (' OBSOLETE COMMAND:',1X,A10,5X,'PLEASE USE:',1X,A10)  
      CWORD = CNEWAY    
      IF (CWORD .EQ. 'SAVE      ') GO TO 1500   
      GO TO 700 
C                                 . . . . . . . . . . . . . . . . . . . 
 5000 RETURN    
      END   
      SUBROUTINE MNEXIN(PINT)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Transforms the external parameter values U to internal    
CC        values in the dense array PINT. Subroutine MNPINT is used.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION PINT(*) 
      LIMSET = .FALSE.  
      DO 100  IINT= 1, NPAR 
      IEXT = NEXOFI(IINT)   
      CALL MNPINT(U(IEXT),IEXT,PINTI)   
      PINT(IINT) = PINTI    
  100 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNFIXP(IINT)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        removes parameter IINT from the internal (variable) parameter 
CC        list, and arranges the rest of the list to fill the hole. 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION V1(2) ,YY(MNI)  
      EQUIVALENCE (V(1,1) , V1(1))  
C                           reduce number of variable parameters by one 
      IEXT = NEXOFI(IINT)   
      NIOFEX(IEXT) = 0  
      NPAR = NPAR - 1   
C                       save values in case parameter is later restored 
      NPFIX = NPFIX + 1 
      IPFIX(NPFIX) = IEXT   
      LC = IINT 
      XS(NPFIX) = X(LC) 
      XTS(NPFIX) = XT(LC)   
      DIRINS(NPFIX) = DIRIN(LC) 
      GRDS(NPFIX) = GRD(LC) 
      G2S(NPFIX) = G2(LC)   
      GSTEPS(NPFIX) = GSTEP(LC) 
C                        shift values for other parameters to fill hole 
      DO 100  IK= IEXT+1, NU    
         IF  (NIOFEX(IK) .GT. 0)  THEN  
         LC = NIOFEX(IK) - 1    
         NIOFEX(IK) = LC    
         NEXOFI(LC) = IK    
         X(LC) = X(LC+1)    
         XT(LC) = XT(LC+1)  
         DIRIN(LC) = DIRIN(LC+1)    
         GRD(LC) = GRD(LC+1)    
         G2(LC) = G2(LC+1)  
         GSTEP(LC) = GSTEP(LC+1)    
         ENDIF  
  100 CONTINUE  
      IF (ISW(2) .GT. 1)  GO TO 250 
      ISW(2) = 0    
      GO TO 300 
C                    remove one row and one column from variance matrix 
  250 KON = 0   
      IF (NPAR .LE. 0)  GO TO 300   
      KON2 = 0  
      MPAR = NPAR + 1   
      DO 260 I= 1, MPAR 
  260 YY(I)=V(I,IINT)   
      DO 294 I= 1, MPAR 
      IF (I.EQ.IINT)  GO TO 294 
      KON2 = KON2 + 1   
      DO 292 J= 1, MPAR 
      IF (J .EQ. IINT)  GO TO 292   
      KON = KON + 1 
      V1(KON)=V(J,I) - YY(J)*YY(I)/YY(IINT) 
  292 CONTINUE  
      KON = MAXINT*KON2 
  294 CONTINUE  
  300 RETURN    
      END   
      SUBROUTINE MNFREE(K)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Restores one or more fixed parameter(s) to variable status    
CC        by inserting it into the internal parameter list at the   
CC        appropriate place.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C--       K = 0 means restore all parameters    
C--       K = 1 means restore the last parameter fixed  
C--       K = -I means restore external parameter I (if possible)   
C--       IQ = fix-location where internal parameters were stored   
C--       IR = external number of parameter being restored  
C--       IS = internal number of parameter being restored  
      IF (K .GT. 1)  WRITE (ISYSWR,510) 
      IF (NPFIX .LT. 1)  WRITE (ISYSWR,500) 
      IF (K.EQ.1 .OR. K.EQ.0)  GO TO 40 
C                   release parameter with specified external number    
      KA = IABS(K)  
      IF (NIOFEX(KA) .EQ. 0)  GO TO 15  
      WRITE (ISYSWR,540)    
  540 FORMAT (49H0ERROR.  PARAMETER SPECIFIED IS ALREADY VARIABLE. /)   
      RETURN    
   15 IF (NPFIX .LT. 1)  GO TO 21   
      DO 20 IK= 1, NPFIX    
      IF (IPFIX(IK) .EQ. KA)  GO TO 24  
   20 CONTINUE  
   21 WRITE (ISYSWR,530)    
  530 FORMAT ('0ERROR.  PARAMETER SPECIFIED HAS NEVER BEEN VARIABLE.'/  
     +   ' TO MAKE IT VARIABLE, USE THE COMMAND:   PARAMETER '/)    
      RETURN    
   24 IF (IK .EQ. NPFIX)  GO TO 40  
C                   move specified parameter to end of list 
      IPSAV = KA    
      XV = XS(IK)   
      XTV = XTS(IK) 
      DIRINV = DIRINS(IK)   
      GRDV = GRDS(IK)   
      G2V = G2S(IK) 
      GSTEPV = GSTEPS(IK)   
      DO 30 I= IK+1,NPFIX   
      IPFIX(I-1) = IPFIX(I) 
      XS(I-1) = XS(I)   
      XTS(I-1) = XTS(I) 
      DIRINS(I-1) = DIRINS(I)   
      GRDS(I-1) = GRDS(I)   
      G2S(I-1) = G2S(I) 
      GSTEPS(I-1) = GSTEPS(I)   
   30 CONTINUE  
      IPFIX(NPFIX) = IPSAV  
      XS(NPFIX) = XV    
      XTS(NPFIX) = XTV  
      DIRINS(NPFIX) = DIRINV    
      GRDS(NPFIX) = GRDV    
      G2S(NPFIX) = G2V  
      GSTEPS(NPFIX) = GSTEPV    
C                restore last parameter in fixed list  -- IPFIX(NPFIX)  
   40 CONTINUE  
      IF (NPFIX .LT. 1)  GO TO 300  
      IR = IPFIX(NPFIX) 
      IS = 0    
      DO 100 IK= NU, IR, -1 
        IF (NIOFEX(IK) .GT. 0) THEN 
         LC = NIOFEX(IK) + 1    
         IS = LC - 1    
         NIOFEX(IK) = LC    
         NEXOFI(LC) = IK    
         X(LC) = X(LC-1)    
         XT(LC) = XT(LC-1)  
         DIRIN(LC) = DIRIN(LC-1)    
         GRD(LC) = GRD(LC-1)    
         G2(LC) = G2(LC-1)  
         GSTEP(LC) = GSTEP(LC-1)    
        ENDIF   
  100 CONTINUE  
      NPAR = NPAR + 1   
      IF (IS .EQ. 0)   IS = NPAR    
      NIOFEX(IR) = IS   
      NEXOFI(IS) = IR   
      IQ = NPFIX    
      X(IS) = XS(IQ)    
      XT(IS) = XTS(IQ)  
      DIRIN(IS) = DIRINS(IQ)    
      GRD(IS) = GRDS(IQ)    
      G2(IS) = G2S(IQ)  
      GSTEP(IS) = GSTEPS(IQ)    
      NPFIX = NPFIX - 1 
      ISW(2) = 0    
      IF (ITAUR .LT. 1)  WRITE(ISYSWR,520) IR,CPNAM(IR) 
      IF (K.EQ.0)  GO TO 40 
  300 RETURN    
  500 FORMAT (  61H0ERROR IN CALL TO MNFREE.  THERE ARE NO MORE FIXED PA    
     1RAMETERS/)    
  510 FORMAT (52H0ERROR IN CALL TO MNFREE.  ARGUMENT GREATER THAN ONE/) 
  520 FORMAT (20X, 9HPARAMETER,I4,2H, ,A10, 22H RESTORED TO VARIABLE. ) 
      END   
      SUBROUTINE MNGRAD(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       Called from MNSET  
CC       Interprets the SET GRAD command, which informs MINUIT whether  
CC       the first derivatives of FCN will be calculated by the user    
CC       inside FCN.  It can check the user's derivative calculation    
CC       by comparing it with a finite difference approximation.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C   
      EXTERNAL FCN,FUTIL    
      CHARACTER*4 CGOOD,CBAD,CNONE,CWD  
      LOGICAL LNONE 
      DIMENSION GF(MNI) 
      PARAMETER (CGOOD='GOOD',CBAD=' BAD',CNONE='NONE') 
C   
      ISW(3) = 1    
      NPARX = NPAR  
      IF (WORD7(1) .GT. 0.0)  GO TO 2000    
C                  get user-calculated first derivatives from FCN   
      DO 30 I= 1, NU    
   30 GIN(I) = UNDEFI   
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FZERO,U,2,FUTIL)   
      NFCN = NFCN + 1   
      CALL MNDERI(FCN,FUTIL)    
      DO 40 I= 1, NPAR  
   40 GF(I) = GRD(I)    
C                    get MINUIT-calculated first derivatives    
      ISW(3) = 0    
      CALL MNHES1(FCN,FUTIL)    
      WRITE (ISYSWR,51) 
   51 FORMAT ('0CHECK OF GRADIENT CALCULATION IN FCN'/12X,'PARAMETER',  
     + 6X,9HG(IN FCN) ,3X,9HG(MINUIT) ,2X,'DG(MINUIT)',3X,9HAGREEMENT)  
      ISW(3) = 1    
      LNONE = .FALSE.   
      DO 100 LC = 1, NPAR   
      I = NEXOFI(LC)    
      CWD = CGOOD   
      ERR = DGRD(LC)    
      IF (ABS(GF(LC)-GRD(LC)) .GT. ERR)  CWD = CBAD 
      IF (GIN(I) .EQ. UNDEFI)  THEN 
          CWD = CNONE   
          LNONE = .TRUE.    
          GF(LC) = 0.   
          ENDIF 
      IF (CWD .NE. CGOOD)  ISW(3) = 0   
      WRITE (ISYSWR,99) I,CPNAM(I),GF(LC),GRD(LC),ERR,CWD   
   99 FORMAT (7X,I5,2X ,A10,3E12.4,4X ,A4)  
  100 CONTINUE  
      IF (LNONE) WRITE (ISYSWR,'(A)')   
     +  '  AGREEMENT=NONE  MEANS FCN DID NOT CALCULATE THE DERIVATIVE'  
      IF (ISW(3) .EQ. 0)  WRITE (ISYSWR,1003)   
 1003 FORMAT ('0MINUIT DOES NOT ACCEPT DERIVATIVE CALCULATIONS BY FCN'/ 
     + ' TO FORCE ACCEPTANCE, ENTER "SET GRAD    1"'/)  
C   
 2000 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNHESS(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Calculates the full second-derivative matrix of FCN   
CC        by taking finite differences. When calculating diagonal   
CC        elements, it may iterate so that step size is nearly that 
CC        which gives function change= UP/10. The first derivatives 
CC        of course come as a free side effect, but with a smaller  
CC        step size in order to obtain a known accuracy.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION YY(MNI) 
      LOGICAL LDEBUG    
C   
      LDEBUG = (IDBG(3) .GE. 1) 
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      NCYC = 3+ISTRAT   
      IF (ISW(5).GE.2 .OR. LDEBUG)  WRITE (ISYSWR,5)    
    5 FORMAT (37H START COVARIANCE MATRIX CALCULATION. )    
      CFROM = 'HESSE   '    
      CSTATU= 'OK        '  
      NPARD = NPAR  
      IF (LDEBUG) WRITE (ISYSWR,7)  
    7 FORMAT (' PAR D   GSTEP           D          G2         GRD    ', 
     +'    SAG    ')    
C                                        . . . . . . diagonal elements .    
C         ISW(2) = 1 if diag approx, 2 if posdef approx, 3 if ok    
C         AIMSAG is the sagitta we are aiming for in second deriv calc. 
      AIMSAG = 0.1*UP   
C         loop over variable parameters for second derivatives  
      DLAST = 0.    
      DO 100 ID= 1, NPARD   
      I = ID + NPAR - NPARD 
      IF (G2(I).EQ.0. .AND. LREPOR) WRITE (ISYSWR,8) I  
    8    FORMAT (/' MINUIT EXCEPTIONAL CONDITION IN MNHESS: ',  
     +       'G2(',I3,')=0. ON ENTERING.'/) 
      IDRV = 2  
      XTF = X(I)    
      DMIN = 10.*EPSMAC*ABS(XTF)    
C                               find step which gives sagitta = AIMSAG  
      DO 15 ICYC= 1, NCYC   
      DINV = SQRT(0.5*ABS(G2(I)/AIMSAG))    
C                               avoid step size zero or infinite    
      IF (DINV .EQ. 0.) DINV = GRD(I)/UP    
      IF (DINV .EQ. 0.) THEN    
         D = ABS(GSTEP(I)) + ABS(DIRIN(I))  
      ELSE  
         D = 1.0/DINV   
      ENDIF 
C         if parameter has limits, max int step size = 0.5  
      STPINM = 0.5  
      IF (GSTEP(I) .LT. 0.)  D = MIN(D,STPINM)  
      IF (D .LT. DMIN)  D = DMIN    
C           see if converged    
      IF (ICYC .GT. 1)  THEN    
         IF (ABS((D-DLAST)/D) .LT. 0.5)  GO TO 19   
         D = MIN(D, 10.*DLAST)  
         D = MAX(D, 0.1*DLAST)  
      ENDIF 
      DLAST = D 
C           take two steps  
      X(I) = XTF + D    
      CALL MNINEX(X)    
      NPARX = NPAR  
      CALL FCN(NPARX,GIN,FS1,U,4,FUTIL) 
      NFCN = NFCN + 1   
      X(I) = XTF - D    
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FS2,U,4,FUTIL) 
      NFCN = NFCN + 1   
      X(I) = XTF    
      SAG = 0.5*(FS1+FS2-2.0*AMIN)  
      G2(I) = 2.*SAG/D**2   
      GRD(I) = (FS1-FS2)/(2.*D) 
    
      IF (LDEBUG) WRITE (ISYSWR,11) I,IDRV,GSTEP(I),D,G2(I),GRD(I),SAG  
   11 FORMAT (I4,I2,6G12.5) 
      GSTEP(I) = SIGN(D,GSTEP(I))   
      DIRIN(I) = D  
      YY(I) = FS1   
   15 CONTINUE  
C                       end of step size loop   
      IF (LREPOR) WRITE (ISYSWR, 16) I,SAG,AIMSAG,GSTEP(I)  
   16 FORMAT (/' MINUIT EXCEPTIONAL CONDITION IN MNHESS:'/  
     +  '        PAR.',I3,', SAG=',E10.3,', AIMSAG=',E10.3,', STEP=',   
     +  E10.3)  
C   
   19 CONTINUE  
      DO 20 J= 1, NPAR  
   20 V(I,J) = 0.   
      V(I,I) = G2(I)    
  100 CONTINUE  
C                              end of diagonal second derivative loop   
      CALL MNINEX(X)    
C                          refine the first derivatives 
      CALL MNHES1(FCN,FUTIL)    
      ISW(2) = 3    
C                                        . . . .  off-diagonal elements 
      IF (NPAR .EQ. 1)  GO TO 214   
      NPARM1 = NPAR - 1 
      DO 200 I= 1, NPARM1   
      IP1 = I + 1   
      DO 180 J= IP1, NPAR   
      XTI = X(I)    
      XTJ = X(J)    
      X(I) = XTI + DIRIN(I) 
      X(J) = XTJ + DIRIN(J) 
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FS1,U,4,FUTIL) 
      NFCN = NFCN + 1   
      X(I) = XTI    
      X(J) = XTJ    
      ELEM = (FS1+AMIN-YY(I)-YY(J)) / (DIRIN(I)*DIRIN(J))   
  170 V(I,J) = ELEM 
      V(J,I) = ELEM 
  180 CONTINUE  
  200 CONTINUE  
  214 CALL MNINEX(X)    
C                  verify matrix positive-definite  
      CALL MNPSDF   
      CALL MNVERT(V,MAXINT,MAXINT,NPAR,IFAIL)   
      IF (IFAIL .GT. 0)  GO TO 390  
C                                        . . . . . . .  calculate  e d m    
      DO 225 I= 1, NPAR 
      DO 225 J= 1, NPAR 
  225 V(I,J) = 2.0 * V(I,J) 
      EDM = 0.  
      DO 250 I= 1, NPAR 
      R = 0.    
      DO 240 J= 1, NPAR 
  240 R = R + V(I,J) * GRD(J)   
  250 EDM = EDM + 0.5 *R *GRD(I)    
      GO TO 400 
  390 ISW(2) = 0    
      IF (ISW(5) .GT. 0) WRITE (ISYSWR,'(A)') ' MATRIX INVERSION FAILS' 
      CSTATU = 'FAILED    ' 
      IF (ISW(5) .GE. 0) WRITE (ISYSWR,391) 
  391 FORMAT (42H MNHESS FAILS AND WILL RETURN UNIT MATRIX. )   
      DO 395 I= 1, NPAR 
      DO 394 J= 1, NPAR 
  394 V(I,J) = 0.0  
  395 V(I,I) = 1.0  
  400 IF (ISW(5).GE.1 .AND. ISW(2).EQ.3 .AND. ITAUR.EQ.0)   
     + WRITE(ISYSWR,'(A)')' COVARIANCE MATRIX CALCULATED SUCCESSFULLY'  
      RETURN    
      END   
      SUBROUTINE MNHES1(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC      Called from MNHESS and MNGRAD   
CC      Calculate first derivatives (GRD) and uncertainties (DGRD)  
CC         and appropriate step sizes GSTEP 
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      LOGICAL LDEBUG    
      LDEBUG = (IDBG(5) .GE. 1) 
      NCYC = 4 + 2*ISTRAT   
      IDRV = 1  
      NPARX = NPAR  
C                                     main loop over parameters 
      DO 100 I= 1, NPAR 
      XTF = X(I)    
      DMIN = 10.*EPSMAC*ABS(XTF)    
      D = 0.5 * ABS(DIRIN(I))   
      IF (D .LT. 10.*DMIN)  D = 100.*DMIN   
C                                       iterate reducing step size  
      DO 50 ICYC= 1, NCYC   
      X(I) = XTF + D    
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FS1,U,4,FUTIL) 
      NFCN = NFCN + 1   
      X(I) = XTF - D    
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FS2,U,4,FUTIL) 
      NFCN = NFCN + 1   
      X(I) = XTF    
C                                        check if step sizes appropriate    
      SAG = 0.5*(FS1+FS2-2.0*AMIN)  
      GRDOLD = GRD(I)   
      GRDNEW = (FS1-FS2)/(2.0*D)    
      DGMIN = EPSMAC*(ABS(FS1)+ABS(FS2))/D  
      IF (LDEBUG) WRITE (ISYSWR,11) I,IDRV,GSTEP(I),D,G2(I),GRDNEW,SAG  
   11 FORMAT (I4,I2,6G12.5) 
      IF (GRDNEW .EQ. 0.)  GO TO 60 
      GRD(I) = GRDNEW   
      GSTEP(I) = SIGN(D,GSTEP(I))   
C                  decrease step until first derivative changes by <5%  
      IF (ABS((GRDOLD-GRDNEW)/GRDNEW) .LT. 0.05) GO TO 60   
      IF (ABS(GRDOLD-GRDNEW) .LT. DGMIN)  GO TO 60  
      IF (D .LT. DMIN)  THEN    
         IF (LREPOR) WRITE (ISYSWR, 49) I,GSTEP(I),GRDOLD,GRDNEW    
   49    FORMAT (/' MINUIT EXCEPTIONAL CONDITION IN MNHES1:'/   
     +     ' TOO SMALL STEP SIZE IN FIRST DERIV NO.',I3,', STEP=',G10.3,    
     +     '    DERIV=',2G12.4/)    
         GO TO 60   
      ENDIF 
      D = 0.2*D 
   50 CONTINUE  
C                                        loop satisfied = too many iter 
      IF (LREPOR) WRITE (ISYSWR, 51) I,GSTEP(I),GRDOLD,GRDNEW   
   51 FORMAT (/' MINUIT EXCEPTIONAL CONDITION IN MNHESS:'/  
     +  ' TOO MANY ITERATIONS ON FIRST DERIV NO.',I3,', STEP=',G10.3,   
     +  '    DERIV=',2G12.4/)   
   60 CONTINUE  
      DGRD(I) = MAX(DGMIN,ABS(GRDOLD-GRDNEW))   
  100 CONTINUE  
C                                        end of first deriv. loop   
      RETURN    
      END   
       SUBROUTINE MNIMPR(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Attempts to improve on a good local minimum by finding a  
CC        better one.   The quadratic part of FCN is removed by MNCALF  
CC        and this transformed function is minimized using the simplex  
CC        method from several random starting points.   
CC        ref. -- Goldstein and Price, Math.Comp. 25, 569 (1971)    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION DSAV(MNI), Y(MNI1) 
      PARAMETER (ALPHA=1.,BETA=0.5,GAMMA=2.0)   
      DATA RNUM/0./ 
      IF (NPAR .LE. 0)  RETURN  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      CFROM = 'IMPROVE '    
      CSTATU = 'UNCHANGED ' 
      ITAUR = 1 
      EPSI = 0.1*UP 
      NPFN=NFCN 
      NLOOP = WORD7(2)  
      IF (NLOOP .LE. 0)  NLOOP = NPAR + 4   
      NPARX = NPAR  
      NPARP1=NPAR+1 
      WG = 1.0/FLOAT(NPAR)  
      SIGSAV = EDM  
      APSI = AMIN   
      DO 2 I= 1, NPAR   
      XT(I) = X(I)  
      DSAV(I) = SQRT(V(I,I)*UP) 
      DO 2 J= 1, NPAR   
    2 VT(I,J) = V(I,J)  
      CALL MNVERT(VT,MAXINT,MAXINT,NPAR,IFAIL)  
      IF (IFAIL .GE. 1)  GO TO 280  
      LOOP = 0  
    3 DO 4 I= 1, NPAR   
      DIRIN(I) = 2.0*DSAV(I)    
    4 CALL MNRN15(RNUM,ISEED)   
      X(I) = XT(I) + 2.0*DIRIN(I)*(RNUM-0.5)    
      LOOP = LOOP + 1   
      REG = 2.0 
      IF (ISW(5) .GE. 0)   WRITE (ISYSWR, 1040) LOOP    
    5 CALL  MNCALF(FCN,X,YCALF,FUTIL)   
      AMIN = YCALF  
C                                        . . . . set up  random simplex 
      JL = NPARP1   
      JH = NPARP1   
      Y(NPARP1) = AMIN  
      AMAX = AMIN   
      DO 15 I= 1, NPAR  
      XI = X(I) 
      CALL MNRN15(RNUM,ISEED)   
      X(I) = XI - DIRIN(I) *(RNUM-0.5)  
      CALL MNCALF(FCN,X,YCALF,FUTIL)    
      Y(I) = YCALF  
      IF (Y(I) .GE. AMIN)  GO TO 7  
      AMIN = Y(I)   
      JL = I    
    7 IF (Y(I) .LE. AMAX)  GO TO 8  
      AMAX = Y(I)   
      JH = I    
    8 CONTINUE  
      DO 10 J= 1, NPAR  
   10 P(J,I) = X(J) 
      P(I,NPARP1) = XI  
   15 X(I) = XI 
      EDM = AMIN    
      SIG2 = EDM    
C                                        . . . . . . .  start main loop 
   50 CONTINUE  
      IF (AMIN .LT. 0.)  GO TO 95   
      IF (ISW(2) .LT. 2)  GO TO 280 
      EP = 0.1*AMIN 
      IF (SIG2 .LT. EP   .AND. EDM.LT.EP  )     GO TO 100   
      SIG2 = EDM    
      IF ((NFCN-NPFN) .GT. NFCNMX)  GO TO 300   
C         calculate new point * by reflection   
      DO 60 I= 1, NPAR  
      PB = 0.   
      DO 59 J= 1, NPARP1    
   59 PB = PB + WG * P(I,J) 
      PBAR(I) = PB - WG * P(I,JH)   
   60 PSTAR(I)=(1.+ALPHA)*PBAR(I)-ALPHA*P(I,JH) 
      CALL MNCALF(FCN,PSTAR,YCALF,FUTIL)    
      YSTAR = YCALF 
      IF(YSTAR.GE.AMIN) GO TO 70    
C         point * better than jl, calculate new point **    
      DO 61 I=1,NPAR    
   61 PSTST(I)=GAMMA*PSTAR(I)+(1.-GAMMA)*PBAR(I)    
      CALL MNCALF(FCN,PSTST,YCALF,FUTIL)    
      YSTST = YCALF 
   66 IF (YSTST .LT. Y(JL))  GO TO 67   
      CALL MNRAZZ(YSTAR,PSTAR,Y,JH,JL)  
      GO TO 50  
   67 CALL MNRAZZ(YSTST,PSTST,Y,JH,JL)  
      GO TO 50  
C         point * is not as good as jl  
   70 IF (YSTAR .GE. Y(JH))  GO TO 73   
      JHOLD = JH    
      CALL MNRAZZ(YSTAR,PSTAR,Y,JH,JL)  
      IF (JHOLD .NE. JH)  GO TO 50  
C         calculate new point **    
   73 DO 74 I=1,NPAR    
   74 PSTST(I)=BETA*P(I,JH)+(1.-BETA)*PBAR(I)   
      CALL MNCALF(FCN,PSTST,YCALF,FUTIL)    
      YSTST = YCALF 
      IF(YSTST.GT.Y(JH)) GO TO 5    
C     point ** is better than jh    
      IF (YSTST .LT. AMIN)  GO TO 67    
      CALL MNRAZZ(YSTST,PSTST,Y,JH,JL)  
      GO TO 50  
C                                        . . . . . .  end main loop 
   95 IF (ISW(5) .GE. 0)  WRITE (ISYSWR,1000)   
      REG = 0.1 
C                                        . . . . . ask if point is new  
  100 CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,AMIN,U,4,FUTIL)    
      NFCN = NFCN + 1   
      DO 120 I= 1, NPAR 
      DIRIN(I) = REG*DSAV(I)    
      IF (ABS(X(I)-XT(I)) .GT. DIRIN(I)) GO TO 150  
  120 CONTINUE  
      GO TO 230 
  150 NFCNMX = NFCNMX + NPFN - NFCN 
      NPFN = NFCN   
      CALL MNSIMP(FCN,FUTIL)    
      IF (AMIN .GE. APSI)  GO TO 325    
      DO 220 I= 1, NPAR 
      DIRIN(I) = 0.1 *DSAV(I)   
      IF (ABS(X(I)-XT(I)) .GT. DIRIN(I)) GO TO 250  
  220 CONTINUE  
  230 IF (AMIN .LT. APSI)  GO TO 350    
      GO TO 325 
C                                        . . . . . . truly new minimum  
  250 LNEWMN = .TRUE.   
      ISW(2) = 0    
      ITAUR = 0 
      NFCNMX = NFCNMX + NPFN - NFCN 
      CSTATU = 'NEW MINIMU' 
      CFROM = 'IMPROVE '    
      IF (ISW(5) .GE. 0)      WRITE (ISYSWR,1030)   
      RETURN    
C                                        . . . return to previous region    
  280 IF (ISW(5) .GT. 0) WRITE (ISYSWR,1020)    
      ISW(2) = 0    
      GO TO 325 
  300 ISW(1) = 1    
  325 DO 330 I= 1, NPAR 
      DIRIN(I) = 0.01*DSAV(I)   
  330 X(I) = XT(I)  
      AMIN = APSI   
      EDM = SIGSAV  
  350 CALL MNINEX(X)    
      IF (ISW(5) .GT. 0)    WRITE (ISYSWR,1010) 
      CFROM = 'IMPROVE '    
      CSTATU= 'UNCHANGED '  
      CALL MNRSET(0)    
      IF (ISW(2) .LT. 2)  GO TO 380 
      IF (LOOP .LT. NLOOP .AND. ISW(1) .LT. 1)  GO TO 3 
      ISW(2) = 3    
  380 CALL MNPRIN (5,AMIN)  
      ITAUR = 0 
      RETURN    
 1000 FORMAT (54H AN IMPROVEMENT ON THE PREVIOUS MINIMUM HAS BEEN FOUND)    
 1010 FORMAT (51H IMPROVE HAS RETURNED TO REGION OF ORIGINAL MINIMUM)   
 1020 FORMAT (44H0COVARIANCE MATRIX WAS NOT POSITIVE-DEFINITE)  
 1030 FORMAT (38H0IMPROVE HAS FOUND A TRULY NEW MINIMUM/1H ,37(1H*)/)   
 1040 FORMAT (18H0START ATTEMPT NO.,I2,  20H TO FIND NEW MINIMUM)   
      END   
      SUBROUTINE MNINEX(PINT)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Transforms from internal coordinates (PINT) to external   
CC        parameters (U).   The minimizing routines which work in   
CC        internal coordinates call this routine before calling FCN.    
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION PINT(*) 
      DO 100 J= 1, NPAR 
      I = NEXOFI(J) 
      IF (NVARL(I) .EQ. 1) THEN 
         U(I) = PINT(J) 
      ELSE  
         U(I) = ALIM(I) + 0.5*(SIN(PINT(J)) +1.0) * (BLIM(I)-ALIM(I))   
      ENDIF 
  100 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNINIT (I1,I2,I3)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        This is the main initialization subroutine for MINUIT 
CC     It initializes some constants in common  
CC                (including the logical I/O unit nos.),    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C   
      CHARACTER*50 CXTITL   
      PARAMETER ( CXTITL = ')  MINUIT TITLE UNDEFINED  ')   
C      EXTERNAL INTRAC   
C      LOGICAL INTRAC    
      ISYSRD = I1   
      ISYSWR = I2   
        ISTKWR(1) = ISYSWR  
        NSTKWR = 1  
      ISYSSA = I3   
      NSTKRD = 0    
      NSTKWR = 0    
C               version identifier  
      CVRSN = '89.05b'  
      CTITL = CXTITL    
      MAXINT=MNI    
      MAXEXT=MNE    
      NBLOCK = 0    
      ICOMND = 0    
      UNDEFI = -54321.  
      CUNDEF = ')UNDEFINED' 
      CFROM = 'INPUT   '    
      CSTATU= 'INITIAL   '  
      ISW(3) = 0    
      ISW(4) = 0    
      ISW(5) = 1    
C         ISW(6)=0 for batch jobs,  =1 for interactive jobs 
      ISW(6) = 0    
C      IF (INTRAC(DUMMY))  ISW(6) = 1    
C        DEBUG options set to default values    
      DO 10 IDB= 0, MAXDBG  
   10 IDBG(IDB) = 0 
      LREPOR = .FALSE.  
      LWARN  = .TRUE.   
      LIMSET = .FALSE.  
      LNEWMN = .FALSE.  
      ISTRAT = 1    
      ITAUR = 0 
C        default page dimensions and 'new page' carriage control integer    
      NPAGWD = 120  
      NPAGLN = 56   
      NEWPAG = 1    
      IF (ISW(6) .GT. 0) THEN   
         NPAGWD = 80    
         NPAGLN = 30    
         NEWPAG = 0 
      ENDIF 
C                   determine machine accuracy epsmac   
      UP = 1.0  
      EPSMAC = 0.5  
      DO 33 I= 1, 100   
      EPSMAC = EPSMAC * 0.5 
      IF ((1.0+EPSMAC) .EQ. 1.0)  GO TO 35  
   33 CONTINUE  
      EPSMAC = 1.0E-6   
   35 EPSMAC = 2.0 * EPSMAC 
C                 the vlims are a non-negligeable distance from pi/2    
C         used by MNPINT to set variables "near" the physical limits    
      PIBY2 = 2.0*ATAN(1.0) 
      DISTNN = 8.0*SQRT(EPSMAC) 
      VLIMHI =  PIBY2 - DISTNN  
      VLIMLO = -PIBY2 + DISTNN  
      NFCN = 0  
      CALL MNCLER   
      WRITE (ISYSWR,'(3A,I3,A,I3,A,E10.2)')  '  MINUIT RELEASE ',CVRSN, 
     +' INITIALIZED.   DIMENSIONS ',MNE,'/',MNI,'  EPSMAC=',EPSMAC  
      RETURN    
      END   
      SUBROUTINE MNINTR(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       Called by user. Interfaces to MNREAD to allow user to change   
CC       easily from Fortran-callable to interactive mode.  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      IFLGIN = 3    
      CALL MNREAD(FCN,IFLGIN,IFLGUT,FUTIL)  
      WRITE (ISYSWR,'(2A/)')  ' END OF MINUIT COMMAND INPUT. ', 
     +      '   RETURN TO USER PROGRAM.'    
      RETURN    
      END   
      SUBROUTINE MNLIMS(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       Called from MNSET  
CC       Interprets the SET LIM command, to reset the parameter limits  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
C   
      CFROM = 'SET LIM '    
      CSTATU= 'NO CHANGE '  
      I2 = WORD7(1) 
      IF (I2 .GT. MAXEXT .OR. I2 .LT. 0)  GO TO 900 
      IF (I2 .GT. 0)  GO TO 30  
C                                     set limits on all parameters  
      NEWCOD = 4    
      IF (WORD7(2) .EQ. WORD7(3))  NEWCOD = 1   
      DO 20 INU= 1, NU  
      IF (NVARL(INU) .LE. 0)  GO TO 20  
      IF (NVARL(INU).EQ.1 .AND. NEWCOD.EQ.1)  GO TO 20  
      NINT = NIOFEX(INU)    
C             see if parameter has been fixed   
      IF (NINT .LE. 0)  THEN    
         IF (ISW(5) .GE. 0)  WRITE (ISYSWR,'(11X,A,I3)')    
     +      ' LIMITS NOT CHANGED FOR FIXED PARAMETER:',INU  
         GO TO 20   
      ENDIF 
      IF (NEWCOD .EQ. 1)  THEN  
C            remove limits from parameter   
         IF (ISW(5) .GT. 0)     WRITE (ISYSWR,134)  INU 
         CSTATU = 'NEW LIMITS'  
         CALL MNDXDI(X(NINT),NINT,DXDI) 
         SNEW = GSTEP(NINT)*DXDI    
         GSTEP(NINT) = ABS(SNEW)    
         NVARL(INU) = 1 
      ELSE  
C             put limits on parameter   
         ALIM(INU) = MIN(WORD7(2),WORD7(3)) 
         BLIM(INU) = MAX(WORD7(2),WORD7(3)) 
         IF (ISW(5) .GT. 0) WRITE (ISYSWR,237)  INU,ALIM(INU),BLIM(INU) 
         NVARL(INU) = 4 
         CSTATU = 'NEW LIMITS'  
         GSTEP(NINT) = -0.1 
      ENDIF 
   20 CONTINUE  
      GO TO 900 
C                                       set limits on one parameter 
   30 IF (NVARL(I2) .LE. 0)  THEN   
        WRITE (ISYSWR,'(A,I3,A)') ' PARAMETER ',I2,' IS NOT VARIABLE.'  
        GO TO 900   
      ENDIF 
      NINT = NIOFEX(I2) 
C                                       see if parameter was fixed  
      IF (NINT .EQ. 0)  THEN    
         WRITE (ISYSWR,'(A,I3)')    
     +     ' REQUEST TO CHANGE LIMITS ON FIXED PARAMETER:',I2   
         DO 82 IFX= 1, NPFIX    
         IF (I2 .EQ. IPFIX(IFX)) GO TO 92   
   82    CONTINUE   
         WRITE (ISYSWR,'(A)') ' MINUIT BUG IN MNLIMS. SEE F. JAMES' 
   92    CONTINUE   
      ENDIF 
      IF (WORD7(2) .NE. WORD7(3))  GO TO 235    
C                                       remove limits   
      IF (NVARL(I2) .NE. 1)  THEN   
         IF (ISW(5) .GT. 0)  WRITE (ISYSWR,134)  I2 
  134    FORMAT (30H LIMITS REMOVED FROM PARAMETER  ,I4)    
         CSTATU = 'NEW LIMITS'  
         IF (NINT .LE. 0)  THEN 
            GSTEPS(IFX) = ABS(GSTEPS(IFX))  
         ELSE   
            CALL MNDXDI(X(NINT),NINT,DXDI)  
            IF (ABS(DXDI) .LT. 0.01)  DXDI=0.01 
            GSTEP(NINT) = ABS(GSTEP(NINT)*DXDI) 
            GRD(NINT) = GRD(NINT)*DXDI  
         ENDIF  
         NVARL(I2) = 1  
      ELSE  
         WRITE (ISYSWR,'(A,I3)') ' NO LIMITS SPECIFIED.  PARAMETER ',   
     +        I2,' IS ALREADY UNLIMITED.  NO CHANGE.'   
      ENDIF 
      GO TO 900 
C                                        put on limits  
  235 ALIM(I2) = MIN(WORD7(2),WORD7(3)) 
      BLIM(I2) = MAX(WORD7(2),WORD7(3)) 
      NVARL(I2) = 4 
      IF (ISW(5) .GT. 0)   WRITE (ISYSWR,237)  I2,ALIM(I2),BLIM(I2) 
  237 FORMAT (10H PARAMETER ,I3, 14H LIMITS SET TO  ,2G15.5)    
      CSTATU = 'NEW LIMITS' 
      IF (NINT .LE. 0)  THEN    
         GSTEPS(IFX) = -0.1 
      ELSE  
         GSTEP(NINT) = -0.1 
      ENDIF 
C   
  900 CONTINUE  
      IF (CSTATU .NE. 'NO CHANGE ')  THEN   
        CALL MNEXIN(X)  
        CALL MNRSET(1)  
      ENDIF 
      RETURN    
      END   
      SUBROUTINE MNLINE(FCN,START,FSTART,STEP,SLOPE,TOLER,FUTIL)    
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Perform a line search from position START 
CC        along direction STEP, where the length of vector STEP 
CC                   gives the expected position of minimum.    
CC        FSTART is value of function at START  
CC        SLOPE (if non-zero) is df/dx along STEP at START  
CC        TOLER is initial tolerance of minimum in direction STEP   
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION START(*), STEP(*)   
      PARAMETER (MAXPT=12)  
      DIMENSION XPT(MAXPT), YPT(MAXPT)  
      DIMENSION XVALS(3),FVALS(3),COEFF(3)  
      CHARACTER*1 CHPT(MAXPT)   
      CHARACTER*26 CHARAL   
      CHARACTER*60 CMESS    
      PARAMETER (SLAMBG=5.,ALPHA=2.)    
C SLAMBG and ALPHA control the maximum individual steps allowed.    
C The first step is always =1. The max length of second step is SLAMBG. 
C The max size of subsequent steps is the maximum previous successful   
C   step multiplied by ALPHA + the size of most recent successful step, 
C   but cannot be smaller than SLAMBG.  
      LOGICAL LDEBUG    
      DATA CHARAL / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' /  
      LDEBUG = (IDBG(1).GE.1)   
C                  starting values for overall limits on total step SLAM    
      OVERAL = 1000.    
      UNDRAL = -100.    
C                                      . set up linear search along STEP    
    
      FVMIN = FSTART    
      XVMIN = 0.    
      NXYPT = 1 
      CHPT(1) = CHARAL(1:1) 
      XPT(1) = 0.   
      YPT(1) = FSTART   
C               SLAMIN = smallest possible value of ABS(SLAM)   
      SLAMIN = 0.   
      DO 20 I= 1, NPAR  
      IF (STEP(I) .EQ. 0.)  GO TO 20    
      RATIO = ABS(START(I)/STEP(I)) 
      IF (SLAMIN .EQ. 0.)     SLAMIN = RATIO    
      IF (RATIO .LT. SLAMIN)  SLAMIN = RATIO    
   20 X(I) = START(I) + STEP(I) 
      IF (SLAMIN .EQ. 0.)  SLAMIN = EPSMAC  
      SLAMIN = SLAMIN*EPSMAC    
      NPARX = NPAR  
C   
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,F1,U,4,FUTIL)  
      NFCN=NFCN+1   
      NXYPT = NXYPT + 1 
      CHPT(NXYPT) = CHARAL(NXYPT:NXYPT) 
      XPT(NXYPT) = 1.   
      YPT(NXYPT) = F1   
      IF (F1 .LT. FSTART) THEN  
         FVMIN = F1 
         XVMIN = 1.0    
      ENDIF 
C                         . quadr interp using slope GDEL and two points    
      SLAM = 1. 
      TOLER8 = TOLER    
      SLAMAX = SLAMBG   
      FLAST = F1    
C                         can iterate on two-points (cut) if no imprvmnt    
   25 CONTINUE  
      DENOM = 2.0*(FLAST-FSTART-SLOPE*SLAM)/SLAM**2 
      IF (DENOM .EQ. 0.)  DENOM = -0.1*SLOPE    
      SLAM = -SLOPE/DENOM   
      IF (SLAM .LT. 0.)  SLAM = SLAMAX  
      IF (SLAM .GT. SLAMAX)  SLAM = SLAMAX  
      IF (SLAM .LT. TOLER8)  SLAM = TOLER8  
      IF (SLAM .LT. SLAMIN)  GO TO 80   
      IF (ABS(SLAM-1.0).LT.TOLER8 .AND. F1.LT.FSTART)  GO TO 70 
      IF (ABS(SLAM-1.0).LT.TOLER8) SLAM = 1.0+TOLER8    
      IF (NXYPT .GE. MAXPT) GO TO 65    
      DO 30 I= 1, NPAR  
   30 X(I) = START(I) + SLAM*STEP(I)    
      CALL MNINEX(X)    
      CALL FCN(NPAR,GIN,F2,U,4,FUTIL)   
      NFCN = NFCN + 1   
      NXYPT = NXYPT + 1 
      CHPT(NXYPT) = CHARAL(NXYPT:NXYPT) 
      XPT(NXYPT) = SLAM 
      YPT(NXYPT) = F2   
      IF (F2 .LT. FVMIN)  THEN  
         FVMIN = F2 
         XVMIN = SLAM   
      ENDIF 
      IF (FSTART .EQ. FVMIN) THEN   
         FLAST = F2 
         TOLER8 = TOLER*SLAM    
         OVERAL = SLAM-TOLER8   
         SLAMAX = OVERAL    
         GO TO 25   
      ENDIF 
C                                        . quadr interp using 3 points  
      XVALS(1) = XPT(1) 
      FVALS(1) = YPT(1) 
      XVALS(2) = XPT(NXYPT-1)   
      FVALS(2) = YPT(NXYPT-1)   
      XVALS(3) = XPT(NXYPT) 
      FVALS(3) = YPT(NXYPT) 
C                             begin iteration, calculate desired step   
   50 CONTINUE  
      SLAMAX = MAX(SLAMAX,ALPHA*ABS(XVMIN)) 
      CALL MNPFIT(XVALS,FVALS,3,COEFF,SDEV) 
      IF (COEFF(3) .LE. 0.)  THEN   
         SLOPEM = 2.0*COEFF(3)*XVMIN + COEFF(2) 
         IF (SLOPEM .LE. 0.) THEN   
            SLAM = XVMIN + SLAMAX   
         ELSE   
            SLAM = XVMIN - SLAMAX   
         ENDIF  
      ELSE  
         SLAM = -COEFF(2)/(2.0*COEFF(3))    
         IF (SLAM .GT. XVMIN+SLAMAX)  SLAM = XVMIN+SLAMAX   
         IF (SLAM .LT. XVMIN-SLAMAX)  SLAM = XVMIN-SLAMAX   
      ENDIF 
      IF (SLAM .GT. 0.) THEN    
          IF (SLAM .GT. OVERAL) SLAM = OVERAL   
      ELSE  
          IF (SLAM .LT. UNDRAL) SLAM = UNDRAL   
      ENDIF 
C               come here if step was cut below 
   52 CONTINUE  
      TOLER9 = MAX(TOLER8,ABS(TOLER8*SLAM)) 
      DO 55 IPT= 1, 3   
      IF (ABS(SLAM-XVALS(IPT)) .LT. TOLER9)  GO TO 70   
   55 CONTINUE  
C                take the step  
      DO 60 I= 1, NPAR  
   60 X(I) = START(I)+SLAM*STEP(I)  
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,F3,U,4,FUTIL)  
      NFCN = NFCN + 1   
      NXYPT = NXYPT + 1 
      CHPT(NXYPT) = CHARAL(NXYPT:NXYPT) 
      XPT(NXYPT) = SLAM 
      YPT(NXYPT) = F3   
C             find worst previous point out of three    
      FVMAX = FVALS(1)  
      NVMAX = 1 
      IF (FVALS(2) .GT. FVMAX) THEN 
         FVMAX = FVALS(2)   
         NVMAX = 2  
      ENDIF 
      IF (FVALS(3) .GT. FVMAX) THEN 
         FVMAX = FVALS(3)   
         NVMAX = 3  
      ENDIF 
C              if latest point worse than all three previous, cut step  
      IF (F3 .GE. FVMAX)  THEN  
          IF (NXYPT .GE. MAXPT) GO TO 65    
          IF (SLAM .GT. XVMIN) OVERAL = MIN(OVERAL,SLAM-TOLER8) 
          IF (SLAM .LT. XVMIN) UNDRAL = MAX(UNDRAL,SLAM+TOLER8) 
          SLAM = 0.5*(SLAM+XVMIN)   
          GO TO 52  
      ENDIF 
C              prepare another iteration, replace worst previous point  
      XVALS(NVMAX) = SLAM   
      FVALS(NVMAX) = F3 
      IF (F3 .LT. FVMIN)  THEN  
         FVMIN = F3 
         XVMIN = SLAM   
      ELSE  
         IF (SLAM .GT. XVMIN) OVERAL = MIN(OVERAL,SLAM-TOLER8)  
         IF (SLAM .LT. XVMIN) UNDRAL = MAX(UNDRAL,SLAM+TOLER8)  
      ENDIF 
      IF (NXYPT .LT. MAXPT)  GO TO 50   
C                                            . . end of iteration . . . 
C            stop because too many iterations   
   65 CMESS = ' LINE SEARCH HAS EXHAUSTED THE LIMIT OF FUNCTION CALLS ' 
      GO TO 100 
C            stop because within tolerance  
   70 CONTINUE  
      CMESS = ' LINE SEARCH HAS ATTAINED TOLERANCE '    
      GO TO 100 
   80 CONTINUE  
      CMESS = ' STEP SIZE AT ARITHMETICALLY ALLOWED MINIMUM'    
  100 CONTINUE  
      AMIN = FVMIN  
      DO 120 I= 1, NPAR 
      DIRIN(I) = STEP(I)*XVMIN  
  120 X(I) = START(I) + DIRIN(I)    
      IF (LREPOR)  THEN 
         IF ( XVMIN.LT.0.) WRITE (ISYSWR,126)  XVMIN    
  126    FORMAT (' MINUIT EXCEPTIONAL CONDITION IN MNLINE:'/    
     +    ' LINE MINIMUM IN BACKWARDS DIRECTION, RELATIVE STEP=',F10.3) 
         IF (FVMIN .EQ. FSTART)  WRITE (ISYSWR,127) 
  127    FORMAT (' MINUIT EXCEPTIONAL CONDITION IN MNLINE:',    
     +    ' LINE SEARCH FINDS NO IMPROVEMENT ') 
      ENDIF 
      IF (LDEBUG)  THEN 
         WRITE (ISYSWR,'('' AFTER'',I3,'' POINTS,'',A)') NXYPT,CMESS    
         CALL MNPLOT(XPT,YPT,CHPT,NXYPT,ISYSWR,NPAGWD,NPAGLN)   
      ENDIF 
      RETURN    
      END   
      SUBROUTINE MNMATU(KODE)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        prints the covariance matrix v when KODE=1.   
CC        calculates and prints the 
CC        individual correlation coefficients and global correlations.  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION VLINE(MNI)  
      IF (ISW(2) .LT. 2)  THEN  
          IF (ISW(5) .GE. 0)    
     +       WRITE (ISYSWR,'('' NO COVARIANCE MATRIX. '')') 
          GO TO 500 
          ENDIF 
      IF (ISW(2).EQ.2 .AND. ISW(5) .GE. 0)  
     +       WRITE(ISYSWR,'('' NOT POSITIVE-DEFINITE'')')   
      IF (NPAR .EQ. 0)  THEN    
          WRITE (ISYSWR,'('' MNMATU: NPAR=0'')')    
          GO TO 500 
          ENDIF 
C                                       . . . . .external error matrix  
      IF (KODE .EQ. 1)  CALL MNEMAT(P,MAXINT)   
C                                       . . . . . correlation coeffs. . 
      IF (NPAR .EQ. 1)  THEN    
                IF (ISW(5) .GT. 0)  
     +          WRITE (ISYSWR,'('' ONLY ONE FREE PARAMETER'')') 
          GO TO 500 
          ENDIF 
      NCOEF = (NPAGWD-18)/6 
      NPARM = MIN0(NPAR,NCOEF)  
      DO 130 I= 1, NPAR 
      DO 130 J= 1, NPAR 
  130 P(I,J) = V(I,J)   
      CALL MNVERT(P,MAXINT,MAXINT,NPAR,IERR)    
      IF (IERR .GT. 0)  THEN    
         WRITE (ISYSWR, 131)    
  131    FORMAT (48H   MATRIX INVERSION FAILS. CORRELATIONS .GT. 1.  )  
         ISW(2) = 0 
      ELSE  
         WRITE (ISYSWR, 150) (ID,ID=1,NPARM)    
  150        FORMAT (36H0PARAMETER  CORRELATION COEFFICIENTS  / 
     +       18H INT. EXT.  GLOBAL   ,16I6) 
         DO 200 I= 1, NPAR  
         IX = NEXOFI(I) 
         DO 170 J= 1, NPAR  
  170    VLINE(J) = V(I,J)/SQRT(ABS(V(I,I)*V(J,J))) 
         DENOM = P(I,I)*V(I,I)  
         GCC = 1.0  
         IF (DENOM .GT. 1.0)  GCC = SQRT(1.0 - 1.0/(V(I,I)*P(I,I))) 
         WRITE (ISYSWR,171) I,IX, GCC, (VLINE(IT),IT=1,NPAR)    
  171      FORMAT (1X,I3,2X,I3,2X,F7.5,1X,16F6.3/(20X,16F6.3))  
  200    CONTINUE   
      ENDIF 
  500 RETURN    
      END   
      SUBROUTINE MNMIGR(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Performs a local function minimization using basically the    
CC        method of Davidon-Fletcher-Powell as modified by Fletcher 
CC        ref. -- Fletcher, Comp.J. 13,317 (1970)   "switching method"  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION GS(MNI), STEP(MNI),  XXS(MNI), FLNU(MNI), VG(MNI)   
      LOGICAL LDEBUG    
      PARAMETER (TOLER=0.05)    
      IF (NPAR .LE. 0)  RETURN  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      LDEBUG = (IDBG(4) .GE. 1) 
      CFROM = 'MIGRAD  '    
      CSTATU= 'INITIATE  '  
      ISWTR = ISW(5) - 2*ITAUR  
      NPFN = NFCN   
      NPARX = NPAR  
      NRSTRT = 0    
      NPSDF = 0 
      RHOTOL = 1.0E-3*APSI  
      IF (ISWTR .GE. 1)  WRITE (ISYSWR,470) ISTRAT,RHOTOL   
  470 FORMAT (' START MIGRAD MINIMIZATION.  STRATEGY',I2,   
     +'.  CONVERGENCE WHEN EDM .LT.',E9.2)  
C                                           iniialization strategy  
      IF (ISTRAT .EQ. 2)  GO TO 1   
      IF (ISW(2) .GE. 2)  GO TO 2   
      IF (ISTRAT .LT. 2)  GO TO 2   
C                                come (back) here to restart completely 
    1 CONTINUE  
      IF (NRSTRT .GT. ISTRAT)  THEN 
         CSTATU= 'FAILED    '   
         GO TO 230  
         ENDIF  
C                                      . get covariance and gradient    
      CALL MNHESS(FCN,FUTIL)    
      NPSDF = 0 
      GO TO 10  
C                                        . get gradient at start point  
    2 CONTINUE  
      IF (ISW(3) .EQ. 1) THEN   
          CALL MNINEX(X)    
          CALL FCN(NPARX,GIN,FZERO,U,2,FUTIL)   
          NFCN = NFCN + 1   
      ENDIF 
      CALL MNDERI(FCN,FUTIL)    
      IF (ISW(2) .GE. 2)  GO TO 10  
C                                   sometimes start with diagonal matrix    
      DO 5 I=1,NPAR 
      DO 4 J=1,NPAR 
    4 V(I,J) = 0.   
      IF (G2(I) .EQ. 0.)  G2(I) = 1.    
      V(I,I) = 1./G2(I) 
    5 CONTINUE  
C                                         ready to start first iteration    
   10 CONTINUE  
      IMPRUV = 0    
      NRSTRT = NRSTRT + 1   
      IF (NRSTRT .GT. ISTRAT+1)  THEN   
         CSTATU= 'FAILED    '   
         GO TO 230  
         ENDIF  
      FS = AMIN 
C                                        . . . get EDM and set up loop  
      EDM = 0.  
      DO 18 I= 1, NPAR  
      GS(I) = GRD(I)    
      RI = 0.   
      DO 17 J= 1, NPAR  
      XXS(I) = X(I) 
   17 RI = RI + V(I,J)*GRD(J)   
   18 EDM = EDM + GS(I) *RI *0.5    
      ITER = 0  
      CALL MNINEX(X)    
      IF (ISWTR .GE. 1)  CALL MNPRIN(3,AMIN)    
      IF (ISWTR .GE. 2)  CALL MNMATU(0) 
C                                        . . . . .  start main loop 
   24 CONTINUE  
      IF (NFCN-NPFN .GE. NFCNMX)  GO TO 190 
      GDEL = 0. 
      GSSQ = 0. 
      DO 30  I=1,NPAR   
      RI = 0.   
      GSSQ = GSSQ + GS(I)**2    
      DO 25 J=1,NPAR    
   25 RI = RI + V(I,J) *GS(J)   
      STEP(I) = -0.5*RI 
   30 GDEL = GDEL + STEP(I)*GS(I)   
      IF (GSSQ .EQ. 0.)  THEN   
          IF (ISWTR .GE. 1) WRITE (ISYSWR,31)   
   31     FORMAT (' FIRST DERIVATIVES OF FCN ARE ALL ZERO') 
          GO TO 300 
      ENDIF 
C                 if gdel positive, V not posdef    
      IF (GDEL .GE. 0.0)  THEN  
         IF (ISWTR .GE. 1)  WRITE (ISYSWR,520)  
         IF (NPSDF .EQ. 1)  GO TO 1 
         CALL MNPSDF    
         NPSDF = 1  
         GO TO 24   
         ENDIF  
C                                        . . . . do line search 
      CALL MNLINE(FCN,XXS,FS,STEP,GDEL,TOLER,FUTIL) 
      IF (AMIN .EQ. FS) GO TO 200   
      CFROM  = 'MIGRAD  '   
      CSTATU= 'PROGRESS  '  
C                                        . get gradient at new point    
      IF (ISW(3) .EQ. 1) THEN   
          CALL MNINEX(X)    
          CALL FCN(NPARX,GIN,FZERO,U,2,FUTIL)   
          NFCN = NFCN + 1   
      ENDIF 
      CALL MNDERI(FCN,FUTIL)    
C                                         . calculate new EDM   
      NPSDF = 0 
   81 EDM = 0.  
      GVG = 0.  
      DELGAM = 0.   
      GDGSSQ = 0.   
      DO 100 I= 1, NPAR 
      RI = 0.   
      VGI = 0.  
      DO 90 J= 1, NPAR  
      VGI = VGI + V(I,J)*(GRD(J)-GS(J)) 
   90 RI = RI + V(I,J) *GRD(J)  
      VG(I) = VGI*0.5   
      GAMI = GRD(I) - GS(I) 
      GDGSSQ = GDGSSQ + GAMI**2 
      GVG = GVG + GAMI*VG(I)    
      DELGAM = DELGAM + DIRIN(I)*GAMI   
  100 EDM = EDM + GRD(I)*RI*0.5 
C                                              and see if converged 
      IF (EDM .GE. 0. .AND. EDM .LT. 0.1*RHOTOL)  GO TO 300 
      ITER = ITER + 1   
      IF (ISWTR.GE.3 .OR. (ISWTR.EQ.2 .AND. MOD(ITER,10).EQ.1)) 
     *     CALL MNPRIN(3,AMIN)  
      IF (EDM .LT. 0.)  GO TO 105   
      IF (GDGSSQ .EQ. 0.)  THEN 
          IF (ISWTR .GE. 1)  WRITE (ISYSWR,'(A)')   
     +      ' NO CHANGE IN FIRST DERIVATIVES OVER LAST STEP'    
      ENDIF 
      IF (DELGAM.LT.0. .AND. LDEBUG)   WRITE (ISYSWR,'(A)') 
     +        ' FIRST DERIVATIVES INCREASING ALONG SEARCH LINE' 
      IF (GVG .GT. 0.)  GO TO 107   
C                                          . not positive-definite  
  105 IF (ISWTR .GE. 1)  WRITE (ISYSWR, 520)    
      CSTATU = 'NOT POSDEF' 
      IF (NPSDF .EQ. 1)  GO TO 230  
      CALL MNPSDF   
      NPSDF = 1 
      GO TO 81  
C                                        .  update covariance matrix    
  107 CONTINUE  
      CSTATU = 'IMPROVEMNT' 
      DO 120 I= 1, NPAR 
      DO  120  J=1,NPAR 
      D = DIRIN(I)*DIRIN(J)/DELGAM - VG(I)*VG(J)/GVG    
  120 V(I,J) = V(I,J) + 2.0*D   
      IF (DELGAM .LE. GVG)  GO TO 135   
      DO 125 I= 1, NPAR 
  125 FLNU(I) = DIRIN(I)/DELGAM - VG(I)/GVG 
      DO 130 I= 1, NPAR 
      DO 130 J= 1, NPAR 
  130 V(I,J) = V(I,J) + 2.0*GVG*FLNU(I)*FLNU(J) 
  135 CONTINUE  
      DO 140 I= 1, NPAR 
      XXS(I) = X(I) 
      GS(I) = GRD(I)    
  140 CONTINUE  
      FS = AMIN 
      IMPRUV = IMPRUV + 1   
      IF (IMPRUV .GE. NPAR)  ISW(2) = 3 
      GO TO 24  
C                                        . . . . .  end main loop   
C                                         . . call limit in MNMIGR  
  190 ISW(1) = 1    
      IF (ISW(5) .GE. 0)    
     +     WRITE (ISYSWR,'(A)')  ' CALL LIMIT EXCEEDED IN MIGRAD.'  
      CSTATU = 'CALL LIMIT' 
      GO TO 230 
C                                         . . fails to improve . .  
  200 IF (ISWTR .GE. 1)  WRITE (ISYSWR,'(A)')   
     +           ' MIGRAD FAILS TO FIND IMPROVEMENT'    
      DO 210 I= 1, NPAR 
  210 X(I) = XXS(I) 
      IF (EDM .LT. RHOTOL)  GO TO 300   
      IF (EDM .LT. ABS(2.*EPSMAC*AMIN))  THEN   
         IF (ISWTR .GE. 0)  WRITE (ISYSWR, '(A)')   
     +      ' MACHINE ACCURACY LIMITS FURTHER IMPROVEMENT.' 
         GO TO 300  
         ENDIF  
      IF (ITAUR .EQ. 1) THEN    
         CSTATU = 'PROBLEMS  '  
         GO TO 300  
         ENDIF  
      IF (ISTRAT .LT. 1)  THEN  
         IF (ISW(5) .GE. 0) WRITE (ISYSWR, '(A)')   
     +    ' MIGRAD FAILS WITH STRATEGY=0.   WILL TRY WITH STRATEGY=1.'  
         ISTRAT = 1 
         GO TO 1    
         ENDIF  
C                                         . . fails to converge 
  230 IF (ISWTR .GE. 0)  WRITE (ISYSWR,'(A)')   
     +    ' MIGRAD TERMINATED WITHOUT CONVERGENCE.' 
      ISW(2) = 0    
      GO TO 400 
C                                         . . apparent convergence  
  300 IF (ISWTR .GE. 0) WRITE(ISYSWR,'(/A)')    
     +   ' MIGRAD MINIMIZATION HAS CONVERGED.'  
      IF (ITAUR .EQ. 0) THEN    
        IF (ISTRAT .GE. 2 .OR. (ISTRAT.EQ.1.AND.ISW(2).LT.3)) THEN  
           IF (ISW(5) .GE. 0)  WRITE (ISYSWR, '(A)')    
     +      '0MIGRAD WILL VERIFY CONVERGENCE AND ERROR MATRIX.' 
           CALL MNHESS(FCN,FUTIL)   
           NPSDF = 0    
           IF (EDM .GT. RHOTOL) GO TO 10    
        ENDIF   
      ENDIF 
      CSTATU='CONVERGED '   
      IF (ISW(2) .EQ. 2) CSTATU ='NOT POSDEF'   
      IF (ISW(2) .LT. 2) CSTATU ='UNCERTAIN '   
C                                           come here in any case   
  400 CONTINUE  
      CFROM = 'MIGRAD  '    
      CALL  MNINEX(X)   
      IF (ISWTR .GE. 0)  CALL MNPRIN (3,AMIN)   
      IF (ISWTR .GE. 1)  CALL MNMATU(1) 
      RETURN    
C   
  520 FORMAT (51H MIGRAD COVARIANCE MATRIX IS NOT POSITIVE-DEFINITE.)   
      END   
      SUBROUTINE MNMNOS(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Performs a MINOS error analysis on those parameters for   
CC        which it is requested on the MINOS command.   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      IF (NPAR .LE. 0)  GO TO 700   
      NGOOD = 0 
      NBAD = 0  
C                                      . loop over parameters requested 
      DO 570 KNT= 1, NPAR   
      IF (INT(WORD7(2)) .EQ. 0) THEN    
          ILAX = NEXOFI(KNT)    
      ELSE  
          IF (KNT .GE. 7)  GO TO 580    
          ILAX = INT(WORD7(KNT+1))  
          IF (ILAX .EQ. 0)  GO TO 580   
          IF (ILAX .GT. 0 .AND. ILAX .LE. NU) THEN  
             IF (NIOFEX(ILAX) .GT. 0)  GO TO 565    
          ENDIF 
          WRITE (ISYSWR,564) ILAX   
  564     FORMAT ('0ILLEGAL PARAMETER NUMBER REQUESTED:',I10)   
          GO TO 570 
      ENDIF 
  565 CONTINUE  
C                                         calculate one pair of M E's   
      CALL MNMNOT(FCN,ILAX,FUTIL)   
      IF (LNEWMN)  GO TO 650    
C                                          update NGOOD and NBAD    
      IF (ERP(ILAX) .GT. 0.) THEN   
         NGOOD=NGOOD+1  
      ELSE  
         NBAD=NBAD+1    
      ENDIF 
      IF (ERN(ILAX) .LT. 0.) THEN   
         NGOOD=NGOOD+1  
      ELSE  
         NBAD=NBAD+1    
      ENDIF 
  570 CONTINUE  
C                                           end of loop . . . . . . .   
  580 CONTINUE  
C                                        . . . . printout final values .    
      CFROM = 'MINOS   '    
      CSTATU= 'UNCHANGED '  
      IF (NGOOD.EQ.0.AND.NBAD.EQ.0) GO TO 700   
      IF (NGOOD.GT.0.AND.NBAD.EQ.0) CSTATU='SUCCESSFUL' 
      IF (NGOOD.EQ.0.AND.NBAD.GT.0) CSTATU='FAILURE   ' 
      IF (NGOOD.GT.0.AND.NBAD.GT.0) CSTATU='PROBLEMS  ' 
      IF (ISW(5) .GE. 0) CALL MNPRIN(4,AMIN)    
      IF (ISW(5) .GE. 2) CALL MNMATU(0) 
      GO TO 900 
C                                        . . . new minimum found . . . .    
  650 CONTINUE  
      CFROM = 'MINOS   '    
      CSTATU= 'NEW MINIMU'  
      IF (ISW(5) .GE. 0) CALL MNPRIN(4,AMIN)    
      WRITE (ISYSWR,675)    
  675 FORMAT (50H0NEW MINIMUM FOUND.  GO BACK TO MINIMIZATION STEP./1H ,    
     +60(1H=)/60X,1HV/60X,1HV/60X,1HV/57X,7HVVVVVVV/58X,5HVVVVV/59X,    
     +3HVVV/60X,1HV//)  
      GO TO 900 
  700 WRITE (ISYSWR,'(A)') ' THERE ARE NO MINOS ERRORS TO CALCULATE.'   
  900 RETURN    
      END   
      SUBROUTINE MNMNOT(FCN,ILAX,FUTIL) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Performs a MINOS error analysis on one parameter. 
CC        The parameter ILAX is varied, and the minimum of the  
CC        function with respect to the other parameters is followed 
CC        until it crosses the value FMIN+UP.   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION XDEV(MNI),W(MNE)    
      DIMENSION XPT(20), YPT(20)    
      CHARACTER*1 CHPT(20)  
      CHARACTER*4 CPOS,CNEG,CSIG    
      CHARACTER*1 CDOT,CSTAR,CBLANK 
      PARAMETER (CPOS='POSI',CNEG='NEGA',CDOT='.',CSTAR='*',CBLANK=' ') 
      LOGICAL LPRBLM, LOVFLO    
C                                        . . save and prepare start vals    
      SIGSAV = EDM  
      IPRBLM  = 0   
      LOVFLO = .FALSE.  
      LNEWMN = .FALSE.  
      TOLER = EPSI  
      APSI = EPSI*0.5   
      ITAUR = 1 
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      ABEST=AMIN    
      AIM = AMIN + UP   
      MPAR=NPAR 
      NFMXIN = NFCNMX   
      CREMIN = 0.04*UP  
      CREMAX = 25.0*UP  
      DO 130 I= 1, MPAR 
      XT(I) = X(I)  
      DO 125 J= 1, MPAR 
  125 VT(I,J) = V(I,J)  
  130 CONTINUE  
      DO 135 I= 1, NU   
  135 W(I) = WERR(I)    
C                                        . . . . . start main loop . . .    
      ISW(1) = 0    
      NLIMIT = NFCN + NFCNMX    
      ERP(ILAX) = 0.    
      ERN(ILAX) = 0.    
      IT = NIOFEX(ILAX) 
      CALL MNINEX(XT)   
      UT = U(ILAX)  
      XPT(1) = UT   
      YPT(1) = AIM  
      CHPT(1) = CBLANK  
      XPT(2) = UT   
      YPT(2) = ABEST    
      CHPT(2) = CSTAR   
      XPT(3) = UT   
      YPT(3) = AIM + 0.2*(AIM-ABEST)    
      CHPT(3) = CDOT    
      NXYPT = 3 
      IF (NVARL(ILAX) .EQ. 1) THEN  
         ALIM(ILAX) = UT -100.*W(ILAX)  
         BLIM(ILAX) = UT +100.*W(ILAX)  
         ENDIF  
      XUNIT = SQRT(UP/VT(IT,IT))    
      MARC = 0  
      DO 162 I= 1, MPAR 
      IF (I .EQ. IT)  GO TO 162 
      MARC = MARC + 1   
      XDEV(MARC) = XUNIT*VT(IT,I)   
  162 CONTINUE  
      CALL MNFIXP (IT)  
      SIG = 1.0 
      CSIG = CPOS   
      DULIM = BLIM(ILAX) - UT   
C                                        .Loop over sig.    
C                                        . sig=sign of error being calcd    
  165 IF (ISW(5) .GT. 1) WRITE (ISYSWR,806)  CSIG,ILAX,CPNAM(ILAX)  
  806 FORMAT (  18H0DETERMINATION OF ,A4,  30HTIVE MINOS ERROR FOR PARAM    
     +ETER,I3, 2X ,A10) 
      IF(ISW(2).LT.1) THEN  
         WRITE (ISYSWR, '(A)') ' MINUIT ERROR: NO COVARIANCE MATRIX '   
         GO TO 460  
      ENDIF 
      ITER = 0  
      LIMSET = .FALSE.  
      DU1 = SIG*W(ILAX) 
      IF (ABS(DU1) .LE. DULIM)  GO TO 180   
      LIMSET = .TRUE.   
      DU1 = SIG * DULIM 
      IF (DULIM .LT. 1.0E-3*W(ILAX))    GO TO 440   
  180 U(ILAX) = UT + DU1    
      IF (NPAR .GT. 0)  THEN    
         FAC = DU1/W(ILAX)  
         DO 185 I= 1, NPAR  
  185    X(I) = XT(I) + FAC*XDEV(I) 
      ENDIF 
C                                        loop to hit AIM    
  200 CALL MNINEX (X)   
      IF (ISW(5) .GT. 1) WRITE (ISYSWR,801)  ILAX,UT,DU1,U(ILAX)    
  801 FORMAT (' PARAMETER',I4,' SET TO',E11.3,' + ',E10.3,' = ',E12.3)  
      NPARX = NPAR  
      CALL FCN(NPARX,GIN,ANOW,U,4,FUTIL)    
      AMIN = ANOW   
      NFCN = NFCN + 1   
      LPRBLM = .FALSE.  
      IF (NPAR .GT. 0) THEN 
         CALL MNDERI(FCN,FUTIL) 
         NFCNMX = NLIMIT - NFCN 
         CALL MNMIGR(FCN,FUTIL) 
         IF (CSTATU(1:4) .EQ. 'PROB') LPRBLM=.TRUE. 
         ENDIF  
      IF (ABEST-AMIN .GT. 0.01*UP)  GO TO 650   
      IF (ISW(1) .GE. 1)  GO TO 450 
      IF (ISW(2) .LT. 2)  GO TO 460 
      CREM = AMIN - ABEST   
      IF (CREM .LT. CREMIN)  CREM = CREMIN  
      IF (CREM .GT. CREMAX)  CREM = CREMAX  
      NXYPT = NXYPT + 1 
      XPT(NXYPT) = U(ILAX)  
      YPT(NXYPT) = AMIN 
      CHPT(NXYPT) = CSIG(1:1)   
      IF (AMIN .GT. (AIM+UP)) THEN  
         YPT(NXYPT) = AIM+UP    
         CHPT(NXYPT) = '+'  
         LOVFLO = .TRUE.    
         ENDIF  
      IF (LPRBLM) THEN  
          CHPT(NXYPT) = 'V' 
          IPRBLM = IPRBLM + 1   
          ENDIF 
      SQUC = SQRT(UP/CREM)  
      IF (ABS(AMIN-AIM) .LT. TOLER)  GO TO 400  
C                                        . . another iteration necessary    
      ITER = ITER + 1   
      IF (ITER .GT. 10)  GO TO 430  
      IF (ITER .EQ. 1)  GO TO 270   
C       check previous iteration to avoid oscillating   
      SQUC2 = SQUC  
      IF ((SQUC2-1.0) * (SQUC1-1.0) .GT. 0.0)  GO TO 270    
      SQUC = 0.65*SQUC2 + 0.35  
      SQUC11 = 1.0/SQUC1    
      IF ((SQUC11-SQUC)*(SQUC-1.0) .GT. 0.0)  GO TO 270 
      WRITE (ISYSWR,260) ILAX   
  260 FORMAT (' MINOS IS HAVING TROUBLE WITH PARAMETER',I4) 
      SQUC = 0.5 *SQUC11 + 0.5  
  270 CONTINUE  
      SQUC1 = SQUC  
      DU1 = DU1 * SQUC  
      IF (ABS(DU1) .LE. DULIM)  GO TO 280   
      IF (LIMSET)  GO TO 440    
      LIMSET = .TRUE.   
      DU1 = SIG*DULIM   
  280 U(ILAX) = UT + DU1    
      DO 290 I= 1, NPAR 
      IOLD = I  
      IF (I .GE. IT)  IOLD = I+1    
  290 X(I) = XT(IOLD) + SQUC*(X(I)-XT(IOLD))    
      GO TO 200 
C                                        . error successfully calculated    
  400 EROS = DU1 * SQUC 
      IF (ISW(5) .GT. 1) WRITE (ISYSWR,808)  CSIG,ILAX,CPNAM(ILAX),EROS 
  808 FORMAT (/9X,4HTHE ,A4,  29HTIVE MINOS ERROR OF PARAMETER,I3,   2H 
     +, ,A10,      4H, IS ,E12.4)   
  410 IF (ISW(5) .GT. 1) WRITE (ISYSWR,'(5X, 74(1H*))') 
      IF (SIG .GT. 0.)  GO TO 420   
      ERN(ILAX) = EROS  
      GO TO 500 
  420 ERP(ILAX) = EROS  
      SIG = -1.0    
      CSIG = CNEG   
      DULIM = UT - ALIM(ILAX)   
      GO TO 165 
C                                        . . . . . . . . failure returns    
  430 IF (ISW(5) .GE. 0)  WRITE (ISYSWR,'(A)') '   TOO MANY ITERATIONS.'    
      GO TO 460 
  440 IF (ISW(5) .GE. 0) WRITE(ISYSWR,807)  CSIG,ILAX,CPNAM(ILAX),DULIM 
  807 FORMAT (5X,'THE ',A4,'TIVE MINOS ERROR OF PARAMETER',I3,', ',A,   
     +', EXCEEDS ',E12.4/)  
      EROS = 0. 
      GO TO 410 
  450 IF (ISW(5) .GE. 0) WRITE (ISYSWR, 802)  CSIG,ILAX,NFMXIN  
  802 FORMAT (9X,'THE ',A,'TIVE MINOS ERROR',I4,' REQUIRES MORE THAN',  
     +   I5,' FUNCTION CALLS.'/)    
      EROS = 0. 
      GO TO 410 
  460 IF (ISW(5) .GE. 0) WRITE (ISYSWR, 805) CSIG,ILAX  
  805 FORMAT (25X,A,'TIVE MINOS ERROR NOT CALCULATED FOR PARAMETER',I4/)    
      EROS = 0. 
      GO TO 410 
C                                        . . parameter finished. reset v    
  500 CONTINUE  
      IF ((ISW(5).GE.1 .AND. NXYPT .GE.8) .OR.  
     +    (ISW(5).GE.0 .AND. IPRBLM.GT.0))  THEN    
         WRITE (ISYSWR,813)  NEWPAG,ILAX,CPNAM(ILAX),NXYPT-3    
  813    FORMAT (I1,'MINOS BEHAVIOUR OF PARAMETER',I3,  
     +     2H, ,A/28H ERROR CALCULATION REQUIRED ,I3,' MINIMIZATIONS,', 
     +     ' AS SUMMARIZED BELOW. ' )   
         IF (IPRBLM .GT. 0)  WRITE (ISYSWR, '(A,A)')    
     +      'MINOS ERRORS MAY BE UNDERESTIMATED IF POINTS MARKED "V" ', 
     +      ' ARE TOO HIGH DUE TO INCOMPLETE MINIMIZATION'  
         IF (LOVFLO) WRITE (ISYSWR,'(A,A)') ' POINTS MARKED "+" WERE',  
     +      ' IN FACT TOO HIGH TO BE REPRESENTED ON THE GRAPH.' 
         NUNIT = ISYSWR 
         CALL MNPLOT(XPT,YPT,CHPT,NXYPT,NUNIT,NPAGWD,NPAGLN)    
         WRITE(ISYSWR,814)  ILAX,CPNAM(ILAX)    
  814    FORMAT ('          PARAMETER ',I3,2H, ,A/) 
      ENDIF 
      IF (IPRBLM .GT. 0)  CSTATU = 'PROBLEMS  ' 
C                       normal termination  
      CALL MNFREE(1)    
      DO 560 I= 1, MPAR 
      DO 550 J= 1, MPAR 
  550 V(I,J) = VT(I,J)  
  560 CONTINUE  
      DO 595 I= 1, MPAR 
  595 X(I) = XT(I)  
      DO 635 I= 1, NU   
  635 WERR(I) = W(I)    
      CALL MNINEX (X)   
      EDM = SIGSAV  
      AMIN = ABEST  
      ISW(2) = 3    
      GO TO 700 
C                       new minimum 
  650 LNEWMN = .TRUE.   
      ISW(2) = 0    
      SAV = U(ILAX) 
      CALL MNFREE(1)    
      U(ILAX) = SAV 
      CALL MNEXIN(X)    
      EDM = 100.*UP 
C                       in any case 
  700 CONTINUE  
      NFCNMX = NFMXIN   
      ITAUR = 0 
      RETURN    
      END   
      SUBROUTINE MNPARM(K,CNAMJ,UK,WK,A,B,IERFLG)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called from MNREAD and user-callable  
CC    Implements one parameter definition, that is: 
CC          K     (external) parameter number   
CC          CNAMK parameter name    
CC          UK    starting value    
CC          WK    starting step size or uncertainty 
CC          A, B  lower and upper physical parameter limits 
CC    and sets up (updates) the parameter lists.    
CC    Output: IERFLG=0 if no problems   
CC                  >0 if MNPARM unable to implement definition 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      CHARACTER*(*) CNAMJ   
      CHARACTER*10  CNAMK   
C   
      IERFLG = 0    
      CNAMK = CNAMJ 
      NINT = NPAR   
      IF (K.LT.1 .OR. K.GT.MAXEXT) THEN 
C                     parameter number exceeds allowed maximum value    
        WRITE (ISYSWR,9)  K,MAXEXT  
    9   FORMAT (/' MINUIT USER ERROR.  PARAMETER NUMBER IS',I11/    
     +         ',  ALLOWED RANGE IS ONE TO',I4/)    
        GO TO 800   
      ENDIF 
C                     normal parameter request  
      KTOFIX = 0    
      IF (NVARL(K) .LT. 0) GO TO 50 
C         previously defined parameter is being redefined   
C                                     find if parameter was fixed   
      DO 40 IX= 1, NPFIX    
      IF (IPFIX(IX) .EQ. K)  KTOFIX = K 
   40 CONTINUE  
      IF (KTOFIX .GT. 0)  THEN  
         IF (LWARN) WRITE (ISYSWR,'(A/A)') ' MINUIT WARNING: ', 
     +   ' PARAMETER WAS FIXED, WILL BE FIXED AGAIN AFTER REDEFINITION' 
         IF (NINT .GE. MAXINT)  THEN    
            WRITE (ISYSWR,'(A)') ' CANNOT RELEASE. MAX NPAR EXCEEDED.'  
            GO TO 800   
            ENDIF   
         CALL MNFREE(-K)    
         ENDIF  
C                       if redefining previously variable parameter 
      IF(NIOFEX(K) .GT. 0) NINT = NPAR-1    
   50 CONTINUE  
      IF (WK .GT. 0.0)  GO TO 122   
C                                        . . .constant parameter . . . .    
      IF (ISW(5) .GE. 0)  WRITE (ISYSWR, 82)  K,CNAMK,UK    
   82 FORMAT (/'    NO.   NAME     VALUE (CONSTANT)'/   
     +           1X,I5,1X,1H',A10,1H',1X,G13.5) 
      NVL = 0   
      GO TO 200 
  122 IF (A.EQ.0. .AND. B.EQ.0.) THEN   
C                                      variable parameter without limits    
      NVL = 1   
      IF (ISW(5) .GE. 0)  WRITE (ISYSWR, 127)  K,CNAMK,UK,WK    
  127 FORMAT (/'    NO.   NAME         VALUE      STEP SIZE  '/ 
     +       1X,I5,1X,1H',A10,1H',1X,2G13.5)    
      ELSE  
C                                         variable parameter with limits    
      NVL = 4   
      IF (ISW(5) .GE. 0)  WRITE (ISYSWR, 132)  K,CNAMK,UK,WK,A,B    
  132 FORMAT ('0   NO.   NAME         VALUE      STEP SIZE      LIMITS'/    
     +       1X,I5,1X,1H',A10,1H',1X,2G13.5,2X,2G13.5)  
      ENDIF 
C                             . . request for another variable parameter    
      NINT = NINT + 1   
      IF (NINT .GT. MAXINT)  THEN   
         WRITE (ISYSWR,135)  MAXINT 
  135    FORMAT (/' MINUIT USER ERROR.   TOO MANY VARIABLE PARAMETERS.'/    
     +   ' THIS VERSION OF MINUIT DIMENSIONED FOR',I4//)    
         GO TO 800  
         ENDIF  
      IF (NVL .EQ. 1)  GO TO 200    
      IF (A .EQ. B)  THEN   
        WRITE (ISYSWR,'(/A,A/A/)') ' USER ERROR IN MINUIT PARAMETER',   
     +   ' DEFINITION',' UPPER AND LOWER LIMITS EQUAL.' 
        GO TO 800   
        ENDIF   
      IF (B .LT. A) THEN    
         SAV = B    
         B = A  
         A = SAV    
         IF (LWARN) WRITE (ISYSWR,'(A)')    
     +           ' MINUIT WARNING.  ABOVE LIMITS HAVE BEEN REVERSED.'   
         ENDIF  
      IF (LWARN .AND. ((B-A) .GT. 1.0E8)) WRITE (ISYSWR,151) K  
  151 FORMAT (' MINUIT WARNING.  LIMITS ON PARAMETER',I4,' ARE ',   
     +'TOO FAR APART'/' OR VALUE IS BADLY SCALED. EXPECT PROBLEMS.')    
      DANGER = (B-UK)*(UK-A)    
      IF (DANGER .LT. 0.)  WRITE (ISYSWR,'(A)') 
     +           ' MINUIT WARNING.  STARTING VALUE IS OUTSIDE LIMITS.'  
      IF (DANGER .EQ. 0.)  WRITE (ISYSWR,'(A)') 
     +           ' MINUIT WARNING.  PARAMETER VALUE IS AT LIMIT'    
  200 CONTINUE  
C                           . . . input OK, set values, arrange lists,  
C                                    calculate step sizes GSTEP, DIRIN  
      CFROM = 'PARAMETR'    
      CSTATU= 'NEW VALUES'  
      NU = MAX(NU,K)    
      CPNAM(K) = CNAMK  
      U(K) = UK 
      WERR(K) = WK  
      ALIM(K) = A   
      BLIM(K) = B   
      NVARL(K) = NVL    
      CALL MNRSET(1)    
C                             K is external number of new parameter 
C           LASTIN is the number of var. params with ext. param. no.< K 
      LASTIN = 0    
      DO 240 IX= 1, K-1 
      IF (NIOFEX(IX) .GT. 0)  LASTIN=LASTIN+1   
  240 CONTINUE  
C                 NINT is new number of variable params, NPAR is old    
      IF (NINT .EQ. NPAR)  GO TO 280    
      IF (NINT .GT. NPAR) THEN  
C                          insert new variable parameter in list    
         DO 260 IN= NPAR,LASTIN+1,-1    
         IX = NEXOFI(IN)    
         NIOFEX(IX) = IN+1  
         NEXOFI(IN+1)= IX   
         X    (IN+1) = X    (IN)    
         XT   (IN+1) = XT   (IN)    
         DIRIN(IN+1) = DIRIN(IN)    
         G2   (IN+1) = G2   (IN)    
         GSTEP(IN+1) = GSTEP(IN)    
  260    CONTINUE   
      ELSE  
C                          remove variable parameter from list  
         DO 270 IN= LASTIN+1,NINT   
         IX = NEXOFI(IN+1)  
         NIOFEX(IX) = IN    
         NEXOFI(IN)= IX 
         X     (IN)= X    (IN+1)    
         XT    (IN)= XT   (IN+1)    
         DIRIN (IN)= DIRIN(IN+1)    
         G2    (IN)= G2   (IN+1)    
         GSTEP (IN)= GSTEP(IN+1)    
  270    CONTINUE   
      ENDIF 
  280 CONTINUE  
      IX = K    
      NIOFEX(IX) = 0    
      NPAR = NINT   
C                                       lists are now arranged . . . .  
      IF (NVL .GT. 0)  THEN 
         IN = LASTIN+1  
         NEXOFI(IN) = IX    
         NIOFEX(IX) = IN    
         SAV = U(IX)    
         CALL MNPINT(SAV,IX,PINTI)  
         X(IN) = PINTI  
         XT(IN) = X(IN) 
         SAV2 = SAV + WERR(IX)  
         CALL MNPINT(SAV2,IX,PINTI) 
         VPLU = PINTI - X(IN)   
         SAV2 = SAV - WERR(IX)  
         CALL MNPINT(SAV2,IX,PINTI) 
         VMINU = PINTI - X(IN)  
         DIRIN(IN) = 0.5 * (ABS(VPLU) +ABS(VMINU))  
         G2(IN) = 2.0*UP / DIRIN(IN)**2 
         GSTEP(IN) = MAX (EPSMAC*ABS(X(IN)), 0.2*DIRIN(IN)) 
         GRD  (IN) = G2(IN)*DIRIN(IN)   
C                   if parameter has limits 
         IF (NVARL(K) .GT. 1) THEN  
            IF (GSTEP(IN).GT. 0.5)  GSTEP(IN)=0.5   
            GSTEP(IN) = -GSTEP(IN)  
         ENDIF  
      ENDIF 
      IF (KTOFIX .GT. 0)  THEN  
         KINFIX = NIOFEX(KTOFIX)    
         IF (KINFIX .GT. 0)  CALL MNFIXP(KINFIX)    
      ENDIF 
      RETURN    
C                   error on input, unable to implement request  . . . .    
  800 CONTINUE  
      IERFLG = 1    
      RETURN    
      END   
      SUBROUTINE MNPFIT(PARX2P,PARY2P,NPAR2P,COEF2P,SDEV2P) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
C   
C     to fit a parabola to npar2p points    
C   
C   npar2p   no. of points  
C   parx2p(i)   x value of point i  
C   pary2p(i)   y value of point i  
C   
C   coef2p(1...3)  coefficients of the fitted parabola  
C   y=coef2p(1) + coef2p(2)*x + coef2p(3)*x**2  
C   sdev2p= variance    
C   method : chi**2 = min equation solved explicitly    
      DIMENSION PARX2P(NPAR2P),PARY2P(NPAR2P),COEF2P(NPAR2P)    
      DIMENSION CZ(3)   
C   
      DO 3  I=1,3   
    3 CZ(I)=0.  
      SDEV2P=0. 
      IF(NPAR2P.LT.3) GO TO 10  
      F=NPAR2P  
C--- center x values for reasons of machine precision   
      XM=0. 
      DO 2  I=1,NPAR2P  
    2 XM=XM+PARX2P(I)   
      XM=XM/F   
      X2=0. 
      X3=0. 
      X4=0. 
      Y=0.  
      Y2=0. 
      XY=0. 
      X2Y=0.    
      DO 1  I=1,NPAR2P  
      S=PARX2P(I)-XM    
      T=PARY2P(I)   
      S2=S*S    
      X2=X2+S2  
      X3=X3+S*S2    
      X4=X4+S2*S2   
      Y=Y+T 
      Y2=Y2+T*T 
      XY=XY+S*T 
      X2Y=X2Y+S2*T  
    1 CONTINUE  
      A=(F*X4-X2**2)*X2-F*X3**2 
      IF(A.EQ.0.)  GOTO 10  
      CZ(3)=(X2*(F*X2Y-X2*Y)-F*X3*XY)/A 
      CZ(2)=(XY-X3*CZ(3))/X2    
      CZ(1)=(Y-X2*CZ(3))/F  
      IF(NPAR2P.EQ.3)  GOTO 6   
      SDEV2P=Y2-(CZ(1)*Y+CZ(2)*XY+CZ(3)*X2Y)    
      IF(SDEV2P.LT.0.)  SDEV2P=0.   
      SDEV2P=SDEV2P/(F-3.)  
    6 CZ(1)=CZ(1)+XM*(XM*CZ(3)-CZ(2))   
      CZ(2)=CZ(2)-2.*XM*CZ(3)   
   10 CONTINUE  
      DO 11  I=1,3  
   11 COEF2P(I)=CZ(I)   
      RETURN    
      END   
      SUBROUTINE MNPINT(PEXTI,I,PINTI)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Calculates the internal parameter value PINTI corresponding   
CC        to the external value PEXTI for parameter I.  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      LOGICAL LIMLOC    
      LIMLOC = .FALSE.  
      PINTI = PEXTI 
      IGO = NVARL(I)    
      IF (IGO .EQ. 4)  THEN 
C--                          there are two limits   
        ALIMI = ALIM(I) 
        BLIMI = BLIM(I) 
        IF (PEXTI .LE. ALIMI) THEN  
            A = VLIMLO  
            LIMLOC = .TRUE. 
        ELSE    
            IF (PEXTI .GE. BLIMI)  THEN 
               A = VLIMHI   
               LIMLOC = .TRUE.  
            ENDIF   
        ENDIF   
        IF (LIMLOC) THEN    
           PINTI = A    
           PEXTI = ALIMI + 0.5* (BLIMI-ALIMI) *(SIN(A) +1.0)    
           LIMSET = .TRUE.  
           IF (LWARN)  WRITE (ISYSWR,241)  I    
  241      FORMAT (' WARNING - VARIABLE',I3,' HAS BEEN BROUGHT BACK',   
     +           ' INSIDE LIMITS BY MNPINT.')   
        ELSE    
           YY=2.0*(PEXTI-ALIMI)/(BLIMI-ALIMI) - 1.0 
           PINTI = ATAN(YY/SQRT(1.0- YY**2) )   
        ENDIF   
      ENDIF 
      RETURN    
      END   
      SUBROUTINE MNPLOT(XPT,YPT,CHPT,NXYPT,NUNIT,NPAGWD,NPAGLN) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        plots points in array xypt onto one page with labelled axes   
CC        NXYPT is the number of points to be plotted   
CC        XPT(I) = x-coord. of ith point    
CC        YPT(I) = y-coord. of ith point    
CC        CHPT(I) = character to be plotted at this position    
CC        the input point arrays XPT, YPT, CHPT are destroyed.  
CC  
      DIMENSION   XPT(*), YPT(*), SAV(2)    
      CHARACTER*1 CHPT(*) ,  CHSAV,  CHBEST, CDOT, CSLASH, CBLANK   
      PARAMETER (MAXWID=100)    
      CHARACTER*100 CLINE   
      DIMENSION XVALUS(12)  
      LOGICAL OVERFL,OVERPR 
      DATA CDOT,CSLASH,CBLANK/ '.' , '/' , ' '/ 
      MAXNX = MIN(NPAGWD-20,MAXWID) 
      IF (MAXNX .LT. 10)  MAXNX = 10    
      MAXNY = NPAGLN    
      IF (MAXNY .LT. 10)  MAXNY = 10    
      IF (NXYPT .LE. 1)  RETURN 
      XBEST = XPT(1)    
      YBEST = YPT(1)    
      CHBEST = CHPT(1)  
C         order the points by decreasing y  
      KM1 = NXYPT - 1   
      DO 150 I= 1, KM1  
      IQUIT = 0 
      NI = NXYPT - I    
      DO 140 J= 1, NI   
      IF (YPT(J) .GT. YPT(J+1)) GO TO 140   
        SAVX = XPT(J)   
        XPT(J) = XPT(J+1)   
        XPT(J+1) = SAVX 
        SAVY = YPT(J)   
        YPT(J) = YPT(J+1)   
        YPT(J+1) = SAVY 
        CHSAV = CHPT(J) 
        CHPT(J) = CHPT(J+1) 
        CHPT(J+1) = CHSAV   
      IQUIT = 1 
  140 CONTINUE  
      IF (IQUIT .EQ. 0) GO TO 160   
  150 CONTINUE  
  160 CONTINUE  
C         find extreme values   
      XMAX = XPT(1) 
      XMIN = XMAX   
      DO 200 I= 1, NXYPT    
        IF (XPT(I) .GT. XMAX)  XMAX = XPT(I)    
        IF (XPT(I) .LT. XMIN)  XMIN = XPT(I)    
  200 CONTINUE  
      DXX = 0.001*(XMAX-XMIN)   
      XMAX = XMAX + DXX 
      XMIN = XMIN - DXX 
      CALL MNBINS(XMIN,XMAX,MAXNX,XMIN,XMAX,NX,BWIDX)   
      YMAX = YPT(1) 
      YMIN = YPT(NXYPT) 
      IF (YMAX .EQ. YMIN)  YMAX=YMIN+1.0    
      DYY = 0.001*(YMAX-YMIN)   
      YMAX = YMAX + DYY 
      YMIN = YMIN - DYY 
      CALL MNBINS(YMIN,YMAX,MAXNY,YMIN,YMAX,NY,BWIDY)   
      ANY = NY  
C         if first point is blank, it is an 'origin'    
      IF (CHBEST .EQ. CBLANK)  GO TO 50 
      XBEST = 0.5 * (XMAX+XMIN) 
      YBEST = 0.5 * (YMAX+YMIN) 
   50 CONTINUE  
C         find scale constants  
      AX = 1.0/BWIDX    
      AY = 1.0/BWIDY    
      BX = -AX*XMIN + 2.0   
      BY = -AY*YMIN - 2.0   
C         convert points to grid positions  
      DO 300 I= 1, NXYPT    
      XPT(I) = AX*XPT(I) + BX   
  300 YPT(I) = ANY-AY*YPT(I) - BY   
      NXBEST = AX*XBEST + BX    
      NYBEST = ANY  - AY*YBEST - BY 
C         print the points  
      NY = NY + 2   
      NX = NX + 2   
      ISP1 = 1  
      LINODD = 1    
      OVERPR=.FALSE.    
      DO 400 I= 1, NY   
      DO 310 IBK= 1, NX 
  310 CLINE (IBK:IBK) = CBLANK  
      CLINE(1:1) = CDOT 
      CLINE(NX:NX) = CDOT   
      CLINE(NXBEST:NXBEST) = CDOT   
      IF (I.NE.1 .AND. I.NE.NYBEST .AND. I.NE.NY)  GO TO 320    
      DO 315 J= 1, NX   
  315 CLINE(J:J) = CDOT 
  320 CONTINUE  
      YPRT = YMAX - FLOAT(I-1)*BWIDY    
      IF (ISP1 .GT. NXYPT)  GO TO 350   
  325 OVERFL = .FALSE.  
C         find the points to be plotted on this line    
        DO 340 K= ISP1,NXYPT    
      KS = YPT(K)   
      IF (KS .GT. I)  GO TO 345 
      IX = XPT(K)   
      IF (CLINE(IX:IX) .EQ.   CDOT)  GO TO 340  
      IF (CLINE(IX:IX) .EQ. CBLANK)  GO TO 340  
      IF (CLINE(IX:IX) .EQ.CHPT(K))  GO TO 340  
      OVERFL = .TRUE.   
      GO TO 345 
  340 CLINE(IX:IX) = CHPT(K)    
        ISP1 = NXYPT + 1    
        GO TO 350   
  345   ISP1 = K    
  350 CONTINUE  
      IF (OVERPR)  GO TO 390    
      IF (LINODD .EQ. 1 .OR. I .EQ. NY)  GO TO 380  
      LINODD = 1    
      WRITE (NUNIT, 1007)       CLINE(:NX)  
      GO TO 395 
  380 WRITE (NUNIT, 1001) YPRT, CLINE(:NX)  
      LINODD = 0    
      GO TO 395 
  390 WRITE (NUNIT, 1005)  CLINE(:NX)   
C         0verpr is true if the following line is to be overprinted 
C         overfl is true if points remain to be plotted on this line    
  395 OVERPR = OVERFL   
      IF (.NOT. OVERFL)  GO TO 400  
      DO 398 IBK= 1, NX 
  398 CLINE(IBK:IBK) = CBLANK   
      GO TO 325 
  400 CONTINUE  
C         print labels on x-axis every ten columns  
      DO 410 IBK= 1, NX 
      CLINE(IBK:IBK) = CBLANK   
      IF (MOD(IBK,10) .EQ. 1)  CLINE(IBK:IBK) = CSLASH  
  410 CONTINUE  
      WRITE (NUNIT, 1007)       CLINE(:NX)  
C   
      DO 430 IBK= 1, 12 
  430 XVALUS(IBK) = XMIN + FLOAT(IBK-1)*10.*BWIDX   
      ITEN = (NX+9) / 10    
      WRITE (NUNIT,1004)  (XVALUS(IBK), IBK=1,ITEN) 
      WRITE (NUNIT,1002)  BWIDX 
  500 RETURN    
 1001 FORMAT (1X,G14.7,' ..',A) 
 1002 FORMAT (40X,13HONE COLUMN =   ,G13.7) 
 1003 FORMAT (5X,A10)   
 1004 FORMAT (12X,12G10.4)  
 1005 FORMAT (18H overprint         ,A) 
 1007 FORMAT (18X,A)    
      END   
      SUBROUTINE MNPOUT(IEXT,CHNAM,VAL,ERR,XLOLIM,XUPLIM,IINT)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC     User-called  
CC     Provides the user with information concerning the current status 
CC          of parameter number IEXT. Namely, it returns:   
CC        CHNAM: the name of the parameter  
CC        VAL: the current (external) value of the parameter    
CC        ERR: the current estimate of the parameter uncertainty    
CC        XLOLIM: the lower bound (or zero if no limits)    
CC        XUPLIM: the upper bound (or zero if no limits)    
CC        IINT: the internal parameter number (or zero if not variable) 
CC     Except for IINT, this is exactly the inverse of MNPARM   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      CHARACTER*(*) CHNAM   
      CHNAM = CPNAM(IEXT)   
      VAL = U(IEXT) 
      XLOLIM = 0.   
      XUPLIM = 0.   
      IINT = NIOFEX(IEXT)   
C             calculate parameter error from covariance matrix if any   
      ERR = 0.  
      IF (IINT .GT. 0) THEN 
         IF (ISW(2) .GE. 1) THEN    
           DX = SQRT(ABS(V(IINT,IINT)*UP))  
           IF (NVARL(IEXT) .GT. 1)  THEN    
             XLOLIM = ALIM(IEXT)    
             XUPLIM = BLIM(IEXT)    
             AL = ALIM(IEXT)    
             BA = BLIM(IEXT) - AL   
             DU1 = AL + 0.5 *(SIN(X(IINT)+DX) +1.0) * BA - U(IEXT)  
             DU2 = AL + 0.5 *(SIN(X(IINT)-DX) +1.0) * BA - U(IEXT)  
             IF (DX .GT. 1.0)  DU1 = BA 
             DX = 0.5 * (ABS(DU1) + ABS(DU2))   
           ENDIF    
           WERR(IEXT) = DX  
         ENDIF  
         ERR = WERR(IEXT)   
      ENDIF 
      RETURN    
      END   
      SUBROUTINE MNPRIN  (INKODE,FVAL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Prints the values of the parameters at the time of the call.  
CC        also prints other relevant information such as function value,    
CC        estimated distance to minimum, parameter errors, step sizes.  
CC  
C         According to the value of IKODE, the printout is: 
C    IKODE=INKODE= 0    only info about function value  
C                  1    parameter values, errors, limits    
C                  2    values, errors, step sizes, internal values 
C                  3    values, errors, step sizes, first derivs.   
C                  4    values, parabolic errors, MINOS errors  
C    when INKODE=5, MNPRIN chooses IKODE=1,2, or 3, according to ISW(2) 
C   
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C   
      CHARACTER*14 COLHDU(6),COLHDL(6)  
C                  get value of IKODE based in INKODE, ISW(2)   
      IKODE = INKODE    
      IF (INKODE .EQ. 5) THEN   
         IKODE = ISW(2)+1   
         IF (IKODE .GT. 3)  IKODE=3 
      ENDIF 
C                  set 'default' column headings    
      DO 5 K= 1, 6  
      COLHDU(K) = 'UNDEFINED'   
    5 COLHDL(K) = 'COLUMN HEAD' 
C   
C              report function value and status 
      IF (FVAL .EQ. UNDEFI) THEN    
         WRITE (ISYSWR,'(A)') '0FUNCTION VALUE IS UNKNOWN.' 
      ELSE  
         WRITE (ISYSWR,905)  FVAL,CFROM,CSTATU,NFCN,EDM 
  905 FORMAT (/' FCN=',G15.7,' FROM ',A8,'  STATUS=',A10,' CALLS=',I5,  
     +        ' EDM=',E10.2)    
         IF (CFROM .EQ. 'MIGRAD  ' .OR. 
     +       CFROM .EQ. 'MINOS   ' .OR. 
     +       CFROM .EQ. 'HESSE   ') WRITE (ISYSWR,907) ISTRAT,UP    
  907 FORMAT (21X,'STRATEGY=',I2,'    ERROR DEF=',F10.4)    
      ENDIF 
C   
      IF (IKODE .EQ. 0)  GO TO 700  
      IF (NU .EQ. 0)  THEN  
       WRITE (ISYSWR,'(A)') ' THERE ARE CURRENTLY NO PARAMETERS DEFINED'    
       GO TO 700    
      ENDIF 
      IF (IKODE .EQ. 1)  THEN   
         COLHDU(1) = '              '   
         COLHDL(1) = '      ERROR   '   
         COLHDU(2) = '      PHYSICAL'   
         COLHDU(3) = ' LIMITS       '   
         COLHDL(2) = '    NEGATIVE  '   
         COLHDL(3) = '    POSITIVE  '   
      ENDIF 
      IF (IKODE .EQ. 2)  THEN   
         COLHDU(1) = '              '   
         COLHDL(1) = '      ERROR   '   
         COLHDU(2) = '    INTERNAL  '   
         COLHDL(2) = '    STEP SIZE '   
         COLHDU(3) = '    INTERNAL  '   
         COLHDL(3) = '      VALUE   '   
      ENDIF 
      IF (IKODE .EQ. 3)  THEN   
         COLHDU(1) = '              '   
         COLHDL(1) = '      ERROR   '   
         COLHDU(2) = '       STEP   '   
         COLHDL(2) = '       SIZE   '   
         COLHDU(3) = '      FIRST   '   
         COLHDL(3) = '   DERIVATIVE '   
      ENDIF 
      IF (IKODE .EQ. 4)  THEN   
         COLHDU(1) = '    PARABOLIC '   
         COLHDL(1) = '      ERROR   '   
         COLHDU(2) = '        MINOS '   
         COLHDU(3) = 'ERRORS        '   
         COLHDL(2) = '   NEGATIVE   '   
         COLHDL(3) = '   POSITIVE   '   
      ENDIF 
C   
      IF (IKODE .NE. 4)  THEN   
         IF (ISW(2) .LT. 2) COLHDU(1)=' CURRENT GUESS'  
         IF (ISW(2) .EQ. 2) COLHDU(1)='  APPROXIMATE '  
      ENDIF 
      NCOL = 3  
      WRITE (ISYSWR, 910) (COLHDU(KK),KK=1,NCOL)    
      WRITE (ISYSWR, 911) (COLHDL(KK),KK=1,NCOL)    
  910 FORMAT (/' INT EXT  PARAMETER ',     13X       ,6A14) 
  911 FORMAT ( ' NO. NO.    NAME    ','    VALUE    ',6A14) 
C   
C                                        . . . loop over parameters . . 
      DO 200 I= 1, NU   
      IF (NVARL(I) .LT. 0)  GO TO 200   
      L = NIOFEX(I) 
      IF (L .EQ. 0)  GO TO 55   
C              variable parameter.  calculate external error if v exists    
      IF (ISW(2) .GE. 1) THEN   
        DX = SQRT(ABS(V(L,L)*UP))   
        IF (NVARL(I) .GT. 1)  THEN  
          AL = ALIM(I)  
          BA = BLIM(I) - AL 
          DU1 = AL + 0.5 *(SIN(X(L)+DX) +1.0) * BA - U(I)   
          DU2 = AL + 0.5 *(SIN(X(L)-DX) +1.0) * BA - U(I)   
          IF (DX .GT. 1.0)  DU1 = BA    
          DX = 0.5 * (ABS(DU1) + ABS(DU2))  
        ENDIF   
        WERR(I) = DX    
      ENDIF 
      X1 = WERR(I)  
      IF (IKODE .EQ. 1) THEN    
         IF (NVARL(I) .LE. 1) THEN  
            WRITE (ISYSWR, 952)  L,I,CPNAM(I),U(I),X1   
            GO TO 200   
         ELSE   
         X2 = ALIM(I)   
         X3 = BLIM(I)   
         ENDIF  
      ENDIF 
      IF (IKODE .EQ. 2) THEN    
         X2 = DIRIN(L)  
         X3 = X(L)  
      ENDIF 
      IF (IKODE .EQ. 3) THEN    
         X2 = DIRIN(L)  
         X3 = GRD(L)    
      ENDIF 
      IF (IKODE .EQ. 4) THEN    
         X2 = ERN(I)    
         X3 = ERP(I)    
      ENDIF 
      WRITE (ISYSWR,952)   L,I,CPNAM(I),U(I),X1,X2,X3   
  952 FORMAT (I4,I3,2X,A10,6G14.5)  
C               check if parameter is at limit  
      IF (NVARL(I) .LE. 1)  GO TO 200   
      IF (ABS(COS(X(L))) .LT. 0.001)  WRITE (ISYSWR,1004)   
 1004 FORMAT (1H ,32X,42HWARNING -   - ABOVE PARAMETER IS AT LIMIT.)    
      GO TO 200 
C   
C                                print constant or fixed parameter. 
   55 CONTINUE  
                          COLHDU(1) = '   constant   '  
      IF (NVARL(I).GT.0)  COLHDU(1) = '     fixed    '  
      IF (NVARL(I).EQ.4 .AND. IKODE.EQ.1) THEN  
        WRITE (ISYSWR,'(I7,2X,A10,G14.5,A,2G14.5)') 
     +     I,CPNAM(I),U(I),COLHDU(1),ALIM(I),BLIM(I)    
      ELSE  
        WRITE (ISYSWR,'(I7,2X,A10,G14.5,A)')  I,CPNAM(I),U(I),COLHDU(1) 
      ENDIF 
  200 CONTINUE  
C   
  700 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNPSDF 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        calculates the eigenvalues of v to see if positive-def.   
CC        if not, adds constant along diagonal to make positive.    
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EPSMIN = 1.0E-6   
      EPSPDF = MIN(EPSMIN, EPSMAC)  
      DO 213 I= 1, NPAR 
      DO 213 J= 1, NPAR 
  213 P(I,J) = V(I,J)   
C      call eigen (p,p,maxint,npar,pstar,-npar) 
      CALL MNEIG(P,MAXINT,NPAR,MAXINT,PSTAR,EPSMAC,IFAULT)  
      PMIN = PSTAR(1)   
      PMAX = PSTAR(1)   
      DO 215 IP= 2, NPAR    
      IF (PSTAR(IP) .LT. PMIN)  PMIN = PSTAR(IP)    
      IF (PSTAR(IP) .GT. PMAX)  PMAX = PSTAR(IP)    
  215 CONTINUE  
      ONE = 1.0 
      PMAX = MAX(ABS(PMAX), ONE)    
      IF (PMIN .LE. 0.0  .OR.  ISW(5) .GE. 3)   
     X         WRITE (ISYSWR,550) (PSTAR(IP),IP=1,NPAR) 
      IF (PMIN .GT. EPSPDF*PMAX)  GO TO 217 
      IF (ISW(2) .EQ. 3)  ISW(2)=2  
      PADD = 1.0E-3*PMAX - PMIN 
      DO 216 IP= 1, NPAR    
  216 V(IP,IP) = V(IP,IP) + PADD    
      CSTATU= 'NOT POSDEF'  
      IF (LWARN)  THEN  
         WRITE (ISYSWR, 530)    
         WRITE (ISYSWR, 560)  PADD  
      ENDIF 
  217 CONTINUE  
C   
  530 FORMAT (' MINUIT COVARIANCE MATRIX NOT POSITIVE-DEFINITE.' )  
  550 FORMAT (41H EIGENVALUES OF SECOND-DERIVATIVE MATRIX: /(10E12.4))  
  560 FORMAT (32H MATRIX FORCED POS-DEF BY ADDING,E12.5,12H TO DIAGONAL)    
      RETURN    
      END   
      SUBROUTINE MNRAZZ(YNEW,PNEW,Y,JH,JL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called only by MNSIMP (and MNIMPR) to add a new point 
CC        and remove an old one from the current simplex, and get the   
CC        estimated distance to minimum.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION PNEW(*), Y(*)   
      DO 10 I=1,NPAR    
   10 P(I,JH) = PNEW(I) 
      Y(JH)=YNEW    
      IF(YNEW .LT. AMIN) THEN   
        DO 15 I=1,NPAR  
   15   X(I) = PNEW(I)  
        CALL MNINEX(X)  
        AMIN = YNEW 
        CSTATU = 'PROGRESS  '   
        JL=JH   
      ENDIF 
      JH = 1    
      NPARP1 = NPAR+1   
   20 DO 25 J=2,NPARP1  
      IF (Y(J) .GT. Y(JH))  JH = J  
   25 CONTINUE  
      EDM = Y(JH) - Y(JL)   
      IF (EDM .LE. 0.)  GO TO 45    
      US = 1.0/EDM  
      DO 35 I= 1, NPAR  
      PBIG = P(I,1) 
      PLIT = PBIG   
      DO 30 J= 2, NPARP1    
      IF (P(I,J) .GT. PBIG)  PBIG = P(I,J)  
      IF (P(I,J) .LT. PLIT)  PLIT = P(I,J)  
   30 CONTINUE  
      DIRIN(I) = PBIG - PLIT    
      IF (ITAUR .LT. 1)  V(I,I) = 0.5*(V(I,I) +US*DIRIN(I)**2)  
   35 CONTINUE  
   40 RETURN    
   45 WRITE (ISYSWR, 1000)  NPAR    
      GO TO 40  
 1000 FORMAT ('   FUNCTION VALUE DOES NOT SEEM TO DEPEND ON ANY OF THE',    
     +    I3,' VARIABLE PARAMETERS.' /10X,'VERIFY THAT STEP SIZES ARE', 
     +    ' BIG ENOUGH AND CHECK FCN LOGIC.'/1X,79(1H*)/1X,79(1H*)/)    
      END   
      SUBROUTINE MNREAD(FCN,IFLGIN,IFLGUT,FUTIL)    
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called from MINUIT.  Reads all user input to MINUIT.  
CC     This routine is highly unstructured and defies normal logic. 
CC  
CC     IFLGIN indicates the function originally requested:  
CC           = 1: read one-line title   
CC             2: read parameter definitions    
CC             3: read MINUIT commands  
CC  
CC     IFLGUT= 1: reading terminated normally   
CC             2: end-of-data on input  
CC             3: unrecoverable read error  
CC             4: unable to process parameter requests  
CC internally,  
CC     IFLGDO indicates the subfunction to be performed on the next 
CC         input record: 1: read a one-line title   
CC                       2: read a parameter definition 
CC                       3: read a command  
CC                       4: read in covariance matrix   
CC     for example, when IFLGIN=3, but IFLGDO=1, then it should read    
CC       a title, but this was requested by a command, not by MINUIT.   
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      PARAMETER (MAXP=7)    
      DIMENSION PLIST(MAXP) 
      CHARACTER CNAMK*10, CRDBUF*80, CELMNT*20  
      CHARACTER COMAND*10   
      CHARACTER CPROMT(3)*40, CLOWER*26, CUPPER*26  
      DATA CPROMT/' ENTER MINUIT TITLE, or "SET INPUT n" : ',   
     +            ' ENTER MINUIT PARAMETER DEFINITION:     ',   
     +            ' ENTER MINUIT COMMAND:                  '/   
C   
      DATA CLOWER/'abcdefghijklmnopqrstuvwxyz'/ 
      DATA CUPPER/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/ 
C   
      IFLGUT = 1    
      IFLGDO = IFLGIN   
      IFATAL = 0    
C                                           . . . . read next record    
   10 CONTINUE  
      IF (ISW(6) .EQ. 1) WRITE (ISYSWR,'(A)') CPROMT(IFLGDO)    
      READ (ISYSRD,'(A)',ERR=500,END=45)  CRDBUF    
C                                           . .   preemptive commands   
      IF (INDEX(CRDBUF,'*EOF') .EQ. 1 .OR.  
     +    INDEX(CRDBUF,'*eof') .EQ. 1)    THEN  
         WRITE (ISYSWR,'(A,I3)') ' *EOF ENCOUNTERED ON UNIT NO.',ISYSRD 
         GO TO 50   
         ENDIF  
      IF (INDEX(CRDBUF,'SET INP') .EQ. 1 .OR.   
     +    INDEX(CRDBUF,'set inp') .EQ. 1)    THEN   
         ICOMND = ICOMND + 1    
         WRITE (ISYSWR, 21) ICOMND,CRDBUF(1:50) 
   21    FORMAT (' **********'/' ***',I3,'****',A/' **********')    
         GO TO 50   
         ENDIF  
      GO TO 80  
C                                    . . hardware EOF on current ISYSRD 
   45 CRDBUF = '*EOF '  
      WRITE (ISYSWR,'(A,I3)') ' END OF DATA ON UNIT NO.',ISYSRD 
C                                     or SET INPUT command  
   50 CONTINUE  
         CALL MNSTIN(CRDBUF,IERR)   
         IF (IERR .EQ. 0)  GO TO 10 
         IFLGUT = IERR  
         GO TO 900  
   80 IF (IFLGDO .GT. 1) GO TO 100  
C                            read title        . . . . .   IFLGDO = 1   
C              if title is 'SET TITLE', skip and read again 
      IF (INDEX(CRDBUF,'SET TIT') .EQ. 1)  GO TO 10 
      IF (INDEX(CRDBUF,'set tit') .EQ. 1)  GO TO 10 
      CTITL = CRDBUF(1:50)  
      WRITE (ISYSWR,'(1X,A50)')  CTITL  
      WRITE (ISYSWR,'(1X,78(1H*))') 
      IF (IFLGIN .EQ. IFLGDO)  GO TO 900    
      IFLGDO = IFLGIN   
      GO TO 10  
C                            data record is not a title. get upper case 
  100 CONTINUE  
      DO 110 I= 1, 10   
      IF (CRDBUF(I:I) .EQ. '''') GO TO 111  
         DO 108 IC= 1, 26   
         IF (CRDBUF(I:I) .EQ. CLOWER(IC:IC)) CRDBUF(I:I)=CUPPER(IC:IC)  
  108    CONTINUE   
  110 CONTINUE  
  111 CONTINUE  
C                            read parameter definitions.   IFLGDO = 2   
      IF (IFLGDO .GT. 2)  GO TO 300 
C              if parameter def is 'PARAMETER', skip and read again 
      IF (INDEX(CRDBUF,'PAR') .EQ. 1)  GO TO 10 
C              if line starts with SET TITLE, read a title first    
      IF (INDEX(CRDBUF,'SET TIT') .EQ. 1)  THEN 
         IFLGDO = 1 
         GO TO 10   
         ENDIF  
C              find out whether fixed or free-field format  
      KAPO1 = INDEX(CRDBUF,'''')    
      IF (KAPO1 .EQ. 0)  GO TO 150  
      KAPO2 = INDEX(CRDBUF(KAPO1+1:),'''')  
      IF (KAPO2 .EQ. 0)  GO TO 150  
C          new (free-field) format  
      KAPO2 = KAPO2 + KAPO1 
C                             skip leading blanks if any    
         DO 115 ISTART=1, KAPO1-1   
         IF (CRDBUF(ISTART:ISTART) .NE. ' ')  GO TO 120 
  115    CONTINUE   
         ISTART = KAPO1-1   
  120 CONTINUE  
C                               parameter number integer    
      IF (ISTART .LT. 1)  GO TO 210 
      CELMNT = CRDBUF(ISTART:KAPO1-1)   
      READ (CELMNT,'(BN,F20.0)',ERR=180) FK 
      K = FK    
      IF (K .EQ. 0)  GO TO 210  
      CNAMK = 'PARAM '//CELMNT  
      IF (KAPO2-KAPO1 .GT. 1) CNAMK = CRDBUF(KAPO1+1:KAPO2-1)   
      CALL MNCRCK(CRDBUF(KAPO2+1:),MAXP,COMAND,PLIST,LLIST,IERR,ISYSWR) 
      IF (IERR .GT. 0)  GO TO 180   
      UK = PLIST(1) 
      WK = 0.   
      IF (LLIST .GE. 2)  WK = PLIST(2)  
      A = 0.    
      IF (LLIST .GE. 3)  A = PLIST(3)   
      B = 0.    
      IF (LLIST .GE. 4)  B = PLIST(4)   
      GO TO 170 
C          old (fixed-field) format 
  150 CONTINUE  
      READ (CRDBUF, 158,ERR=180) XK,CNAMK,UK,WK,A,B    
  158 FORMAT (BN,F10.0, A10, 4F10.0)    
C     XK=XK*1E+10
      K = XK    
      IF (K .EQ. 0)  GO TO 210  
C          parameter format cracked, implement parameter definition 
  170 CALL MNPARM(K,CNAMK,UK,WK,A,B,IERR)   
      IF (IERR .EQ. 0)  GO TO 10    
C          format error 
  180 CONTINUE  
      IF (ISW(6) .EQ. 1)  THEN  
          WRITE (ISYSWR,'(A)') ' FORMAT ERROR.  IGNORED.  ENTER AGAIN.' 
      ELSE  
          WRITE (ISYSWR,'(A)') ' ERROR IN PARAMETER DEFINITION' 
          IFATAL = IFATAL + 1   
      ENDIF 
      GO TO 10  
C                                       . . . end parameter requests    
  210 WRITE (ISYSWR,'(4X,75(1H*))') 
      IF (IFATAL.GT.0 .AND. ISW(6).NE.1)  THEN  
         IFLGUT = 4 
         GO TO 900  
      ENDIF 
      IF (IFLGIN .EQ. IFLGDO)  GO TO 900    
      NPARX = NPAR  
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FNEW,U,4,FUTIL)    
      NFCN = NFCN+1 
      AMIN = FNEW   
      CALL MNPRIN(1,AMIN)   
      IFLGDO = IFLGIN   
      GO TO 10  
C                                              . . . . .   IFLGDO = 3   
C                                           read commands   
  300 CONTINUE  
C               crack the next command . . . . . . . . . . . . . . . .  
         DO 350 IPOS= 1, 80 
         IF (CRDBUF(IPOS:IPOS) .NE. ' ') GO TO 355  
  350    CONTINUE   
      WRITE (ISYSWR,'(A)') ' BLANK COMMAND IGNORED.'    
      GO TO 10  
  355 IBEGIN = IPOS 
      CALL MNCRCK(CRDBUF(IBEGIN:),MAXP,COMAND,PLIST,LLIST,IERR,ISYSWR)  
      IF (IERR .GT. 0) THEN 
         IF (ISW(6) .EQ. 1) THEN    
            WRITE (ISYSWR,'(A)') ' COMMAND IGNORED '    
            GO TO 10    
         ELSE   
            WRITE (ISYSWR,'(A)') ' COMMAND CANNOT BE INTERPRETED'   
            GO TO 500   
         ENDIF  
      ENDIF 
C                    certain commands are trapped here already  
         IF (INDEX(COMAND,'PAR' ) .EQ. 1)  GO TO 440    
             IF (INDEX(COMAND,'SET') .NE. 1)  GO TO 370 
             IF (INDEX(COMAND,'COV') .EQ. 5)  GO TO 400 
             IF (INDEX(COMAND,'TIT') .EQ. 5)  GO TO 460 
  370 CONTINUE  
      CALL MNEXCM(FCN,COMAND,PLIST,LLIST,IERR,FUTIL)    
         IF (COMAND(1:3).EQ.'END')  GO TO 900   
         IF (COMAND(1:3).EQ.'EXI')  GO TO 900   
         IF (COMAND(1:3).EQ.'RET')  GO TO 900   
         IF (COMAND(1:3).EQ.'STO')  GO TO 900   
      GO TO 10  
C                                        . . . . . . . . . . set covar  
  400 NRAPE = PLIST(1)  
      ICOMND = ICOMND + 1   
      WRITE (ISYSWR,405) ICOMND,COMAND,(PLIST(I),I=1,LLIST) 
  405 FORMAT (1H ,10(1H*)/1H ,3H*** ,I3,4H****,A10,7G13.5/21X,7G13.5)   
      WRITE (ISYSWR, '(1H ,10(1H*))' )  
      IF (NRAPE .NE. NPAR)  GO TO 425   
      READ (ISYSRD,420,ERR=500,END=45)  ((V(I,J),I=1,J),J=1,NRAPE)  
  420 FORMAT (BN,7E11.4,3X) 
      ISW(2) = 3    
      IF (ISW(5) .GE. 0)  CALL MNMATU(1)    
      IF (ISW(5) .GE. 1)  CALL MNPRIN(2,AMIN)   
      GO TO 10  
  425 CONTINUE  
      WRITE (ISYSWR,428)    
  428 FORMAT(' SIZE OF COVARIANCE MATRIX TO BE READ DOES NOT',  
     + ' CORRESPOND TO'/' NUMBER OF CURRENTLY VARIABLE PARAMETERS.',    
     + '    COMMAND IGNORED.'/) 
      READ (ISYSRD,420,ERR=500,END=45)  ((DUMMY,I=1,J),J=1,NRAPE)   
      GO TO 10  
C                                           . . . . . PARAMETER command 
  440 CONTINUE  
      IFLGDO = 2    
      IFATAL = 0    
C        go and read parameter definitions  
      GO TO 10  
C                                              . . . . set title    
  460 CONTINUE  
      IFLGDO = 1    
      GO TO 10  
C                                              . . . . error conditions 
  500 IFLGUT = 3    
  900 RETURN    
      END   
      SUBROUTINE MNRN15(VAL,INSEED) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
C         This is a super-portable random number generator. 
C         It should not overflow on any 32-bit machine. 
C         The cycle is only ~10**9, so use with care!   
C         Note especially that VAL must not be undefined on input.  
C                    Set Default Starting Seed  
      DATA ISEED/12345/ 
      IF (VAL .EQ. 3.00)  GO TO 100 
C   
      INSEED = ISEED    
      K = ISEED/53668   
      ISEED = 40014*(ISEED-K*53668) - K*12211   
      IF (ISEED .LT. 0) ISEED = ISEED + 2147483563  
      VAL = REAL(ISEED) * 4.656613E-10  
      RETURN    
C               "entry" to set seed, flag is VAL=3. 
  100 ISEED = INSEED    
      RETURN    
      END   
      SUBROUTINE MNRSET(IOPT)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called from MNCLER and whenever problem changes   
CC    If IOPT=1,    
CC        Resets function value and errors to UNDEFINED 
CC    If IOPT=0, sets only MINOS errors to undefined    
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      IF (IOPT .GT. 0)  THEN    
        AMIN = UNDEFI   
        FVAL3 = 2.0*ABS(AMIN) + 1.  
        EDM = 1.0E5*UP  
        ISW(1) = 0  
        ISW(2) = 0  
      ENDIF 
      DO 10 I= 1, NU    
      ERP(I) = 0.0  
      ERN(I) = 0.0  
   10 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNSAVE 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       Writes current parameter values and step sizes onto file ISYSSA    
CC          in format which can be reread by Minuit for restarting. 
CC       The covariance matrix is also output if it exists. 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION VC(7)   
      LOGICAL LOPEN,LNAME   
      CHARACTER CGNAME*64, CFNAME*64, CANSWR*1  
C   
      INQUIRE(UNIT=ISYSSA,OPENED=LOPEN,NAMED=LNAME,NAME=CGNAME) 
      IF (LOPEN) THEN   
         IF (.NOT.LNAME) CGNAME='UNNAMED FILE'  
         WRITE (ISYSWR,32) ISYSSA,CGNAME    
   32    FORMAT (' CURRENT VALUES WILL BE SAVED ON UNIT',I3,': ',A/)    
      ELSE  
C                new file, open it  
         WRITE (ISYSWR,35) ISYSSA   
   35    FORMAT (' UNIT',I3,' IS NOT OPENED.')  
         IF (ISW(6) .EQ. 1) THEN    
            WRITE (ISYSWR,'(A)') ' PLEASE GIVE FILE NAME:'  
            READ (ISYSRD,'(A)') CFNAME  
            OPEN (UNIT=ISYSSA,FILE=CFNAME,STATUS='NEW',ERR=600) 
            CGNAME = CFNAME 
         ELSE   
            GO TO 650   
         ENDIF  
      ENDIF 
C                               file is now correctly opened    
      IF (ISW(6) .EQ. 1)  THEN  
         WRITE (ISYSWR,37)  ISYSSA  
   37    FORMAT (' SHOULD UNIT',I3,' BE REWOUND BEFORE WRITING TO IT?' )    
         READ  (ISYSRD,'(A)')  CANSWR   
         IF (CANSWR.EQ.'Y' .OR. CANSWR.EQ.'y') REWIND ISYSSA    
      ENDIF 
C                               and rewound if requested    
      WRITE (ISYSSA,'(10HSET TITLE )',ERR=700)  
      WRITE (ISYSSA,'(A)')  CTITL   
      WRITE (ISYSSA,'(10HPARAMETERS)')  
      NLINES = 3    
C                                write out parameter values 
      DO 200 I= 1, NU   
      IF (NVARL(I) .LT. 0)  GO TO 200   
      NLINES = NLINES + 1   
      IF (NVARL(I) .GT. 1)  GO TO 100   
C         parameter without limits  
      WRITE (ISYSSA,1001)  I,CPNAM(I),U(I),WERR(I)  
      GO TO 200 
C         parameter with limits 
  100 CONTINUE  
      WRITE (ISYSSA,1001) I,CPNAM(I),U(I),WERR(I),ALIM(I),BLIM(I)   
 1001 FORMAT (1X,I5,1H',A10,1H',4E12.5) 
  200 CONTINUE  
      WRITE (ISYSSA,'(A)')  ' ' 
      NLINES = NLINES + 1   
C                                  write out covariance matrix, if any  
      IF (ISW(2) .LT. 1)  GO TO 750 
      WRITE (ISYSSA,1003,ERR=700)  NPAR 
 1003 FORMAT ('SET COVARIANCE',I6)  
      WRITE (ISYSSA,1004) ((V(I,J),I=1,J),J=1,NPAR) 
 1004 FORMAT (BN,7E11.4,3X) 
      NEL = (NPAR*(NPAR+1))/2   
      NCOVAR = NEL/7 + 1    
      IF (MOD(NEL,7) .GT. 0)  NCOVAR = NCOVAR + 1   
      NLINES = NLINES + NCOVAR  
      WRITE (ISYSWR, 501) NLINES,ISYSSA,CGNAME(1:45)    
  501 FORMAT (1X,I5,' RECORDS WRITTEN TO UNIT',I4,':',A)    
      IF (NCOVAR .GT. 0) WRITE (ISYSWR, 502) NCOVAR 
  502 FORMAT (' INCLUDING',I5,' RECORDS FOR THE COVARIANCE MATRIX.'/)   
      GO TO 900 
C                                           some error conditions   
  600 WRITE (ISYSWR,'(A,I4)') ' I/O ERROR: UNABLE TO OPEN UNIT',ISYSSA  
      GO TO 900 
  650 WRITE (ISYSWR,'(A,I4,A)') ' UNIT',ISYSSA,' IS NOT OPENED.'    
      GO TO 900 
  700 WRITE (ISYSWR,'(A,I4)') ' ERROR: UNABLE TO WRITE TO UNIT',ISYSSA  
      GO TO 900 
  750 WRITE (ISYSWR,'(A)') ' THERE IS NO COVARIANCE MATRIX TO SAVE.'    
C   
  900 RETURN    
      END   
      SUBROUTINE MNSCAN(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Scans the values of FCN as a function of one parameter    
CC        and plots the resulting values as a curve using MNPLOT.   
CC        It may be called to scan one parameter or all parameters. 
CC        retains the best function and parameter values found. 
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION XPT(101), YPT(101)  
      CHARACTER*1 CHPT(101), CSTAR,CSYMX    
      DATA CSTAR,CSYMX/ '*' , 'X' / 
      XLREQ = MIN(WORD7(3),WORD7(4))    
      XHREQ = MAX(WORD7(3),WORD7(4))    
      NCALL = WORD7(2) + 0.01   
      IF (NCALL .LE. 1)  NCALL = 41 
      IF (NCALL .GT. 100)  NCALL = 100  
      NCCALL = NCALL    
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      IPARWD = WORD7(1) + 0.1   
      IPAR = MAX0(IPARWD, 0)    
      IF (IPARWD .GT. 0)  GO TO 200 
C   
C         equivalent to a loop over parameters requested    
  100 IPAR = IPAR + 1   
      IF (IPAR .GT. NU)  GO TO 900  
      IF (NIOFEX(IPAR) .LE. 0)  GO TO 100   
C         set up range for parameter IPAR   
  200 CONTINUE  
      UBEST = U(IPAR)   
      XPT(1) = UBEST    
      YPT(1) = AMIN 
      CHPT(1) = CSYMX   
      NXYPT = 1 
      IF (NVARL(IPAR) .GT. 1)  GO TO 300    
C         no limits on parameter    
      IF (XLREQ .EQ. XHREQ)  GO TO 250  
      UNEXT = XLREQ 
      STEP = (XHREQ-XLREQ)/FLOAT(NCALL-1)   
      GO TO 500 
  250 CONTINUE  
      XL = UBEST - WERR(IPAR)   
      XH = UBEST+  WERR(IPAR)   
      CALL MNBINS(XL,XH,NCALL, UNEXT,UHIGH,NBINS,STEP)  
      NCCALL = NBINS + 1    
      GO TO 500 
C         limits on parameter   
  300 CONTINUE  
      IF (XLREQ .EQ. XHREQ)  GO TO 350  
      XL = MAX(XLREQ,ALIM(IPAR))    
      XH = MIN(XHREQ,BLIM(IPAR))    
      IF (XL .GE. XH)  GO TO 700    
      UNEXT = XL    
      STEP = (XH-XL)/FLOAT(NCALL-1) 
      GO TO 500 
  350 CONTINUE  
      UNEXT = ALIM(IPAR)    
      STEP = (BLIM(IPAR)-ALIM(IPAR))/FLOAT(NCALL-1) 
C         main scanning loop over parameter IPAR    
  500 CONTINUE  
      DO 600 ICALL = 1, NCCALL  
      U(IPAR) = UNEXT   
      NPARX = NPAR  
      CALL FCN(NPARX,GIN,FNEXT,U,4,FUTIL)   
      NFCN = NFCN + 1   
      NXYPT = NXYPT + 1 
      XPT(NXYPT) = UNEXT    
      YPT(NXYPT) = FNEXT    
      CHPT(NXYPT) = CSTAR   
      IF (FNEXT .LT. AMIN)  THEN    
        AMIN = FNEXT    
        UBEST = UNEXT   
        CFROM = 'SCAN    '  
        CSTATU= 'IMPROVED  '    
        ENDIF   
  530 CONTINUE  
      UNEXT = UNEXT + STEP  
  600 CONTINUE  
C         finished with scan of parameter IPAR  
      U(IPAR) = UBEST   
      CALL MNEXIN(X)    
      WRITE (ISYSWR,1001)  NEWPAG,IPAR,CPNAM(IPAR)  
      NUNIT = ISYSWR    
      CALL MNPLOT(XPT,YPT,CHPT,NXYPT,NUNIT,NPAGWD,NPAGLN)   
      GO TO 800 
  700 CONTINUE  
      WRITE (ISYSWR,1000) IPAR  
  800 CONTINUE  
      IF (IPARWD .LE. 0)  GO TO 100 
C         finished with all parameters  
  900 CONTINUE  
      CALL MNPRIN(5,AMIN)   
      RETURN    
 1000 FORMAT (46H REQUESTED RANGE OUTSIDE LIMITS FOR PARAMETER  ,I3/)   
 1001 FORMAT (I1,'SCAN OF PARAMETER NO.',I3,3H,   ,A10) 
      END   
      SUBROUTINE MNSEEK(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC   Performs a rough (but global) minimization by monte carlo search.  
CC        Each time a new minimum is found, the search area is shifted  
CC        to be centered at the best value.  Random points are chosen   
CC        uniformly over a hypercube determined by current step sizes.  
CC   The Metropolis algorithm accepts a worse point with probability    
CC      exp(-d/UP), where d is the degradation.  Improved points    
CC      are of course always accepted.  Actual steps are random 
CC      multiples of the nominal steps (DIRIN). 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      PARAMETER (TWOPI=2.0*3.141593)    
      DIMENSION STEP(MNI), XBEST(MNI), XMID(MNI)    
      MXFAIL = WORD7(1) 
      IF (MXFAIL .LE. 0)  MXFAIL=100+20*NPAR    
      MXSTEP = 10*MXFAIL    
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      ALPHA = WORD7(2)  
      IF (ALPHA .LE. 0.)  ALPHA=3.  
      IF (ISW(5) .GE. 1)  WRITE (ISYSWR, 3) MXFAIL,MXSTEP,ALPHA 
    3 FORMAT (' MNSEEK: MONTE CARLO MINIMIZATION USING METROPOLIS', 
     + ' ALGORITHM'/' TO STOP AFTER',I6,' SUCCESSIVE FAILURES, OR', 
     + I7,' STEPS'/' MAXIMUM STEP SIZE IS',F9.3,' ERROR BARS.') 
      CFROM = 'MNSEEK  '    
      CSTATU= 'INITIAL   '  
      IF (ISW(5) .GE. 2)  CALL MNPRIN(2,AMIN)   
      CSTATU = 'UNCHANGED ' 
      IFAIL = 0 
      RNUM = 0. 
      NPARX = NPAR  
      FLAST = AMIN  
C              set up step sizes, starting values   
      DO 10 IPAR =  1, NPAR 
      IEXT = NEXOFI(IPAR)   
      DIRIN(IPAR) = 2.0*ALPHA*WERR(IEXT)    
      IF (NVARL(IEXT) .GT. 1)  THEN 
C              parameter with limits    
         CALL MNDXDI(X(IPAR),IPAR,DXDI) 
         IF (DXDI .EQ. 0.)  DXDI=1. 
         DIRIN(IPAR) = 2.0*ALPHA*WERR(IEXT)/DXDI    
         IF (ABS(DIRIN(IPAR)).GT.TWOPI)  DIRIN(IPAR)=TWOPI  
         ENDIF  
      XMID(IPAR) = X(IPAR)  
   10 XBEST(IPAR) = X(IPAR) 
C                              search loop  
      DO 500 ISTEP= 1, MXSTEP   
      IF (IFAIL .GE. MXFAIL)  GO TO 600 
        DO 100 IPAR= 1, NPAR    
        CALL MNRN15(RNUM1,ISEED)    
        CALL MNRN15(RNUM2,ISEED)    
  100   X(IPAR) = XMID(IPAR) + 0.5*(RNUM1+RNUM2-1.)*DIRIN(IPAR) 
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN,FTRY,U,4,FUTIL)    
      NFCN = NFCN + 1   
      IF (FTRY .LT. FLAST)  THEN    
         IF (FTRY .LT. AMIN)  THEN  
            CSTATU = 'IMPROVEMNT'   
            AMIN = FTRY 
            DO 200 IB= 1, NPAR  
  200       XBEST(IB) = X(IB)   
            IFAIL = 0   
            IF (ISW(5) .GE. 2) CALL MNPRIN(2,AMIN)  
            ENDIF   
         GO TO 300  
      ELSE  
         IFAIL = IFAIL + 1  
C                   Metropolis algorithm    
         BAR = EXP((AMIN-FTRY)/UP)  
         CALL MNRN15(RNUM,ISEED)    
         IF (BAR .LT. RNUM)  GO TO 500  
      ENDIF 
C                    Accept new point, move there   
  300 CONTINUE  
      DO 350 J= 1, NPAR 
      XMID(J) = X(J)    
  350 CONTINUE  
      FLAST = FTRY  
  500 CONTINUE  
C                               end search loop 
  600 CONTINUE  
      IF (ISW(5).GT.1 .OR. LREPOR) WRITE (ISYSWR,601) IFAIL 
  601 FORMAT(' MNSEEK:',I5,' SUCCESSIVE UNSUCCESSFUL TRIALS.')  
      DO 700 IB= 1, NPAR    
  700 X(IB) = XBEST(IB) 
      CALL MNINEX(X)    
      IF (ISW(5) .GE. 1)  CALL MNPRIN(2,AMIN)   
      IF (ISW(5) .EQ. 0)  CALL MNPRIN(0,AMIN)   
      RETURN    
      END   
      SUBROUTINE MNSET(FCN,FUTIL)   
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Called from MNEXCM    
CC        Interprets the commands that start with SET and SHOW  
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
C   
      EXTERNAL FCN,FUTIL    
C        file characteristics for SET INPUT 
      LOGICAL LOPEN 
      CHARACTER*1 CANSWR    
      CHARACTER CFNAME*64, CMODE*16 
C       'SET ' or 'SHOW',  'ON ' or 'OFF', 'SUPPRESSED' or 'REPORTED  ' 
      CHARACTER CKIND*4,    COPT*3,         CWARN*10    
C        explanation of print level numbers -1:3  and strategies 0:2    
      CHARACTER CPRLEV(-1:3)*34 ,CSTRAT(0:2)*44 
C        identification of debug options    
      PARAMETER (NUMDBG = 5)    
      CHARACTER*40 CDBOPT(0:NUMDBG) 
C        things that can be set or shown    
      CHARACTER*10 CNAME(30)    
      DATA CNAME( 1)/'FCN value '/  
      DATA CNAME( 2)/'PARameters'/  
      DATA CNAME( 3)/'LIMits    '/  
      DATA CNAME( 4)/'COVariance'/  
      DATA CNAME( 5)/'CORrelatio'/  
      DATA CNAME( 6)/'PRInt levl'/  
      DATA CNAME( 7)/'NOGradient'/  
      DATA CNAME( 8)/'GRAdient  '/  
      DATA CNAME( 9)/'ERRor def '/  
      DATA CNAME(10)/'INPut file'/  
      DATA CNAME(11)/'WIDth page'/  
      DATA CNAME(12)/'LINes page'/  
      DATA CNAME(13)/'NOWarnings'/  
      DATA CNAME(14)/'WARnings  '/  
      DATA CNAME(15)/'RANdom gen'/  
      DATA CNAME(16)/'TITle     '/  
      DATA CNAME(17)/'STRategy  '/  
      DATA CNAME(18)/'EIGenvalue'/  
      DATA CNAME(19)/'PAGe throw'/  
      DATA CNAME(20)/'MINos errs'/  
      DATA CNAME(21)/'EPSmachine'/  
      DATA CNAME(22)/'OUTputfile'/  
      DATA CNAME(23)/'BATch     '/  
      DATA CNAME(24)/'INTeractiv'/  
          DATA NNAME/24/    
C        options not intended for normal users  
      DATA CNAME(25)/'reserve   '/  
      DATA CNAME(26)/'reserve   '/  
      DATA CNAME(27)/'NODebug   '/  
      DATA CNAME(28)/'DEBug     '/  
      DATA CNAME(29)/'SHOw      '/  
      DATA CNAME(30)/'SET       '/  
          DATA NNTOT/30/    
C   
      DATA CPRLEV(-1)/'-1: NO OUTPUT EXCEPT FROM "SHOW"  '/ 
      DATA CPRLEV( 0)/' 0: REDUCED OUTPUT                '/ 
      DATA CPRLEV( 1)/' 1: NORMAL OUTPUT                 '/ 
      DATA CPRLEV( 2)/' 2: EXTRA OUTPUT FOR PROBLEM CASES'/ 
      DATA CPRLEV( 3)/' 3: MAXIMUM OUTPUT                '/ 
C   
      DATA CSTRAT( 0)/' 0: MINIMIZE THE NUMBER OF CALLS TO FUNCTION'/   
      DATA CSTRAT( 1)/' 1: TRY TO BALANCE SPEED AGAINST RELIABILITY'/   
      DATA CSTRAT( 2)/' 2: MAKE SURE MINIMUM TRUE, ERRORS CORRECT  '/   
C   
      DATA CDBOPT(0)/'REPORT ALL EXCEPTIONAL CONDITIONS      '/ 
      DATA CDBOPT(1)/'MNLINE: LINE SEARCH MINIMIZATION       '/ 
      DATA CDBOPT(2)/'MNDERI: FIRST DERIVATIVE CALCULATIONS  '/ 
      DATA CDBOPT(3)/'MNHESS: SECOND DERIVATIVE CALCULATIONS '/ 
      DATA CDBOPT(4)/'MNMIGR: COVARIANCE MATRIX UPDATES      '/ 
      DATA CDBOPT(5)/'MNHES1: FIRST DERIVATIVE UNCERTAINTIES '/ 
C   
C   
      DO 2 I= 1, NNTOT  
      IF (INDEX(CWORD(4:10),CNAME(I)(1:3)) .GT. 0)  GO TO 5 
    2 CONTINUE  
      I = 0 
    5 KNAME = I 
C   
C           Command could be SET xxx, SHOW xxx,  HELP SET or HELP SHOW  
      IF (INDEX(CWORD(1:4),'HEL') .GT. 0)  GO TO 2000   
      IF (INDEX(CWORD(1:4),'SHO') .GT. 0)  GO TO 1000   
      IF (INDEX(CWORD(1:4),'SET') .EQ. 0)  GO TO 1900   
C                           --- 
      CKIND = 'SET '    
C                                        . . . . . . . . . . set unknown    
      IF (KNAME .LE. 0)  GO TO 1900 
C                                        . . . . . . . . . . set known  
      GO TO(3000,  20,  30,  40,3000,  60,  70,  80,  90, 100,  
     +       110, 120, 130, 140, 150, 160, 170,3000, 190,3000,  
     +       210, 220, 230, 240,1900,1900, 270, 280, 290, 300) , KNAME  
C   
C                                        . . . . . . . . . . set param  
   20 CONTINUE  
      IPRM = WORD7(1)   
      IF (IPRM .GT. NU)  GO TO 25   
      IF (IPRM .LE. 0)   GO TO 25   
      IF (NVARL(IPRM) .LT. 0)  GO TO 25 
      CFROM = 'SET PARM'    
      CSTATU = 'NEW VALUES' 
      U(IPRM) = WORD7(2)    
      CALL MNEXIN(X)    
      CALL MNRSET(1)    
      GO TO 4000    
   25 WRITE (ISYSWR,'(A/)') ' ILLEGAL PARAMETER NUMBER.  IGNORED.'  
      GO TO 4000    
C                                        . . . . . . . . . . set limits 
   30 CALL MNLIMS(FCN,FUTIL)    
      GO TO 4000    
C                                        . . . . . . . . . . set covar  
   40 CONTINUE  
C   this command must be handled by MNREAD, and is not Fortran-callable 
      GO TO 3000    
C                                        . . . . . . . . . . set print  
   60 ISW(5) = WORD7(1) 
      GO TO 4000    
C                                        . . . . . . . . . . set nograd 
   70 ISW(3) = 0    
      GO TO 4000    
C                                        . . . . . . . . . . set grad   
   80 CALL MNGRAD(FCN,FUTIL)    
      GO TO 4000    
C                                        . . . . . . . . . . set errdef 
   90 UP = WORD7(1) 
      IF (UP .LE. 0.)  UP = 1.0 
      CALL MNRSET(0)    
      GO TO 4000    
C                                        . . . . . . . . . . set input  
C This command must be handled by MNREAD. If it gets this far,  
C         it is illegal.    
  100 CONTINUE  
      GO TO 3000    
C                                        . . . . . . . . . . set width  
  110 NPAGWD = WORD7(1) 
      GO TO 4000    
C                                        . . . . . . . . . . set lines  
  120 NPAGLN = WORD7(1) 
      GO TO 4000    
C                                        . . . . . . . . . . set nowarn 
  130 LWARN = .FALSE.   
      GO TO 4000    
C                                        . . . . . . . . . . set warn   
  140 LWARN = .TRUE.    
      GO TO 4000    
C                                        . . . . . . . . . . set random 
  150 JSEED = INT(WORD7(1)) 
      VAL = 3.  
      CALL MNRN15(VAL, JSEED)   
      IF (ISW(5) .GT. 0) WRITE (ISYSWR, 151) JSEED  
  151 FORMAT (' MINUIT RANDOM NUMBER SEED SET TO ',I10) 
      GO TO 4000    
C                                        . . . . . . . . . . set title  
  160 CONTINUE  
C   this command must be handled by MNREAD, and is not Fortran-callable 
      GO TO 3000    
C                                        . . . . . . . . . set strategy 
  170 ISTRAT = WORD7(1) 
      ISTRAT = MAX(ISTRAT,0)    
      ISTRAT = MIN(ISTRAT,2)    
      IF (ISW(5) .GT. 0)  GO TO 1172    
      GO TO 4000    
C                                       . . . . . . . . . set page throw    
  190 NEWPAG = WORD7(1) 
      GO TO 1190    
C                                        . . . . . . . . . . set epsmac 
  210 IF (WORD7(1).GT.0. .AND. WORD7(1).LT.0.1) EPSMAC = WORD7(1)   
      GO TO 1210    
C                                        . . . . . . . . . . set outputfile 
  220 CONTINUE  
      IUNIT = WORD7(1)  
      ISYSWR = IUNIT    
      ISTKWR(1) = IUNIT 
      IF (ISW(5) .GE. 0) GO TO 1220 
      GO TO 4000    
C                                        . . . . . . . . . . set batch  
  230 ISW(6) = 0    
      IF (ISW(5) .GE. 0)  GO TO 1100    
      GO TO 4000    
C                                        . . . . . . . . . . set interactive    
  240 ISW(6) = 1    
      IF (ISW(5) .GE. 0)  GO TO 1100    
      GO TO 4000    
C                                        . . . . . . . . . . set nodebug    
  270 ISET = 0  
      GO TO 281 
C                                        . . . . . . . . . . set debug  
  280 ISET = 1  
  281 CONTINUE  
      IDBOPT = WORD7(1) 
      IF (IDBOPT .GT. NUMDBG) GO TO 288 
      IF (IDBOPT .GE. 0) THEN   
          IDBG(IDBOPT) = ISET   
          IF (ISET .EQ. 1)  IDBG(0) = 1 
      ELSE  
C             SET DEBUG -1  sets all debug options  
          DO 285 ID= 0, NUMDBG  
  285     IDBG(ID) = ISET   
      ENDIF 
      LREPOR = (IDBG(0) .GE. 1) 
      GO TO 4000    
  288 WRITE (ISYSWR,289) IDBOPT 
  289 FORMAT (' UNKNOWN DEBUG OPTION',I6,' REQUESTED. IGNORED') 
      GO TO 4000    
C                                        . . . . . . . . . . set show   
  290 CONTINUE  
C                                        . . . . . . . . . . set set    
  300 CONTINUE  
      GO TO 3000    
C                -----------------------------------------------------  
 1000 CONTINUE  
C               at this point, CWORD must be 'SHOW' 
      CKIND = 'SHOW'    
      IF (KNAME .LE. 0)  GO TO 1900 
      GO TO (1010,1020,1030,1040,1050,1060,1070,1070,1090,1100, 
     +       1110,1120,1130,1130,1150,1160,1170,1180,1190,1200, 
     +       1210,1220,1100,1100,1900,1900,1270,1270,1290,1300),KNAME   
C   
C                                        . . . . . . . . . . show fcn   
 1010 CONTINUE  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      CALL MNPRIN (0,AMIN)  
      GO TO 4000    
C                                        . . . . . . . . . . show param 
 1020 CONTINUE  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      CALL MNPRIN (5,AMIN)  
      GO TO 4000    
C                                        . . . . . . . . . . show limits    
 1030 CONTINUE  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      CALL MNPRIN (1,AMIN)  
      GO TO 4000    
C                                        . . . . . . . . . . show covar 
 1040 CALL MNMATU(1)    
      GO TO 4000    
C                                        . . . . . . . . . . show corre 
 1050 CALL MNMATU(0)    
      GO TO 4000    
C                                        . . . . . . . . . . show print 
 1060 CONTINUE  
      IF (ISW(5) .LT.-1)  ISW(5) = -1   
      IF (ISW(5) .GT. 3)  ISW(5) = 3    
      WRITE (ISYSWR,'(A)') ' ALLOWED PRINT LEVELS ARE:' 
      WRITE (ISYSWR,'(27X,34A1)') CPRLEV   
C     WRITE (ISYSWR,1061)  CPRLEV(ISW(5))   
C1061 FORMAT (/' CURRENT PRINTOUT LEVEL IS ',34A1) 
      GO TO 4000    
C                                        . . . . . . . show nograd, grad    
 1070 CONTINUE  
      IF (ISW(3) .LE. 0) THEN   
         WRITE (ISYSWR, 1081)   
 1081    FORMAT(' NOGRAD IS SET.  DERIVATIVES NOT COMPUTED IN FCN.')    
      ELSE  
         WRITE (ISYSWR, 1082)   
 1082    FORMAT('   GRAD IS SET.  USER COMPUTES DERIVATIVES IN FCN.')   
      ENDIF 
      GO TO 4000    
C                                        . . . . . . . . . . show errdef    
 1090 WRITE (ISYSWR, 1091)  UP  
 1091 FORMAT (' ERRORS CORRESPOND TO FUNCTION CHANGE OF',G13.5) 
      GO TO 4000    
C                                        . . . . . . . . . . show input,    
C                                                    batch, or interactive  
 1100 CONTINUE  
      INQUIRE(UNIT=ISYSRD,OPENED=LOPEN,NAME=CFNAME) 
      IF (LREPOR .AND..NOT.LOPEN) WRITE (ISYSWR,1101) ISYSRD    
 1101 FORMAT (/' MINUIT EXCEPTIONAL CONDITION: ',   
     +  'INPUT UNIT NO.',I3,' IS NOT OPENED.')  
      CMODE = 'BATCH MODE      '    
      IF (ISW(6) .EQ. 1)  CMODE = 'INTERACTIVE MODE'    
      WRITE (ISYSWR,1002) CMODE,ISYSRD,CFNAME   
 1002 FORMAT (' INPUT NOW BEING READ IN ',A,' FROM UNIT NO.',I3/    
     + ' FILENAME: ',A) 
      GO TO 4000    
C                                        . . . . . . . . . . show width 
 1110 WRITE (ISYSWR,1111) NPAGWD    
 1111 FORMAT (10X,'PAGE WIDTH IS SET TO',I4,' COLUMNS') 
      GO TO 4000    
C                                        . . . . . . . . . . show lines 
 1120 WRITE (ISYSWR,1121) NPAGLN    
 1121 FORMAT (10X,'PAGE LENGTH IS SET TO',I4,' LINES')  
      GO TO 4000    
C                                        . . . . . . .show nowarn, warn 
 1130 CONTINUE  
                 CWARN = 'SUPPRESSED'   
      IF (LWARN) CWARN = 'REPORTED  '   
      WRITE (ISYSWR,1141) CWARN 
 1141 FORMAT (' MINUIT WARNING MESSAGES ARE ',A)    
      GO TO 4000    
C                                        . . . . . . . . . . show random    
 1150 VAL = 0.  
      CALL MNRN15(VAL,IGRAIN)   
      IKSEED = IGRAIN   
      WRITE (ISYSWR, 1151)  IKSEED  
 1151 FORMAT (' MINUIT RNDM SEED IS CURRENTLY=',I10/)   
      VAL = 3.0 
      ISEED = IKSEED    
      CALL MNRN15(VAL,ISEED)    
      GO TO 4000    
C                                        . . . . . . . . . show title   
 1160 WRITE (ISYSWR,'(A,A)') ' TITLE OF CURRENT TASK IS:',CTITL 
      GO TO 4000    
C                                        . . . . . . . show strategy    
 1170 WRITE (ISYSWR, '(A)') ' ALLOWED STRATEGIES ARE:'  
      WRITE (ISYSWR, '(20X,A)') CSTRAT  
 1172 WRITE (ISYSWR, 1175) CSTRAT(ISTRAT)   
 1175 FORMAT (/' NOW USING STRATEGY ',A/)   
      GO TO 4000    
C                                          . . . . . show eigenvalues   
 1180 CONTINUE  
      ISWSAV = ISW(5)   
      ISW(5) = 3    
      IF (ISW(2) .LT. 3)  THEN  
         CALL  MNHESS(FCN,FUTIL)    
      ELSE  
         CALL MNPSDF    
      ENDIF 
      ISW(5) = ISWSAV   
      GO TO 4000    
C                                            . . . . . show page throw  
 1190 WRITE (ISYSWR,'(A,I3)') ' PAGE THROW CARRIAGE CONTROL =',NEWPAG   
      IF (NEWPAG .EQ. 0)    
     +    WRITE (ISYSWR,'(A)') ' NO PAGE THROWS IN MINUIT OUTPUT'   
      GO TO 4000    
C                                        . . . . . . show minos errors  
 1200 CONTINUE  
      DO 1202 II= 1, NPAR   
      IX = NEXOFI(II)   
      IF (ERP(IX).GT.0. .OR. ERN(IX).LT.0.)  GO TO 1204 
 1202 CONTINUE  
      WRITE (ISYSWR,'(A)') '     NO MINOS ERRORS HAVE BEEN CALCULATED.' 
      GO TO 4000    
 1204 CONTINUE  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      CALL MNPRIN(4,AMIN)   
      GO TO 4000    
C                                        . . . . . . . . . show epsmac  
 1210 WRITE (ISYSWR,'(A,E12.3)')    
     +  ' FLOATING-POINT NUMBERS ASSUMED ACCURATE TO',EPSMAC    
      GO TO 4000    
C                                        . . . . . . show outputfiles   
 1220 CONTINUE  
      WRITE (ISYSWR,'(A,I4)') '  MINUIT PRIMARY OUTPUT TO UNIT',ISYSWR  
      GO TO 4000    
C                                        . . . . . . show nodebug, debug    
 1270 CONTINUE  
      DO 1285 ID= 0, NUMDBG 
      COPT = 'OFF'  
      IF (IDBG(ID) .GE. 1)  COPT = 'ON '    
 1285 WRITE (ISYSWR,1286) ID, COPT, CDBOPT(ID)  
 1286 FORMAT (10X,'DEBUG OPTION',I3,' IS ',A3,' :',A)   
      GO TO 4000    
C                                        . . . . . . . . . . show show  
 1290 CKIND = 'SHOW'    
      GO TO 2100    
C                                        . . . . . . . . . . show set   
 1300 CKIND = 'SET '    
      GO TO 2100    
    
C                -----------------------------------------------------  
C                              UNKNOWN COMMAND  
 1900 WRITE (ISYSWR, 1901) CWORD    
 1901 FORMAT (' THE COMMAND:',A10,' IS UNKNOWN.'/)  
      GO TO 2100    
C                -----------------------------------------------------  
C                    HELP SHOW,  HELP SET,  SHOW SET, or SHOW SHOW  
 2000 CKIND = 'SET '    
      IF (INDEX(CWORD(4:10),'SHO') .GT. 0)  CKIND = 'SHOW'  
 2100 WRITE (ISYSWR, 2101)  CKIND,CKIND, (CNAME(KK),KK=1,NNAME) 
 2101 FORMAT (' THE FORMAT OF THE ',A4,' COMMAND IS:'// 
     +   1X,A4,' xxx    [numerical arguments if any]'// 
     +   ' WHERE xxx MAY BE ONE OF THE FOLLOWING:'/ 
     +   (7X,6A12)) 
      GO TO 4000    
C                -----------------------------------------------------  
C                               ILLEGAL COMMAND 
 3000 WRITE (ISYSWR,'('' ABOVE COMMAND IS ILLEGAL.   IGNORED'')')   
 4000 RETURN    
      END   
      SUBROUTINE MNSETI(TIT)    
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       Called by user to set or change title of current task. 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      CHARACTER*(*) TIT 
      CTITL = TIT   
      RETURN    
      END   
      SUBROUTINE MNSIMP(FCN,FUTIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        Performs a minimization using the simplex method of Nelder    
CC        and Mead (ref. -- Comp. J. 7,308 (1965)). 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      EXTERNAL FCN,FUTIL    
      DIMENSION Y(MNI1)    
      DATA ALPHA,BETA,GAMMA,RHOMIN,RHOMAX / 1.0, 0.5, 2.0, 4.0, 8.0/    
      IF (NPAR .LE. 0)  RETURN  
      IF (AMIN .EQ. UNDEFI)  CALL MNAMIN(FCN,FUTIL) 
      CFROM = 'SIMPLEX '    
      CSTATU= 'UNCHANGED '  
      NPFN=NFCN 
      NPARP1=NPAR+1 
      NPARX = NPAR  
      RHO1 = 1.0 + ALPHA    
      RHO2 = RHO1 + ALPHA*GAMMA 
      WG = 1.0/FLOAT(NPAR)  
      IF (ISW(5) .GE. 0) WRITE(ISYSWR,100) EPSI 
  100 FORMAT(' START SIMPLEX MINIMIZATION.    CONVERGENCE WHEN EDM .LT.'    
     +,E10.2 )  
      DO 2 I= 1, NPAR   
      IF (ISW(2) .GE. 1)  DIRIN(I) = SQRT(V(I,I)*UP)    
      IF (ABS(DIRIN(I)) .LT. 1.0E-10*ABS(X(I))) DIRIN(I)=1.0E-8*X(I)    
      IF(ITAUR.LT. 1)  V(I,I) =    DIRIN(I)**2/UP   
    2 CONTINUE  
      IF (ITAUR .LT. 1)  ISW(2) = 1 
C**       choose the initial simplex using single-parameter searches    
    1 CONTINUE  
      YNPP1 = AMIN  
      JL = NPARP1   
      Y(NPARP1) = AMIN  
      ABSMIN = AMIN 
      DO 10 I= 1, NPAR  
      AMING = AMIN  
      PBAR(I) = X(I)    
      BESTX = X(I)  
      KG = 0    
      NS = 0    
      NF = 0    
    4 X(I) = BESTX + DIRIN(I)   
      CALL MNINEX(X)    
      CALL FCN(NPARX,GIN, F, U, 4, FUTIL)   
      NFCN = NFCN + 1   
      IF (F .LE. AMING)  GO TO 6    
C         failure   
      IF (KG .EQ. 1)  GO TO 8   
      KG = -1   
      NF = NF + 1   
      DIRIN(I) = DIRIN(I) * (-0.4)  
      IF (NF .LT. 3)  GO TO 4   
      NS = 6    
C         success   
    6 BESTX = X(I)  
      DIRIN(I) = DIRIN(I) * 3.0 
      AMING = F 
      CSTATU= 'PROGRESS  '  
      KG = 1    
      NS = NS + 1   
      IF (NS .LT. 6)  GO TO 4   
C         local minimum found in ith direction  
    8 Y(I) = AMING  
      IF (AMING .LT. ABSMIN)  JL = I    
      IF (AMING .LT. ABSMIN)  ABSMIN = AMING    
      X(I) = BESTX  
      DO 9 K= 1, NPAR   
    9 P(K,I) = X(K) 
   10 CONTINUE  
      JH = NPARP1   
      AMIN=Y(JL)    
      CALL MNRAZZ(YNPP1,PBAR,Y,JH,JL)   
      DO 20 I= 1, NPAR  
   20 X(I) = P(I,JL)    
      CALL MNINEX(X)    
      CSTATU = 'PROGRESS  ' 
      IF (ISW(5) .GE. 1)  CALL MNPRIN(5,AMIN)   
      EDM = EDM * 10.   
      SIG2 = EDM    
      NCYCL=0   
C                                        . . . . .  start main loop 
   50 CONTINUE  
      IF (SIG2 .LT. EPSI .AND. EDM.LT.EPSI)     GO TO 76    
      SIG2 = EDM    
      IF ((NFCN-NPFN) .GT. NFCNMX)  GO TO 78    
C         calculate new point * by reflection   
      DO 60 I= 1, NPAR  
      PB = 0.   
      DO 59 J= 1, NPARP1    
   59 PB = PB + WG * P(I,J) 
      PBAR(I) = PB - WG * P(I,JH)   
   60 PSTAR(I)=(1.+ALPHA)*PBAR(I)-ALPHA*P(I,JH) 
      CALL MNINEX(PSTAR)    
      CALL FCN(NPARX,GIN,YSTAR,U,4,FUTIL)   
      NFCN=NFCN+1   
      IF(YSTAR.GE.AMIN) GO TO 70    
C         point * better than jl, calculate new point **    
      DO 61 I=1,NPAR    
   61 PSTST(I)=GAMMA*PSTAR(I)+(1.-GAMMA)*PBAR(I)    
      CALL MNINEX(PSTST)    
      CALL FCN(NPARX,GIN,YSTST,U,4,FUTIL)   
      NFCN=NFCN+1   
C         try a parabola through ph, pstar, pstst.  min = prho  
      Y1 = (YSTAR-Y(JH)) * RHO2 
      Y2 = (YSTST-Y(JH)) * RHO1 
      RHO = 0.5 * (RHO2*Y1 -RHO1*Y2) / (Y1 -Y2) 
      IF (RHO .LT. RHOMIN)  GO TO 66    
      IF (RHO .GT. RHOMAX)  RHO = RHOMAX    
      DO 64 I= 1, NPAR  
   64 PRHO(I) = RHO*PBAR(I) + (1.0-RHO)*P(I,JH) 
      CALL MNINEX(PRHO) 
      CALL FCN(NPARX,GIN,YRHO, U,4,FUTIL)   
      NFCN = NFCN + 1   
      IF (YRHO .LT. Y(JL) .AND. YRHO .LT. YSTST)  GO TO 65  
      IF (YSTST .LT. Y(JL))  GO TO 67   
      IF (YRHO .GT. Y(JL))  GO TO 66    
C         accept minimum point of parabola, PRHO    
   65 CALL MNRAZZ (YRHO,PRHO,Y,JH,JL)   
      GO TO 68  
   66 IF (YSTST .LT. Y(JL))  GO TO 67   
      CALL MNRAZZ(YSTAR,PSTAR,Y,JH,JL)  
      GO TO 68  
   67 CALL MNRAZZ(YSTST,PSTST,Y,JH,JL)  
   68 NCYCL=NCYCL+1 
      IF (ISW(5) .LT. 2)  GO TO 50  
      IF (ISW(5) .GE. 3 .OR. MOD(NCYCL, 10) .EQ. 0) CALL MNPRIN(5,AMIN) 
      GO TO 50  
C         point * is not as good as jl  
   70 IF (YSTAR .GE. Y(JH))  GO TO 73   
      JHOLD = JH    
      CALL MNRAZZ(YSTAR,PSTAR,Y,JH,JL)  
      IF (JHOLD .NE. JH)  GO TO 50  
C         calculate new point **    
   73 DO 74 I=1,NPAR    
   74 PSTST(I)=BETA*P(I,JH)+(1.-BETA)*PBAR(I)   
      CALL MNINEX (PSTST)   
      CALL FCN(NPARX,GIN,YSTST,U,4,FUTIL)   
      NFCN=NFCN+1   
      IF(YSTST.GT.Y(JH)) GO TO 1    
C     point ** is better than jh    
      IF (YSTST .LT. AMIN)  GO TO 67    
      CALL MNRAZZ(YSTST,PSTST,Y,JH,JL)  
      GO TO 50  
C                                        . . . . . .  end main loop 
   76 IF (ISW(5) .GE. 0)  WRITE(ISYSWR,'(A)')   
     +                    ' SIMPLEX MINIMIZATION HAS CONVERGED.'    
      GO TO 80  
   78 IF (ISW(5) .GE. 0)  WRITE(ISYSWR,'(A)')   
     +                    ' SIMPLEX TERMINATES WITHOUT CONVERGENCE.'    
      CSTATU= 'CALL LIMIT'  
      ISW(1) = 1    
   80 DO 82 I=1,NPAR    
      PB = 0.   
      DO 81 J=1,NPARP1  
   81 PB = PB + WG * P(I,J) 
   82 PBAR(I) = PB - WG * P(I,JH)   
      CALL MNINEX(PBAR) 
      CALL FCN(NPARX,GIN,YPBAR,U,4,FUTIL)   
      NFCN=NFCN+1   
      IF (YPBAR .LT. AMIN)  CALL MNRAZZ(YPBAR,PBAR,Y,JH,JL) 
      CALL MNINEX(X)    
      IF (NFCNMX+NPFN-NFCN .LT. 3*NPAR)  GO TO 90   
      IF (EDM .GT. 2.0*EPSI)  GO TO 1   
   90 IF (ISW(5) .GE. 0)  CALL MNPRIN(5, AMIN)  
      RETURN    
      END   
      SUBROUTINE MNSTAT(FMIN,FEDM,ERRDEF,NPARI,NPARX,ISTAT) 
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC       User-called    
CC       Provides the user with information concerning the current status   
CC          of the current minimization. Namely, it returns:    
CC        FMIN: the best function value found so far    
CC        FEDM: the estimated vertical distance remaining to minimum    
CC        ERRDEF: the value of UP defining parameter uncertainties  
CC        NPARI: the number of currently variable parameters    
CC        NPARX: the highest (external) parameter number defined by user    
CC        ISTAT: a status integer indicating how good is the covariance 
CC           matrix:  0= not calculated at all  
CC                    1= diagonal approximation only, not accurate  
CC                    2= full matrix, but forced positive-definite  
CC                    3= full accurate covariance matrix (after MIGRAD, 
CC                         this is the indication of normal convergence.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      FMIN = AMIN   
      FEDM = EDM    
      IF (AMIN .EQ. UNDEFI) FMIN = FEDM 
      ERRDEF = UP   
      NPARI = NPAR  
      NPARX = NU    
      ISTAT = ISW(2)    
      RETURN    
      END   
      SUBROUTINE MNSTIN(CRDBUF,IERR)    
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC Called from MNREAD.  
CC Implements the SET INPUT command to change input units.  
CC If command is: 'SET INPUT'   'SET INPUT 0'   or  '*EOF', 
CC                 or 'SET INPUT , ,  ',    
CC                reverts to previous input unit number,if any. 
CC  
CC      If it is: 'SET INPUT n'  or  'SET INPUT n filename',    
CC                changes to new input file, added to stack 
CC  
CC      IERR = 0: reading terminated normally   
CC             2: end-of-data on primary input file 
CC             3: unrecoverable read error  
CC             4: unable to process request 
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      CHARACTER CRDBUF*(*),CUNIT*10,CFNAME*64,CGNAME*64,CANSWR*1    
      CHARACTER CMODE*16    
      LOGICAL LOPEN,LREWIN,NONAME   
      NONAME = .TRUE.   
      IERR = 0  
      IF (INDEX(CRDBUF,'*EOF') .EQ. 1) GO TO 190    
      IF (INDEX(CRDBUF,'*eof') .EQ. 1) GO TO 190    
      LEND = LEN(CRDBUF)    
C                               look for end of SET INPUT command   
        DO 20 IC= 8,LEND    
        IF (CRDBUF(IC:IC) .EQ. ' ') GO TO 25    
        IF (CRDBUF(IC:IC) .EQ. ',') GO TO 53    
   20   CONTINUE    
      GO TO 200 
   25 CONTINUE  
C         look for end of separator between command and first argument  
      ICOL = IC+1   
         DO 50 IC= ICOL,LEND    
         IF (CRDBUF(IC:IC) .EQ. ' ') GO TO 50   
         IF (CRDBUF(IC:IC) .EQ. ',') GO TO 53   
         GO TO 55   
   50 CONTINUE  
      GO TO 200 
   53 IC = IC + 1   
   55 IC1 = IC  
C                      see if "REWIND" was requested in command 
      LREWIN = .FALSE.  
      IF (INDEX(CRDBUF(1:IC1),'REW') .GT. 5)  LREWIN=.TRUE. 
      IF (INDEX(CRDBUF(1:IC1),'rew') .GT. 5)  LREWIN=.TRUE. 
C                      first argument begins in or after col IC1    
      DO 75 IC= IC1,LEND    
      IF (CRDBUF(IC:IC) .EQ. ' ') GO TO 75  
      IF (CRDBUF(IC:IC) .EQ. ',') GO TO 200 
      GO TO 80  
   75 CONTINUE  
      GO TO 200 
   80 IC1 = IC  
C                        first argument really begins in col IC1    
      DO 100 IC= IC1+1,LEND 
      IF (CRDBUF(IC:IC) .EQ. ' ') GO TO 108 
      IF (CRDBUF(IC:IC) .EQ. ',') GO TO 108 
  100 CONTINUE  
      IC = LEND + 1 
  108 IC2 = IC-1    
C                            end of first argument is in col IC2    
  110 CONTINUE  
      CUNIT = CRDBUF(IC1:IC2)   
      WRITE (ISYSWR,'(A,A)') ' UNIT NO. :',CUNIT    
      READ (CUNIT,'(BN,F10.0)',ERR=500) FUNIT   
      IUNIT = FUNIT 
      IF (IUNIT .EQ. 0)  GO TO 200  
C                             skip blanks and commas, find file name    
      DO 120 IC= IC2+1,LEND 
      IF (CRDBUF(IC:IC) .EQ. ' ') GO TO 120 
      IF (CRDBUF(IC:IC) .EQ. ',') GO TO 120 
      GO TO 130 
  120 CONTINUE  
      GO TO 131 
  130 CONTINUE  
      CFNAME = CRDBUF(IC:LEND)  
      NONAME = .FALSE.  
      WRITE (ISYSWR, '(A,A)') ' FILE NAME IS:',CFNAME   
C              ask if file exists, if not ask for name and open it  
  131 CONTINUE  
      INQUIRE(UNIT=IUNIT,OPENED=LOPEN,NAME=CGNAME)  
      IF (LOPEN) THEN   
         IF (NONAME) THEN   
             GO TO 136  
         ELSE   
             WRITE (ISYSWR,132) IUNIT,CGNAME,CFNAME 
  132        FORMAT (' UNIT',I3,' ALREADY OPENED WITH NAME:',A/ 
     +                  '                 NEW NAME IGNORED:',A) 
         ENDIF  
      ELSE  
C                new file, open it  
         WRITE (ISYSWR,135) IUNIT   
  135    FORMAT (' UNIT',I3,' IS NOT OPENED.')  
         IF (NONAME) THEN   
            WRITE (ISYSWR,'(A)') ' NO FILE NAME GIVEN IN COMMAND.'  
            IF (ISW(6) .NE. 1)  GO TO 800   
            WRITE (ISYSWR,'(A)') ' PLEASE GIVE FILE NAME:'  
            READ (ISYSRD,'(A)') CFNAME  
         ENDIF  
         OPEN (UNIT=IUNIT,FILE=CFNAME,STATUS='OLD',ERR=600) 
         WRITE (ISYSWR,'(A)') ' FILE OPENED SUCCESSFULLY.'  
      ENDIF 
C                                     . .   file is correctly opened    
  136 IF (LREWIN) GO TO 150 
      IF (ISW(6) .NE. 1)  GO TO 300 
      WRITE (ISYSWR,137)  IUNIT 
  137 FORMAT (' SHOULD UNIT',I3,' BE REWOUND?' )    
      READ  (ISYSRD,'(A)')  CANSWR  
      IF (CANSWR.NE.'Y' .AND. CANSWR.NE.'y') GO TO 300  
  150 REWIND IUNIT  
      GO TO 300 
C                      *EOF 
  190 CONTINUE  
      IF (NSTKRD .EQ. 0)  THEN  
         IERR = 2   
         GO TO 900  
         ENDIF  
C                      revert to previous input file    
  200 CONTINUE  
      IF (NSTKRD .EQ. 0)  THEN  
          WRITE (ISYSWR, '(A,A)') ' COMMAND IGNORED:',CRDBUF    
          WRITE (ISYSWR, '(A)') ' ALREADY READING FROM PRIMARY INPUT'   
      ELSE  
        ISYSRD = ISTKRD(NSTKRD) 
        NSTKRD = NSTKRD - 1 
        IF (NSTKRD .EQ. 0)  ISW(6) = IABS(ISW(6))   
        IF (ISW(5) .GE. 0)  THEN    
          INQUIRE(UNIT=ISYSRD,NAME=CFNAME)  
          CMODE = 'BATCH MODE      '    
          IF (ISW(6) .EQ. 1)  CMODE = 'INTERACTIVE MODE'    
          WRITE (ISYSWR,290) CMODE,ISYSRD,CFNAME    
  290     FORMAT (' INPUT WILL NOW BE READ IN ',A,' FROM UNIT NO.',I3/  
     +    ' FILENAME: ',A)  
        ENDIF   
      ENDIF 
      GO TO 900 
C                      switch to new input file, add to stack   
  300 CONTINUE  
      IF (NSTKRD .GE. MAXSTK)  THEN 
          WRITE (ISYSWR, '(A)') ' INPUT FILE STACK SIZE EXCEEDED.'  
          GO TO 800 
          ENDIF 
      NSTKRD = NSTKRD + 1   
      ISTKRD(NSTKRD) = ISYSRD   
      ISYSRD = IUNIT    
C                   ISW(6) = 0 for batch, =1 for interactive, and   
C                      =-1 for originally interactive temporarily batch 
      IF (ISW(6) .EQ. 1)  ISW(6) = -1   
      GO TO 900 
C                      format error 
  500 CONTINUE  
      WRITE (ISYSWR,'(A,A)') ' CANNOT READ FOLLOWING AS INTEGER:',CUNIT 
      GO TO 800 
  600 CONTINUE  
      WRITE (ISYSWR, 601) CFNAME    
  601 FORMAT (' SYSTEM IS UNABLE TO OPEN FILE:',A)  
C                      serious error    
  800 CONTINUE  
      IERR = 3  
  900 CONTINUE  
      RETURN    
      END   
      SUBROUTINE MNVERT(A,L,M,N,IFAIL)  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        inverts a symmetric matrix.   matrix is first scaled to   
CC        have all ones on the diagonal (equivalent to change of units) 
CC        but no pivoting is done since matrix is positive-definite.    
CC  
      PARAMETER (MNE=100 , MNI=35 , MNI1=MNI+1)  
      COMMON    
     1/MN7NAM/ CPNAM(MNE)   
     2/MN7EXT/ U(MNE)     ,WERR(MNE)  ,ALIM(MNE)  ,BLIM(MNE)    
     3/MN7ERR/ ERP(MNE)   ,ERN(MNE) 
     4/MN7INX/ NVARL(MNE) ,NIOFEX(MNE),NEXOFI(MNI)  
     5/MN7INT/ X(MNI)     ,XT(MNI)    ,DIRIN(MNI)   
     6/MN7FX2/ XS(MNI)    ,XTS(MNI)   ,DIRINS(MNI)  
     7/MN7DER/ GRD(MNI)   ,G2(MNI)    ,GSTEP(MNI) ,GIN(MNE) ,DGRD(MNI)  
     8/MN7FX3/ GRDS(MNI)  ,G2S(MNI)   ,GSTEPS(MNI)  
     9/MN7FX1/ IPFIX(MNI) ,NPFIX    
     A/MN7VAR/ V(MNI,MNI)   
     B/MN7VAT/ VT(MNI,MNI)  
     C/MN7SIM/ P(MNI,MNI1),PSTAR(MNI),PSTST(MNI) ,PBAR(MNI),PRHO(MNI)  
      CHARACTER*10 CPNAM    
C   
      PARAMETER (MAXDBG=10, MAXSTK=10)  
      COMMON    
     D/MN7NPR/ MAXINT  ,NPAR    ,MAXEXT ,NU 
     E/MN7IOU/ ISYSRD  ,ISYSWR  ,ISYSSA ,NPAGWD ,NPAGLN ,NEWPAG 
     E/MN7IO2/ ISTKRD(MAXSTK)   ,NSTKRD ,ISTKWR(MAXSTK) ,NSTKWR 
     F/MN7TIT/ CFROM   ,CSTATU  ,CTITL  ,CWORD  ,CUNDEF ,CVRSN  
     G/MN7FLG/ ISW(7)  ,IDBG(0:MAXDBG)  ,NBLOCK ,ICOMND 
     H/MN7MIN/ AMIN    ,UP      ,EDM    ,FVAL3  ,EPSI   ,APSI   
     I/MN7CNV/ NFCN    ,NFCNMX  ,ITAUR  ,ISTRAT 
     J/MN7ARG/ WORD7(7) 
     K/MN7LOG/ LWARN   ,LREPOR  ,LIMSET ,LNOLIM ,LNEWMN 
     L/MN7CNS/ EPSMAC  ,VLIMLO  ,VLIMHI ,UNDEFI 
      CHARACTER CTITL*50,CWORD*10,CUNDEF*10,CFROM*8,CSTATU*10,CVRSN*6   
      LOGICAL LWARN,LREPOR,LIMSET,LNOLIM,LNEWMN 
      DIMENSION A(L,M) ,PP(MNI), Q(MNI),  S(MNI)    
      IFAIL=0   
      IF (N .LT. 1)  GO TO 100  
      IF (N .GT. MAXINT)  GO TO 100 
C                   scale matrix by sqrt of diag elements   
      DO 8  I=1,N   
      SI = A(I,I)   
      IF (SI) 100,100,8 
    8 S(I) = 1.0/SQRT(SI)   
      DO 20 I= 1, N 
      DO 20 J= 1, N 
   20 A(I,J) = A(I,J) *S(I)*S(J)    
C                                        . . . start main loop . . . .  
      DO 65 I=1,N   
      K = I 
C                   preparation for elimination step1   
      Q(K)=1./A(K,K)    
      PP(K) = 1.0   
      A(K,K)=0.0    
      KP1=K+1   
      KM1=K-1   
      IF(KM1)100,50,40  
   40 DO 49 J=1,KM1 
      PP(J)=A(J,K)  
      Q(J)=A(J,K)*Q(K)  
   49 A(J,K)=0. 
   50 IF(K-N)51,60,100  
   51 DO 59 J=KP1,N 
      PP(J)=A(K,J)  
      Q(J)=-A(K,J)*Q(K) 
   59 A(K,J)=0.0    
C                   elimination proper  
   60 DO 65 J=1,N   
      DO 65 K=J,N   
   65 A(J,K)=A(J,K)+PP(J)*Q(K)  
C                   elements of left diagonal and unscaling 
      DO 70 J= 1, N 
      DO 70 K= 1, J 
      A(K,J) = A(K,J) *S(K)*S(J)    
   70 A(J,K) = A(K,J)   
      RETURN    
C                   failure return  
  100 IFAIL=1   
      RETURN    
      END   
      SUBROUTINE STAND  
C ************ DOUBLE PRECISION VERSION *************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
CC        optional user-supplied subroutine is called whenever the  
CC        command "standard" appears.   
CC  
      RETURN    
      END   
